SystemOrganization addCategory: #Athens!
SystemOrganization addCategory: #'Athens-Core'!
SystemOrganization addCategory: #'Athens-Demo'!
SystemOrganization addCategory: #'Athens-PluginCanvas'!
SystemOrganization addCategory: #'Athens-CTransformCanvas'!
SystemOrganization addCategory: #'Athens-Transformations'!
SystemOrganization addCategory: #'Athens-BallonCanvas'!
SystemOrganization addCategory: #'Athens-Reference'!
SystemOrganization addCategory: #'Athens-Tweak'!

!ByteString methodsFor: '*Athens-PluginCanvas' stamp: 'mir 1/6/2007 22:20'!
asUTF8String

	| converter utf8String |
	converter := UTF8TextConverter new.
	utf8String := String streamContents: [:stream | 
		1 to: self size do: [:i | 
			converter nextPut: (self at: i) toStream: stream].
		stream nextPut: (Character value: 0)].
	^utf8String! !

!SolidFillStyle methodsFor: '*Athens' stamp: 'jl 6/7/2006 12:28'!
asRomeFill
	^self asColor! !

!SolidFillStyle methodsFor: '*Athens' stamp: 'jl 8/17/2006 16:59'!
installOnRomePluginCanvas: aCanvas
	^aCanvas selectFill: color! !

!SolidFillStyle methodsFor: '*Athens' stamp: 'cyrille.delaunay 5/7/2010 10:31'!
style
	^#solid! !

!String methodsFor: '*Athens-PluginCanvas' stamp: 'mir 1/6/2007 14:49'!
asUTF8String
	self subclassResponsibility! !

!BitmapFillStyle methodsFor: '*Athens' stamp: 'jl 9/6/2006 14:27'!
installOnRomePluginCanvas: aCanvas

	form asRomePluginSourceFormDuring: [ :f |
		aCanvas primFillBitmapOriginX: origin x asFloat
				 	y: origin y asFloat
					directionX: direction x asFloat / f width
					y: direction y asFloat / f height
					normalX: self normal x asFloat / f width
					y: self normal y asFloat / f height
					repeat: self isTiled
					image: f].

! !

!BitmapFillStyle methodsFor: '*Athens' stamp: 'cyrille.delaunay 5/7/2010 10:16'!
isTranslucent
	"Return true since the bitmap may be translucent and we don't really want to check"
	^true! !

BitmapFillStyle subclass: #TweakBitmapFill
	instanceVariableNames: 'combinationRule'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Tweak'!

!TweakBitmapFill methodsFor: 'accessing' stamp: 'cyrille.delaunay 5/7/2010 10:43'!
combinationRule
	^combinationRule ifNil:[Form over]! !

!TweakBitmapFill methodsFor: 'accessing' stamp: 'cyrille.delaunay 5/7/2010 10:43'!
combinationRule: rule
	combinationRule := rule! !

!FillStyle class methodsFor: '*Athens' stamp: 'cyrille.delaunay 5/7/2010 10:05'!
none
	^Color transparent
! !

!FillStyle class methodsFor: '*Athens' stamp: 'cyrille.delaunay 5/7/2010 10:05'!
solid
	^Color white
! !

!FillStyle methodsFor: '*Athens' stamp: 'jl 6/7/2006 12:29'!
asRomeFill
	^self! !

!FillStyle methodsFor: '*Athens' stamp: 'jl 8/17/2006 16:59'!
installOnRomePluginCanvas: aCanvas
	"to make sophie fills work"
	^self subclassResponsibility ! !

!FillStyle methodsFor: '*Athens' stamp: 'cyrille.delaunay 5/7/2010 10:06'!
transformBy: aTransform
! !

!FillStyle methodsFor: '*Athens' stamp: 'cyrille.delaunay 5/7/2010 10:06'!
transformedBy: aTransform
	^self copy transformBy: aTransform
! !

!MatrixTransform2x3 methodsFor: '*Athens' stamp: 'cyrille.delaunay 5/5/2010 16:23'!
composedWithLocalBis: aTransformation
	"Return the composition of the receiver and the local transformation passed in"
	^self composedWithLocal: aTransformation asMatrixTransform2x3 into: self class new! !

!MatrixTransform2x3 methodsFor: '*Athens' stamp: 'cyrille.delaunay 5/5/2010 16:20'!
scale
	| a11 a12 a21 a22 |
	a11 := self a11.
	a12 := self a12.
	a21 := self a21.
	a22 := self a22.
	^((a11*a11) + (a12*a12)) sqrt @ ((a21 * a21) + (a22 * a22)) sqrt! !

!MatrixTransform2x3 methodsFor: '*Athens' stamp: 'cyrille.delaunay 5/5/2010 16:26'!
sourceQuadFor: aRectangle
	^ aRectangle innerCorners collect: 
		[:p | (self invertPoint: p) truncated]! !

!MatrixTransform2x3 methodsFor: '*Athens-PluginCanvas' stamp: 'bf 8/28/2006 17:59'!
transformRomePluginCanvas: aCanvas
	^aCanvas primTransformBy: self! !

!MatrixTransform2x3 methodsFor: '*Athens-CTransformCanvas' stamp: 'cyrille.delaunay 5/5/2010 16:20'!
warpCellSize
	| a11 a12 a21 a22 |
	a11 := self a11.
	a12 := self a12.
	a21 := self a21.
	a22 := self a22.
	((a11*a11) + (a12*a12)) < 1.01 ifTrue:[^2].
	((a21 * a21) + (a22 * a22)) < 1.01 ifTrue:[^2].
	(a12 - a21) abs < 0.01
		ifTrue:[^1]
		ifFalse:[^2]! !

!IdentityTransform methodsFor: '*Athens' stamp: 'cyrille.delaunay 5/5/2010 16:14'!
scale
	^1@1! !

!IdentityTransform methodsFor: '*Athens' stamp: 'cyrille.delaunay 5/5/2010 16:17'!
transformDirection: aPoint
	^aPoint
! !

!IdentityTransform methodsFor: '*Athens-PluginCanvas' stamp: 'bf 8/28/2006 17:59'!
transformRomePluginCanvas: aCanvas
	^aCanvas! !

!WideString methodsFor: '*Athens-PluginCanvas' stamp: 'mir 1/6/2007 14:51'!
asUTF8String
	| converter utf8String |
	converter := UTF8TextConverter new.
	utf8String := String streamContents: [:stream | 
		1 to: self size do: [:i | 
			converter nextPut: (self at: i) toStream: stream].
		stream nextPut: (Character value: 0)].
	^utf8String! !

!GradientFillStyle methodsFor: '*Athens' stamp: 'cyrille.delaunay 5/7/2010 10:20'!
alpha
	^colorRamp first value alpha! !

!GradientFillStyle methodsFor: '*Athens' stamp: 'cyrille.delaunay 5/7/2010 10:20'!
alpha: newAlpha
	colorRamp := colorRamp collect:[:each|
		each key -> (each value alpha: newAlpha).
	].
	pixelRamp := nil.
	^self! !

!GradientFillStyle methodsFor: '*Athens' stamp: 'cyrille.delaunay 5/7/2010 10:23'!
colors
	"Create a gradient fill style from an array of equally spaced colors"
	^self colorRamp collect:[:each| each value]! !

!GradientFillStyle methodsFor: '*Athens' stamp: 'cyrille.delaunay 5/7/2010 10:23'!
colors: colorArray
	"Create a gradient fill style from an array of equally spaced colors"
	^self colorRamp: (colorArray withIndexCollect:
		[:color :index| (index-1 asFloat / (colorArray size - 1 max: 1)) -> color]).! !

!GradientFillStyle methodsFor: '*Athens' stamp: 'jl 9/5/2006 18:02'!
installOnRomePluginCanvas: aCanvas
	| colorStops i |
	colorStops := WordArray new: colorRamp size * 3.
	i := 0.
	colorRamp do: [:stop |
		colorStops at: (i:=i+1) put: (stop key * 65536.0) rounded.
		colorStops at: (i:=i+1) put: stop value privateRGB.
		colorStops at: (i:=i+1) put: stop value privateAlpha].
	radial == true
		ifTrue: [
			aCanvas primFillRadialGradientOriginX: origin x asFloat
				y: origin y asFloat
				directionX: direction x asFloat
				y: direction y asFloat
				normalX: self normal x asFloat
				y: self normal y asFloat
				colorStops: colorStops]
		ifFalse: [
			aCanvas primFillLinearGradientOriginX: origin x asFloat
				y: origin y asFloat
				directionX: direction x asFloat
				y: direction y asFloat
				colorStops: colorStops]! !

!GradientFillStyle methodsFor: '*Athens' stamp: 'cyrille.delaunay 5/7/2010 10:24'!
isSolidFill
	^false! !

PNGReadWriter subclass: #PNGRomeReadWriter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-PluginCanvas'!

!PNGRomeReadWriter methodsFor: 'accessing' stamp: 'JMM 10/13/2006 14:11'!
nextImage
	| duh basicForm |
	[stream isFileStream 
		ifTrue: 
			[duh := RomePluginForm fromPngFile: stream name]
		ifFalse: 
			[duh := RomePluginForm fromPngStream: stream].
	basicForm := duh asForm. 
	duh hibernate.
	^basicForm] on: Error do: [:ex | ^super nextImage].
! !

!PNGRomeReadWriter methodsFor: 'accessing' stamp: 'JMM 10/13/2006 14:11'!
nextPutImage: aImage
	| fileName rome |
	
	[rome := aImage asRomePluginSourceForm.
	rome unhibernate.
	stream isFileStream 
		ifTrue: 
			[fileName := stream name. 
			rome writeFormToPngFile: fileName]
		ifFalse: 
			[rome writeFormToStream: stream]] on: Error do: [:ex | super nextPutImage: aImage].
	^self
	
! !

!CompositeTransform methodsFor: '*Athens-PluginCanvas' stamp: 'bf 8/28/2006 18:06'!
transformRomePluginCanvas: aCanvas
	globalTransform transformRomePluginCanvas: aCanvas.
	^localTransform transformRomePluginCanvas: aCanvas.
! !

!MorphicTransform methodsFor: '*Athens-PluginCanvas' stamp: 'bf 8/28/2006 18:08'!
transformRomePluginCanvas: aCanvas
	^aCanvas
		translateBy: offset;
		rotateBy: angle;
		scaleBy: scale
! !

!Form methodsFor: '*Athens-PluginCanvas' stamp: 'be 7/31/2006 10:31'!
asRomePluginSourceForm
	| f |
	f := RomePluginSourceForm
		extent: self extent
		depth: self romePluginSourceFormDepth.
	f source: self.
	f offset: offset.
	^f! !

!Form methodsFor: '*Athens-PluginCanvas' stamp: 'jl 9/6/2006 11:17'!
asRomePluginSourceFormDuring: aBlock
	| f hibernate |
	f := self asSourceForm asRomePluginSourceForm.
	hibernate := f unhibernate.
	aBlock value: f.
	hibernate ifTrue: [f hibernate].


! !

!Form methodsFor: '*Athens-PluginCanvas' stamp: 'bf 7/28/2006 12:16'!
asRomePluginTargetForm
	| f |
	f := RomePluginTargetForm extent: self extent depth: 32.
	f target: self.
	^f! !

!Form methodsFor: '*Athens-PluginCanvas' stamp: 'bf 7/25/2006 14:50'!
isRomePluginForm
	^false! !

!Form methodsFor: '*Athens-PluginCanvas' stamp: 'be 7/31/2006 10:34'!
romePluginSourceFormDepth
	^(depth = 1 and: [SmalltalkImage current endianness == #big])
		ifTrue: [1]
		ifFalse: [32]! !

Form subclass: #RomePluginForm
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-PluginCanvas'!

!RomePluginForm classSide methodsFor: 'finalization' stamp: 'bf 7/17/2006 20:02'!
destroyFormHandle: aFormHandle
	self primDestroyFormHandle: aFormHandle! !

!RomePluginForm classSide methodsFor: 'objects from disk' stamp: 'JMM 10/13/2006 09:23'!
fromPngFile: aFileName
	| rf |

	rf := self new.
	rf fromPngFile: aFileName.
	^rf! !

!RomePluginForm classSide methodsFor: 'objects from disk' stamp: 'JMM 10/13/2006 09:23'!
fromPngStream: aStream
	| rf |

	rf := self new.
	rf fromPngStream: aStream.
	^rf! !

!RomePluginForm classSide methodsFor: 'objects from disk' stamp: 'JMM 10/13/2006 09:23'!
fromPngString: aString
	| rf |

	rf := self new.
	rf fromPngString: aString.
	^rf! !

!RomePluginForm classSide methodsFor: 'finalization' stamp: 'bf 7/7/2006 11:13'!
primDestroyFormHandle: aHandle
	"ok to fail"
	<primitive: 'primitiveDestroyFormHandle' module: 'RomePlugin'>
! !

!RomePluginForm methodsFor: 'converting' stamp: 'JMM 10/13/2006 13:07'!
asForm
	| t2 |
	t2 := Form extent: self boundingBox extent depth: depth.
	^ t2
		copyBits: self boundingBox
		from: self
		at: 0 @ 0
		clippingBox: t2 boundingBox
		rule: Form over
		fillColor: nil! !

!RomePluginForm methodsFor: 'converting' stamp: 'bf 7/7/2006 13:54'!
asRomePluginSourceForm
	^self! !

!RomePluginForm methodsFor: 'converting' stamp: 'bf 7/7/2006 13:23'!
asRomePluginTargetForm
	^self! !

!RomePluginForm methodsFor: 'initialize-release' stamp: 'bf 8/23/2006 11:01'!
flush
	self flush: self boundingBox! !

!RomePluginForm methodsFor: 'initialize-release' stamp: 'bf 8/23/2006 11:00'!
flush: aRectangle
	super flush! !

!RomePluginForm methodsFor: 'converting' stamp: 'JMM 10/11/2006 16:08'!
fromPngFile: aFilename
	bits := self primSurfaceCreateFromPng: aFilename.
	bits ifNil: [^self].
	self register.
	width := self primImageSurfaceGetWidth.
	height := self primImageSurfaceGetHeight.
	depth := 32.
	^self! !

!RomePluginForm methodsFor: 'converting' stamp: 'JMM 10/13/2006 09:22'!
fromPngStream: aStream
	self fromPngString: aStream contents! !

!RomePluginForm methodsFor: 'converting' stamp: 'JMM 10/12/2006 18:10'!
fromPngString: aString
	bits := self primImageSurfaceCreateFromPngStream: aString length: aString size.
	bits ifNil: [^self].
	self register.
	width := self primImageSurfaceGetWidth.
	height := self primImageSurfaceGetHeight.
	depth := 32.
	^self! !

!RomePluginForm methodsFor: 'startup-shutdown' stamp: 'bf 7/7/2006 20:10'!
hibernate
	bits ifNotNil: [
		self class destroyFormHandle: bits.
		bits := nil.
		self unregister.
	].! !

!RomePluginForm methodsFor: 'testing' stamp: 'bf 7/25/2006 14:50'!
isRomePluginForm
	^true! !

!RomePluginForm methodsFor: 'primitives' stamp: 'bf 7/7/2006 11:18'!
primCreateFormHandle
	"create a surface of my extent and depth, answer its SurfacePlugin id"
	<primitive: 'primitiveCreateFormHandle' module: 'RomePlugin'>
	^self primitiveFailed
! !

!RomePluginForm methodsFor: 'primitives' stamp: 'JMM 10/12/2006 18:10'!
primImageSurfaceCreateFromPngStream: aBuffer length: length
	"make surface from buffer"
	<primitive: 'primitiveImageSurfaceCreateFromPngStream' module: 'RomePlugin'>
	^self primitiveFailed
! !

!RomePluginForm methodsFor: 'primitives' stamp: 'JMM 10/11/2006 16:07'!
primImageSurfaceGetHeight
	"Get image height"
	<primitive: 'primitiveImageSurfaceGetHeight' module: 'RomePlugin'>
	^self primitiveFailed
! !

!RomePluginForm methodsFor: 'primitives' stamp: 'JMM 10/11/2006 16:07'!
primImageSurfaceGetWidth
	"Get image width"
	<primitive: 'primitiveImageSurfaceGetWidth' module: 'RomePlugin'>
	^self primitiveFailed
! !

!RomePluginForm methodsFor: 'primitives' stamp: 'JMM 10/11/2006 14:35'!
primSurfaceCreateFromPng: aFile
	"Write surface to a file"
	<primitive: 'primitiveImageSurfaceCreateFromPng' module: 'RomePlugin'>
	^self primitiveFailed
! !

!RomePluginForm methodsFor: 'primitives' stamp: 'JMM 10/11/2006 13:52'!
primWriteFormToPngFile: aFile
	"Write surface to a file"
	<primitive: 'primitiveSurfaceWriteToPng' module: 'RomePlugin'>
	^self primitiveFailed
! !

!RomePluginForm methodsFor: 'primitives' stamp: 'JMM 10/13/2006 09:15'!
primWriteFormToString: aString
	"Write surface to a string"
	<primitive: 'primitiveSurfaceWriteToStream' module: 'RomePlugin'>
	^self primitiveFailed
! !

!RomePluginForm methodsFor: 'debug' stamp: 'bf 7/7/2006 13:51'!
printOn: aStream
	aStream
		nextPutAll: self class name;
		nextPut: $(; 
		nextPutAll: 'handle='; print: bits;
		nextPut: $,; print: width;
		nextPut: $x; print: height;
		nextPut: $x; print: depth;
		nextPut: $).
! !

!RomePluginForm methodsFor: 'finalization' stamp: 'bf 7/7/2006 11:48'!
register
	self toFinalizeSend: #destroyFormHandle: to: self class with: bits! !

!RomePluginForm methodsFor: 'initialize-release' stamp: 'bf 7/7/2006 13:59'!
setExtent: extent depth: bitsPerPixel

	width := extent x asInteger.
	width < 0 ifTrue: [width := 0].
	height := extent y asInteger.
	height < 0 ifTrue: [height := 0].
	depth := bitsPerPixel.
	bits ifNotNil: [self error: 'handle not nil'].
	"bits are allocated in #unhibernate"! !

!RomePluginForm methodsFor: 'initialize-release' stamp: 'bf 7/6/2006 16:08'!
setExtent: extent depth: bitsPerPixel bits: bitmap
	^self error: 'This is an external form, bits access not possible'! !

!RomePluginForm methodsFor: 'startup-shutdown' stamp: 'bf 7/7/2006 11:59'!
unhibernate
	bits ifNotNil: [^false].
	bits := self primCreateFormHandle.
	self register.
	^true! !

!RomePluginForm methodsFor: 'finalization' stamp: 'bf 7/7/2006 11:49'!
unregister
	self finalizationRegistry remove: self! !

!RomePluginForm methodsFor: 'converting' stamp: 'JMM 10/11/2006 13:52'!
writeFormToPngFile: aFileName
	self primWriteFormToPngFile: aFileName! !

!RomePluginForm methodsFor: 'converting' stamp: 'JMM 10/13/2006 09:43'!
writeFormToStream: aStream
	| sizeEstimate string size |

	sizeEstimate := height*width*4 max: 1024*10.
	string := String new: sizeEstimate.
	size := self writeFormToString: string.
	aStream next: size putAll: string startingAt: 1.! !

!RomePluginForm methodsFor: 'converting' stamp: 'JMM 10/13/2006 09:39'!
writeFormToString: aString
	| size |
	size := self primWriteFormToString: aString.
	^size! !

RomePluginForm subclass: #RomePluginSourceForm
	instanceVariableNames: 'source'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-PluginCanvas'!

!RomePluginSourceForm methodsFor: 'converting' stamp: 'JMM 10/13/2006 13:08'!
asForm
	^source! !

!RomePluginSourceForm methodsFor: 'accessing' stamp: 'bf 7/7/2006 13:53'!
source: aForm
	source := aForm.! !

!RomePluginSourceForm methodsFor: 'overrides' stamp: 'bf 7/31/2006 13:18'!
unhibernate
	| didUnhibernate |
	(didUnhibernate := super unhibernate)
		ifTrue: [
			(source depth = 1
				and: [source isColorForm not
					and: [SmalltalkImage current endianness == #little]])
				ifTrue: [self copyBits: self boundingBox
					from: source
					at: 0@0 
					colorMap: (WordArray with: 0 with: 16rFF000000)]
				ifFalse: [
					source displayOn: self at: self offset negated.
					source depth = 16 ifTrue: [self fixAlpha]]].
	^didUnhibernate
! !

RomePluginForm subclass: #RomePluginTargetForm
	instanceVariableNames: 'target'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-PluginCanvas'!

!RomePluginTargetForm methodsFor: 'converting' stamp: 'JMM 10/13/2006 13:08'!
asForm
	^target! !

!RomePluginTargetForm methodsFor: 'overrides' stamp: 'bf 8/23/2006 11:08'!
flush
	self flush: target boundingBox! !

!RomePluginTargetForm methodsFor: 'overrides' stamp: 'bf 8/23/2006 11:08'!
flush: aRectangle
	| rule |
	super flush: aRectangle.
	rule := (depth = 32)
		ifTrue: [34 "alphaBlendScaled"]
		ifFalse: [Form paint].
	target copy: aRectangle from: self to: aRectangle origin rule: rule.! !

!RomePluginTargetForm methodsFor: 'private' stamp: 'bf 7/25/2006 13:22'!
privateTarget
	^target! !

!RomePluginTargetForm methodsFor: 'accessing' stamp: 'bf 7/7/2006 12:36'!
target: aForm
	target := aForm! !

!AbstractFont methodsFor: '*Athens-Core' stamp: 'bf 9/5/2006 21:34'!
asRomeFont
	^self inform: 'Cannot convert ', self class name, ' to a RomeFont\' withCRs,
		'You might want to install Rome-Balloon or Rome-Strike.'! !

!OrientedFillStyle methodsFor: '*Athens' stamp: 'cyrille.delaunay 5/7/2010 10:11'!
offset
	^origin! !

!OrientedFillStyle methodsFor: '*Athens' stamp: 'cyrille.delaunay 5/7/2010 10:11'!
offset: aPoint
	self origin: aPoint.! !

!OrientedFillStyle methodsFor: '*Athens' stamp: 'jl 6/14/2006 15:37'!
transformBy: aTransform
	origin := aTransform transformPoint: self origin.
	normal := aTransform transformDirection: self normal. "is lazy initialized and uses direction"
	direction := aTransform transformDirection: self direction.
! !

!OrientedFillStyle methodsFor: '*Athens' stamp: 'jl 6/7/2006 12:34'!
transformedBy: aTransform
	^self copy transformBy: aTransform
! !

DisplayTransform subclass: #COffsetTransform
	instanceVariableNames: 'offset'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Transformations'!

!COffsetTransform commentStamp: 'ar 3/27/2004 18:00' prior: 0!
COffsetTransform is a very specialized kind of transformation which optimizes for the specific case of only having to deal with translation (which is very common).!

!COffsetTransform classSide methodsFor: 'instance creation' stamp: ''!
offset: aPoint
	^self new offset: aPoint! !

!COffsetTransform classSide methodsFor: 'instance creation' stamp: ''!
withOffset: aPoint
	^self new offset: aPoint! !

!COffsetTransform methodsFor: 'comparing' stamp: ''!
= aTransform
	^aTransform isPureTranslation and:[self offset = aTransform offset]! !

!COffsetTransform methodsFor: 'converting' stamp: 'cyrille.delaunay 5/5/2010 16:38'!
asMatrixTransform2x3
	^MatrixTransform2x3 withOffset: offset! !

!COffsetTransform methodsFor: 'composing' stamp: ''!
composedWithLocal: aTransform
	aTransform isPureTranslation
		ifTrue:[^self clone offset: (offset + aTransform offset)].
	^self asMatrixTransform2x3 composedWithLocal: aTransform! !

!COffsetTransform methodsFor: 'transforming' stamp: ''!
globalBoundsToLocal: aRectangle
	^aRectangle translateBy: offset negated! !

!COffsetTransform methodsFor: 'transforming' stamp: ''!
globalPointToLocal: aPoint
	^aPoint - offset! !

!COffsetTransform methodsFor: 'comparing' stamp: ''!
hash
	^offset hash! !

!COffsetTransform methodsFor: 'accessing' stamp: ''!
inverseTransformation
	"Return the inverse transformation of the receiver."
	^self clone offset: offset negated! !

!COffsetTransform methodsFor: 'transforming' stamp: 'ar 6/26/2005 14:07'!
invertDirection: aPoint
	^aPoint! !

!COffsetTransform methodsFor: 'testing' stamp: ''!
isIdentity
	^offset isZero! !

!COffsetTransform methodsFor: 'testing' stamp: ''!
isNoRotationWithin: bounds
	^true! !

!COffsetTransform methodsFor: 'testing' stamp: ''!
isNoTransformWithin: aRectangle
	^true! !

!COffsetTransform methodsFor: 'testing' stamp: ''!
isPureTranslation
	^true! !

!COffsetTransform methodsFor: 'transforming' stamp: ''!
localBoundsToGlobal: aRectangle
	^aRectangle translateBy: offset! !

!COffsetTransform methodsFor: 'transforming' stamp: ''!
localPointToGlobal: aPoint
	^offset + aPoint! !

!COffsetTransform methodsFor: 'converting' stamp: 'cyrille.delaunay 5/5/2010 16:35'!
normalizedTransform
	"if transform is within epsilon of integers, return snapped version"
	
	| rounded |
	rounded := offset rounded.
	(offset - rounded) abs <= 0.0009765625 asPoint "2r1e-10 asFloat"
		ifTrue: [
			^rounded isZero
				ifTrue: [IdentityTransform new]
				ifFalse: [self class offset: rounded]].
	^self! !

!COffsetTransform methodsFor: 'accessing' stamp: ''!
offset
	^offset! !

!COffsetTransform methodsFor: 'accessing' stamp: ''!
offset: aPoint
	offset := aPoint! !

!COffsetTransform methodsFor: 'printing' stamp: 'bf 4/3/2004 00:50'!
printOn: aStream
	aStream 
		nextPutAll: self class name;
		nextPut: $(;
		print: offset;
		nextPut:$).! !

!COffsetTransform methodsFor: 'accessing' stamp: ''!
scale
	^1@1! !

!COffsetTransform methodsFor: 'initialize' stamp: ''!
setIdentity
	offset := 0@0.! !

!COffsetTransform methodsFor: 'transforming' stamp: ''!
transformDirection: aPoint
	^aPoint! !

!COffsetTransform methodsFor: 'transforming' stamp: ''!
transformPoint: aPoint
	^offset + aPoint! !

!DisplayTransform methodsFor: '*Athens' stamp: 'cyrille.delaunay 5/5/2010 16:06'!
composedWithLocalBis: aTransformation
	"Return the composition of the receiver and the local transformation passed in.
	A 'local' transformation is defined as a transformation that takes place
	between the receiver (the 'global') transformation and any 'local' point
	computations, e.g., for the methods
		globalPointToLocal: globalPoint
			globalPoint -> globalTransform -> localTransform -> locaPoint
		localPointToGlobal: localPoint
			localPoint -> localTransform -> globalTransform -> globalPoint
		"
	self isIdentity ifTrue:[^ aTransformation].
	aTransformation isIdentity ifTrue:[^ self].
	^self asMatrixTransform2x3 composedWithLocal: aTransformation asMatrixTransform2x3! !

!DisplayTransform methodsFor: '*Athens' stamp: 'cyrille.delaunay 5/5/2010 16:10'!
invertPoint: aPoint
	^self globalPointToLocal: aPoint! !

!DisplayTransform methodsFor: '*Athens' stamp: 'cyrille.delaunay 5/5/2010 16:07'!
isNoTransformWithin: aRectangle
	"Return true if the receiver represents no transformation within the given bounding rectangle. This method basically determines if the receiver should be seen as a pure translation for the purposes of drawing in the given rectangle."
	^true "only implementor is CMatrixTransform"! !

!DisplayTransform methodsFor: '*Athens' stamp: 'cyrille.delaunay 5/5/2010 16:11'!
transformPoint: aPoint
	^self localPointToGlobal: aPoint! !

!DisplayTransform methodsFor: '*Athens' stamp: 'cyrille.delaunay 5/5/2010 16:11'!
transformRect: aRectangle
	^self localBoundsToGlobal: aRectangle! !

!DisplayTransform methodsFor: '*Athens-PluginCanvas' stamp: 'bf 8/28/2006 17:58'!
transformRomePluginCanvas: aCanvas
	^self subclassResponsibility  ! !

!DisplayTransform methodsFor: '*Athens' stamp: 'cyrille.delaunay 5/5/2010 16:12'!
transformedBy: aTransform
	^self composedWithGlobal: aTransform! !

!DisplayTransform methodsFor: '*Athens-CTransformCanvas' stamp: 'cyrille.delaunay 5/5/2010 15:58'!
warpCellSize

	^1! !

FormCanvas subclass: #CTransformCanvas
	instanceVariableNames: 'backup transform maskCanvas forceWarp warpTransform font fontColor fontChanged lastLinePen'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-CTransformCanvas'!

!CTransformCanvas classSide methodsFor: 'islands' stamp: 'ar 5/20/2005 11:53'!
howToPassAsArgument
	^#passByIdentity:! !

!CTransformCanvas methodsFor: 'push/pop' stamp: 'ar 12/9/2003 17:53'!
asBackup
! !

!CTransformCanvas methodsFor: 'converting' stamp: 'ar 6/8/2003 21:19'!
asBalloonCanvas
	^(BalloonCanvas on: form) 
		setOrigin: 0@0 clipRect: port clipRect;
		transformBy: transform asMatrixTransform2x3;
		aaLevel: 4;
		yourself! !

!CTransformCanvas methodsFor: 'TODO-IGraphicsDevice' stamp: 'ar 12/9/2003 00:37'!
asCanvas
	^self! !

!CTransformCanvas methodsFor: 'accessing' stamp: 'ar 12/9/2003 00:37'!
asTransformCanvas
	^self! !

!CTransformCanvas methodsFor: 'drawing-images' stamp: 'cyrille.delaunay 5/7/2010 10:44'!
balloonWarp: aForm transform: aTransform at: extraOffset sourceRect: sourceRect
	"Warp the given using the appropriate transform and offset."
	| engine fill globalRect tfm |
	"a workaround for balloon sometimes not rounding appropriately"
	globalRect := aTransform localBoundsToGlobal: sourceRect.
	extraOffset ifNotNil:[globalRect := globalRect translateBy: extraOffset].
	port clipBy: globalRect.
	engine := BalloonEngine new.
	engine aaLevel: 2.
	engine bitBlt: port.
	engine destOffset: extraOffset.
	engine deferred: false.
	fill := TweakBitmapFill form: aForm.
	fill tileFlag: false.
	fill origin: 0@0.
	fill direction: aForm width@0.
	fill normal: 0@aForm height.
	"another weirdo offset problem..."
	tfm := aTransform clone.
	tfm a13: tfm a13 - 0.2.
	tfm a23: tfm a23 - 0.2.
	engine
		drawRectangle: sourceRect
		fill: fill
		borderWidth: 0
		borderColor: nil
		transform: tfm.
	engine flush.
	port clipRect: (transform localBoundsToGlobal: clipRect).! !

!CTransformCanvas methodsFor: 'caching' stamp: 'ar 3/18/2003 23:51'!
cache: aRectangle using: aCache during: aBlock
	aCache ifNil:[^aBlock value: self].
	^aCache drawCached: aBlock on: self in: aRectangle! !

!CTransformCanvas methodsFor: 'clipping' stamp: 'StephaneDucasse 4/15/2010 14:51'!
clipBy: aClipShape
	clipRect := clipRect intersect: aClipShape asRectangle.
	port clipBy: (transform localBoundsToGlobal: clipRect) truncated.
	(aClipShape isRectangle and:[transform isPureTranslation]) ifTrue:[^self].
	"Use a mask for clipping"
	"TODO: Need to initialize maskCanvas if not initialized"
	"TODO: Need maskCanvas to provide Form>>bitAnd!!"
	"aClipShape drawOn: maskCanvas."
	"TODO: Need to install a different form/warp in order to get masking right"! !

!CTransformCanvas methodsFor: 'clipping' stamp: ''!
clipBy: aClipShape during: aBlock
	self pushState.
	self clipBy: aClipShape.
	aBlock value: self.
	self popState.! !

!CTransformCanvas methodsFor: 'accessing' stamp: ''!
clipRect
	^clipRect! !

!CTransformCanvas methodsFor: 'accessing' stamp: 'JMM 11/25/2005 17:16'!
colorMap: anInt
	port colorMap: anInt! !

!CTransformCanvas methodsFor: 'accessing' stamp: 'JMM 11/25/2005 17:16'!
combinationRule: anInt
	port combinationRule: anInt! !

!CTransformCanvas methodsFor: 'transforming' stamp: ''!
copyFrom: anObject
	1 to: self class instSize do:[:i|
		self instVarAt: i put: (anObject instVarAt: i).
	].! !

!CTransformCanvas methodsFor: 'initialize' stamp: 'ar 5/22/2005 20:50'!
deferUpdates: aBool
	^form deferUpdates: aBool
! !

!CTransformCanvas methodsFor: 'accessing' stamp: 'JMM 11/25/2005 17:12'!
destForm
	^port destForm! !

!CTransformCanvas methodsFor: 'TODO-IGraphicsDevice' stamp: 'ar 12/9/2003 00:36'!
display: anObject
	"Display the given object"
	anObject displayFrom: self.
! !

!CTransformCanvas methodsFor: 'drawing-text' stamp: 'ar 12/6/2005 14:58'!
displayString: aString from: startIndex to: stopIndex at: aPoint font: aFont kern: kernDelta
	| stringWidth stringHeight box tmpForm |
	font == aFont ifFalse:[
		font := aFont.
		fontChanged := true.
	].
	transform isPureTranslation ifTrue:[
		fontChanged ifTrue:[
			"set paint color again in case we had intermediate drawing operations"
			self setPaintColor: fontColor. 
			font installOn: port foregroundColor: fontColor backgroundColor: Color transparent.
			fontChanged := false.
		].
		font displayString: aString 
			on: port 
			from: startIndex 
			to: stopIndex 
			at: aPoint + origin
			kern: kernDelta.
		^self].


	"draw string onto temporary form"
	stringWidth := aFont widthOfString: aString from: startIndex to: stopIndex.
	stringHeight := aFont height.
	box := aPoint extent: (stringWidth @ stringHeight).
	box := box intersect: clipRect.
	tmpForm := ColorForm extent: box extent depth: 1.
	tmpForm colors: (Array with: Color transparent with: fontColor).
	tmpForm getCanvas 
		drawString: aString 
		from: startIndex 
		to: stopIndex 
		in: (aPoint - box origin extent: box extent) 
		font: font 
		color: Color black
		kern: kernDelta.
	"and blast out image"
	^self paintImage: tmpForm at: box origin! !

!CTransformCanvas methodsFor: 'drawing-text' stamp: 'tak 5/27/2005 17:51'!
displayString: aString from: startIndex to: stopIndex at: aPoint kern: kernDelta baselineY: baselineY font: aFont
	^self displayString: aString from: startIndex to: stopIndex at: aPoint font: aFont kern: kernDelta! !

!CTransformCanvas methodsFor: 'drawing-shapes' stamp: 'ar 6/9/2003 03:36'!
drawCompressedShape: aShape
	^self asBalloonCanvas drawCompressedShape: aShape! !

!CTransformCanvas methodsFor: 'drawing-lines' stamp: 'StephaneDucasse 4/15/2010 14:51'!
drawLineFrom: lastPt to: nextPt brush: brush
	| offset erasing |
	offset := origin.
	self setPaintColor: Color black.
	erasing := brush isColorForm and: [brush colors second isTransparent].
	erasing ifTrue: [
		brush colors at: 2 put: Color white.
		port combinationRule: Form erase].
	port sourceForm: brush; fillColor: nil;
		sourceRect: brush boundingBox;
		colorMap: (brush colormapIfNeededFor: form);
		drawFrom: (lastPt + offset) to: (nextPt + offset).
	erasing ifTrue: [brush colors at: 2 put: Color transparent] ! !

!CTransformCanvas methodsFor: 'drawing-lines' stamp: 'ar 3/27/2003 18:30'!
drawLineFrom: lastPt to: nextPt width: lineWidth color: lineColor
	^self line: lastPt to: nextPt width: lineWidth color: lineColor! !

!CTransformCanvas methodsFor: 'drawing-text' stamp: 'tak 5/27/2005 18:11'!
drawString: aString from: firstIndex to: lastIndex in: bounds font: fontOrNil color: c kern: kernDelta
	transform isPureTranslation ifTrue:[
		^super 
			drawString: aString 
			from: firstIndex 
			to: lastIndex 
			in: bounds 
			font: fontOrNil 
			color: c
			kern: kernDelta
	].
	self pushState.
	self clipBy: bounds.
	font := fontOrNil ifNil:[TextStyle defaultFont].
	font installOn: self 
		foregroundColor: (shadowColor ifNil:[c]) 
		backgroundColor: Color transparent.
	self displayString: aString
		from: firstIndex
		to: lastIndex
		at: bounds topLeft
		font: font
		kern: kernDelta.
	self popState.! !

!CTransformCanvas methodsFor: 'drawing-rectangles' stamp: ''!
fillOval: aRectangle fill: aFill border: aBorder
	"@@@@: Fix this. Remove the old interface. :@@@@"
	^self fillOval: aRectangle fillStyle: aFill borderStyle: aBorder! !

!CTransformCanvas methodsFor: 'drawing-rectangles' stamp: 'ar 6/8/2003 20:34'!
fillRectangle: r color: c
	transform isPureTranslation ifTrue:[
		^super fillRectangle: r color: c
	].
	self balloonFillRectangle: r fillStyle: (shadowColor ifNil:[c]).
! !

!CTransformCanvas methodsFor: 'drawing-rectangles' stamp: ''!
fillRectangle: aRectangle fill: aFill border: aBorder
	"@@@@: Fix this. Remove the old interface. :@@@@"
	^self fillRectangle: aRectangle fillStyle: aFill borderStyle: aBorder! !

!CTransformCanvas methodsFor: 'drawing-rectangles' stamp: 'ar 6/8/2003 20:31'!
fillRectangle: aRectangle fillStyle: aFillStyle
	transform isPureTranslation ifTrue:[
		^super fillRectangle: aRectangle fillStyle: aFillStyle
	].
	self balloonFillRectangle: aRectangle fillStyle: (shadowColor ifNil:[aFillStyle]).
! !

!CTransformCanvas methodsFor: 'drawing-round rects' stamp: 'be 9/18/2007 10:11'!
fillRoundRect: aRectangle radius: cornerRadius fill: fillStyle border: borderStyle
	"Draw a rounded rectangle"
	self shadowColor ifNotNil:[
		^self fillRoundRect: aRectangle radius: cornerRadius fillStyle: shadowColor.
	].
	"see if the round rect is degenerate"
	cornerRadius asPoint <= (0@0) 
		ifTrue:[^self fillRectangle: aRectangle fill: fillStyle border: borderStyle].
	cornerRadius * 2 >= (aRectangle width max: aRectangle height)
		ifTrue:[^self fillOval: aRectangle fill: fillStyle border: borderStyle].
	"Okay it's a rounded rectangle"
	fillStyle isTransparent ifFalse:["fill interior"
		| innerRect radius bw |
		innerRect := aRectangle.
		radius := cornerRadius.
		bw := borderStyle width.
		bw isZero ifFalse:[
			innerRect := innerRect insetBy: bw.
			radius := radius - bw.
		].
		self fillRoundRect: innerRect radius: radius fillStyle: fillStyle.
	].
	borderStyle width = 0 ifFalse:[
		borderStyle frameRoundRect: aRectangle radius: cornerRadius on: self.
	].! !

!CTransformCanvas methodsFor: 'drawing-round rects' stamp: 'ar 6/8/2003 19:07'!
fillRoundRect: aRectangle radius: radius fillStyle: fillStyle
	fillStyle isTransparent ifTrue:[^self].
	radius asPoint <= (0@0) 
		ifTrue:[^self fillRectangle: aRectangle fillStyle: fillStyle].
	(radius * 2) asPoint >= aRectangle extent 
		ifTrue:[^self fillOval: aRectangle fillStyle: fillStyle].
	fillStyle isSolidFill 
		ifFalse:[^self balloonFillRoundRect: aRectangle radius: radius fillStyle: fillStyle].
	self setFillColor: (shadowColor ifNil:[fillStyle asColor]).
	^port fillRoundRect: (aRectangle translateBy: origin) truncated radius: radius.
! !

!CTransformCanvas methodsFor: 'private-state' stamp: 'StephaneDucasse 4/15/2010 14:51'!
flushWarp
	"Warp the receiver onto aCanvas"
	| aCanvas |
	warpTransform ifNil:[^self].
	aCanvas := backup.
	maskCanvas ifNotNil:[
		"Mask out the clipping region if non-rectangular"
		maskCanvas finish.
		(BitBlt toForm: form)
			sourceForm: maskCanvas form;
			combinationRule: Form and;
			copyBits].
	aCanvas 
		privateWarp: form 
		transform: warpTransform 
		at: 0@0 
		sourceRect: form boundingBox 
		cellSize: warpTransform warpCellSize.! !

!CTransformCanvas methodsFor: 'initialize' stamp: 'ar 5/22/2005 20:50'!
forceDamageToScreen: allDamage
	form forceDamageToScreen: allDamage
! !

!CTransformCanvas methodsFor: 'drawing-rectangles' stamp: 'ar 6/8/2003 20:49'!
frameAndFillRectangle: r fillColor: fillColor borderWidth: borderWidth topLeftColor: topLeftColor bottomRightColor: bottomRightColor
	| inner bc |
	transform isPureTranslation ifTrue:[
		^super frameAndFillRectangle: r fillColor: fillColor borderWidth: borderWidth topLeftColor: topLeftColor bottomRightColor: bottomRightColor.
	].
	inner := r insetBy: borderWidth.
	bc := self asBalloonCanvas.
	bc deferred: true.
	fillColor isTransparent ifFalse:[
		bc drawRectangle: inner color: fillColor borderWidth: 0 borderColor: nil.
	].

	(borderWidth > 0 and:[topLeftColor isTransparent not]) ifTrue:[	
		bc drawPolygon: {
			r topLeft.
			r topRight.
			inner topRight.
			inner topLeft.
			inner bottomLeft.
			r bottomLeft.
		} color: topLeftColor borderWidth: 0 borderColor: nil.
	].
	(borderWidth > 0 and:[bottomRightColor isTransparent not]) ifTrue:[	
		bc drawPolygon: {
			r topRight.
			r bottomRight.
			r bottomLeft.
			inner bottomLeft.
			inner bottomRight.
			inner topRight.
		} color: bottomRightColor borderWidth: 0 borderColor: nil.
	].
	bc flush.! !

!CTransformCanvas methodsFor: 'drawing-round rects' stamp: 'ar 6/8/2003 19:05'!
frameRoundRect: aRectangle radius: radius width: borderWidth color: borderColor
	"Frame a rounded rectangle with the given attributes."
	| innerRect |
	(borderWidth isZero or:[borderColor isTransparent])
		ifTrue:[^self].
	radius asPoint <= (0@0) 
		ifTrue:[^self frameRectangle: aRectangle width: borderWidth color: borderColor].
	(radius * 2) asPoint >= aRectangle extent 
		ifTrue:[^self frameOval: aRectangle width: borderWidth color: borderColor].
	"decompose inner rectangle into bezier shape"
	innerRect := aRectangle insetBy: borderWidth.
	innerRect area <= 0 
		ifTrue:[^self fillRoundRect: aRectangle radius: radius fillStyle: borderColor].
	self setFillColor: borderColor.
	port 
		frameRoundRect: (aRectangle translateBy: origin) truncated 
		radius: radius truncated 
		borderWidth: borderWidth truncated.
! !

!CTransformCanvas methodsFor: 'accessing' stamp: 'JMM 11/25/2005 17:14'!
halftoneForm: aPoint
	^port halftoneForm: aPoint! !

!CTransformCanvas methodsFor: 'drawing-images' stamp: 'cyrille.delaunay 5/7/2010 10:44'!
image: aForm at: aPoint sourceRect: sourceRect rule: rule
	"Draw the portion of the given Form defined by sourceRect at the given point using the given BitBlt combination rule."
	"Flood this canvas with aColor wherever stencilForm has non-zero pixels"
	| fill rect |
	transform isPureTranslation ifTrue:[
		^super image: aForm at: aPoint sourceRect: sourceRect rule: rule
	].
	fill := TweakBitmapFill new.
	fill form: aForm.
	fill direction: sourceRect width @ 0.
	fill normal: 0 @ sourceRect height.
	fill origin: aPoint - sourceRect origin.
	rect := (aPoint extent: sourceRect extent) intersect: clipRect.
	(self asBalloonCanvas)
		drawRectangle: rect
		color: fill
		borderWidth: 0
		borderColor: nil.
! !

!CTransformCanvas methodsFor: 'drawing-text' stamp: 'ar 6/8/2003 22:17'!
installStrikeFont: aFont foregroundColor: fgColor backgroundColor: ignored
	font := aFont.
	fontColor := fgColor.
	fontChanged := true.! !

!CTransformCanvas methodsFor: 'drawing-text' stamp: 'ar 2/12/2004 15:58'!
installTTCFont: aFont foregroundColor: fgColor backgroundColor: ignored
	font := aFont.
	fontColor := fgColor.
	fontChanged := true.! !

!CTransformCanvas methodsFor: 'private-state' stamp: 'StephaneDucasse 4/15/2010 14:51'!
installWarp: localRect
	| warpForm cc |
	forceWarp ifFalse:[^self].
	"TODO: Clip localRect against re-transformed portRect to minimize space usage"
	warpForm := Form extent: localRect extent depth: 32.
	warpTransform := transform composedWithLocal: (COffsetTransform withOffset: localRect origin).
	"TODO: #setForm: needs to initialize portRect based on clipRect/transform"
	cc := shadowColor.
	self setForm: warpForm.
	shadowColor := cc.
	self translateBy: localRect origin negated.
	clipRect := localRect.! !

!CTransformCanvas methodsFor: 'testing' stamp: 'bf 7/25/2006 11:14'!
isRomeCanvas
	^false! !

!CTransformCanvas methodsFor: 'testing' stamp: 'ar 12/8/2002 03:33'!
isVisible: aRectangle
	"Optimization"
	(aRectangle right) < clipRect left	ifTrue: [^ false].
	(aRectangle left) > clipRect right	ifTrue: [^ false].
	(aRectangle bottom) < clipRect top	ifTrue: [^ false].
	(aRectangle top) > clipRect bottom	ifTrue: [^ false].
	^ true! !

!CTransformCanvas methodsFor: 'drawing-lines' stamp: 'ar 2/6/2005 15:41'!
line: pt1 to: pt2 width: w color: c
	w isZero ifTrue:[^self].
	c isTransparent ifTrue:[^self].
	(lastLinePen == nil or:[lastLinePen width ~= w]) ifTrue:[
		lastLinePen := Form dotOfSize: w.
	].
	self setPaintColor: c.
	port sourceForm: lastLinePen.
	port colorMap: (Bitmap with: 0 with: 16rFFFFFFFF).
	port width: w; height: w;
		drawFrom: pt1+origin to: pt2+origin.

! !

!CTransformCanvas methodsFor: 'drawing-round rects' stamp: 'ar 6/8/2003 17:14'!
makeRoundRectShape: aRectangle radius: radius
	"decompose a rounded rectangle into bezier form"
	| ovalDiameter rectExtent segments points endPoint seg idx offset rectOffset |
	ovalDiameter := (radius * 2) asPoint min: aRectangle extent.
	(ovalDiameter x <= 0 or:[ovalDiameter y <= 0]) ifTrue:[
		"degenerates into rectangle - just hand back four lines"
		| topLeft topRight bottomLeft bottomRight |
		topLeft := aRectangle topLeft.
		topRight := aRectangle topRight.
		bottomLeft := aRectangle bottomLeft.
		bottomRight := aRectangle bottomRight.

		points := Array new: 4*3.
		points at: 1 put: topLeft.
		points at: 2 put: topLeft.
		points at: 3 put: topRight.

		points at: 4 put: topRight.
		points at: 5 put: topRight.
		points at: 6 put: bottomRight.

		points at: 7 put: bottomRight.
		points at: 8 put: bottomRight.
		points at: 9 put: bottomLeft.

		points at: 10 put: bottomLeft.
		points at: 11 put: bottomLeft.
		points at: 12 put: topLeft.
		^points
	].
	rectExtent := aRectangle extent - ovalDiameter.
	rectOffset := aRectangle origin.
	segments := Bezier2Segment makeEllipseSegments: (0@0 extent: ovalDiameter).
	"patch up the segments to include lines connecting the oval parts.
	we need: 8*3 points for the oval parts + 4*3 points for the connecting lines"
	points := Array new: 12*3.
	idx := 0.
	endPoint := segments last end + rectOffset.
	1 to: 8 by: 2 do:[:i|
		i = 1 ifTrue:[offset := rectOffset + (rectExtent x @ 0)].
		i = 3 ifTrue:[offset := rectOffset + rectExtent].
		i = 5 ifTrue:[offset := rectOffset + (0 @ rectExtent y)].
		i = 7 ifTrue:[offset := rectOffset].
		seg := segments at: i.
		"insert a line segment for the horizontal part of the round rect"
		points at: (idx := idx+1) put: endPoint.
		points at: (idx := idx+1) put: endPoint.
		points at: (idx := idx+1) put: seg start + offset.
		"now the first half-arc"
		points at: (idx := idx+1) put: seg start + offset.
		points at: (idx := idx+1) put: seg via + offset.
		points at: (idx := idx+1) put: seg end + offset.
		"the second half-arc"
		seg := segments at: i+1.
		points at: (idx := idx+1) put: seg start + offset.
		points at: (idx := idx+1) put: seg via + offset.
		points at: (idx := idx+1) put: seg end + offset.
		endPoint := seg end + offset.
	].
	^points! !

!CTransformCanvas methodsFor: 'push/pop' stamp: 'ar 12/9/2003 00:33'!
newBackup
	"Create a backup of the receiver"
	^self copy asBackup! !

!CTransformCanvas methodsFor: 'drawing-text' stamp: 'ar 3/11/2005 21:22'!
paragraph: para bounds: bounds color: c
	| scanner |
	self setPaintColor: c.
	scanner := MultiDisplayScanner new text: para text textStyle: para textStyle
		foreground: (shadowColor ifNil:[c]) background: Color transparent
		fillBlt: nil ignoreColorChanges: shadowColor notNil.
	scanner privatePort: self.
	para displayOn: self using: scanner at: bounds topLeft.! !

!CTransformCanvas methodsFor: 'push/pop' stamp: 'ar 12/9/2003 00:31'!
popState
	self restoreFrom: backup.! !

!CTransformCanvas methodsFor: 'transforming' stamp: ''!
preserveStateDuring: aBlock
	self pushState.
	aBlock value: self.
	self popState.! !

!CTransformCanvas methodsFor: 'drawing-images' stamp: 'ar 6/9/2003 00:11'!
privateWarp: aForm transform: aTransform at: extraOffset sourceRect: sourceRect cellSize: cellSize
	"Warp the given using the appropriate transform and offset."
false ifTrue:[
	^self balloonWarp: aForm transform: aTransform at: extraOffset sourceRect: sourceRect
] ifFalse:[
	^super privateWarp: aForm transform: aTransform at: extraOffset sourceRect: sourceRect cellSize: cellSize
].! !

!CTransformCanvas methodsFor: 'push/pop' stamp: 'StephaneDucasse 4/15/2010 14:51'!
pushState
	backup := self newBackup.
	warpTransform := nil.! !

!CTransformCanvas methodsFor: 'initialize' stamp: 'cyrille.delaunay 5/5/2010 16:35'!
reset
	super reset.
	transform := IdentityTransform new.
	forceWarp := true.
! !

!CTransformCanvas methodsFor: 'private-state' stamp: 'StephaneDucasse 4/15/2010 14:51'!
resetGrafPort
	"Private!! Create a new grafPort for a new copy."
	port := self portClass toForm: form.
	port clipRect: (transform localBoundsToGlobal: clipRect).! !

!CTransformCanvas methodsFor: 'private-state' stamp: 'ar 12/9/2003 00:31'!
restoreFrom: backup
	"Restore the receiver from the given canvas"
	self flushWarp. "flush me so pending changes take effect"
	"This should be a primitive!!"
	self copyFrom: backup! !

!CTransformCanvas methodsFor: 'rounding' stamp: 'cyrille.delaunay 5/5/2010 15:51'!
roundCornersOf: aMorph in: bounds during: aBlock
	aMorph wantsRoundedCorners ifFalse:[^aBlock value].
	(self seesRoundedCornerOf: bounds)
		ifFalse: ["Don't bother with corner logic if the region is inside them"
				^ aBlock value].
	CornerRounder roundCornersOf: aMorph on: self in: bounds
		displayBlock: aBlock
		borderWidth: aMorph borderWidthForRounding
		corners: aMorph roundedCorners
! !

!CTransformCanvas methodsFor: 'initialize' stamp: 'cyrille.delaunay 5/5/2010 16:35'!
setForm: aForm
	transform ifNil:[transform := IdentityTransform new].
	super setForm: aForm.
	port clipRect: (transform localBoundsToGlobal: clipRect).! !

!CTransformCanvas methodsFor: 'private-state' stamp: 'StephaneDucasse 4/15/2010 14:51'!
setOrigin: aPoint clipRect: aRectangle
	origin := aPoint.
	transform isIdentity
		ifTrue:[transform := COffsetTransform withOffset: aPoint]
		ifFalse:[transform offset: aPoint].
	clipRect := aRectangle translateBy: aPoint negated.
	port clipRect: (transform localBoundsToGlobal: clipRect).! !

!CTransformCanvas methodsFor: 'accessing' stamp: 'JMM 11/25/2005 17:14'!
sourceOrigin: aPoint
	^port sourceOrigin: aPoint! !

!CTransformCanvas methodsFor: 'drawing-images' stamp: 'cyrille.delaunay 5/7/2010 10:44'!
stencil: aForm at: aPoint sourceRect: sourceRect color: aColor
	"Flood this canvas with aColor wherever stencilForm has non-zero pixels"
	| stencilForm stencilColors fill rect |
	transform isPureTranslation ifTrue:[
		^super stencil: aForm at: aPoint sourceRect: sourceRect color: aColor.
	].
	stencilForm := aForm.
	stencilForm depth > 8 "ugh, oh this is going to be slowish as hell"
		ifTrue:[stencilForm := stencilForm asFormOfDepth: 8].
	"share bits"
	stencilForm := ColorForm 
		extent: stencilForm extent 
		depth: stencilForm depth 
		bits: stencilForm bits.
	stencilColors := Array new: 1 << stencilForm depth withAll: aColor.
	stencilColors at: 1 put: Color transparent.
	stencilForm colors: stencilColors.
	fill := TweakBitmapFill new.
	fill form: stencilForm.
	fill direction: sourceRect width @ 0.
	fill normal: 0 @ sourceRect height.
	fill origin: sourceRect origin negated.
	rect := (aPoint extent: sourceRect extent) intersect: clipRect.
	(self asBalloonCanvas)
		drawRectangle: rect
		color: fill
		borderWidth: 0
		borderColor: nil.
! !

!CTransformCanvas methodsFor: 'transforming' stamp: 'ar 1/6/2004 20:53'!
transform
	^transform! !

!CTransformCanvas methodsFor: 'transforming' stamp: 'StephaneDucasse 4/15/2010 14:51'!
transform: aTransform
	"Transform the receiver by the given transform.
	Do *NOT* establish warp."
	transform := aTransform.
	origin := transform offset.
	"Update clipRect based on port's information; 
	if set afterwards we may get something a little more accurate."
	clipRect := transform globalBoundsToLocal: port clipRect! !

!CTransformCanvas methodsFor: 'transforming' stamp: 'StephaneDucasse 4/15/2010 14:51'!
transformBy: aTransform
	"Transform the receiver by the given transform.
	Do *NOT* establish warp."
	transform := transform composedWithLocal: aTransform.
	origin := transform offset.
	"Update clipRect based on port's information; 
	if set afterwards we may get something a little more accurate."
	clipRect := transform globalBoundsToLocal: port clipRect! !

!CTransformCanvas methodsFor: 'transforming' stamp: 'ar 4/27/2005 19:09'!
transformBy: aTransform clippingTo: localRect during: aBlock
	"Transform the receiver by the given transformation and apply the given clipping rectangle.
	If non-trivial, the transformation will establish a new warp."
	self pushState.
		"Install the transformation"
		self transformBy: aTransform.
		"Install a new warp if the transform affects the mapping of localRect"
		(transform isPureTranslation)
			ifFalse:[self installWarp: localRect].
		"Install transform and clip rect"
		self clipBy: localRect.
		aBlock value: self.
	self popState.! !

!CTransformCanvas methodsFor: 'transforming' stamp: ''!
transformBy: aTransform during: aBlock
	self pushState.
	[
		self transformBy: aTransform.
		aBlock value: self.
	] ensure:[self popState].! !

!CTransformCanvas methodsFor: 'transforming' stamp: 'ar 12/7/2002 22:15'!
translateBy: offset
	offset isZero ifFalse:[self transformBy: (COffsetTransform withOffset: offset)].! !

!CTransformCanvas methodsFor: 'transforming' stamp: ''!
translateBy: delta during: aBlock
	self pushState.
	self translateBy: delta.
	aBlock value: self.
	self popState.! !

!CTransformCanvas methodsFor: 'drawing-images' stamp: 'StephaneDucasse 4/15/2010 14:51'!
warpImage: aForm transform: aTransform at: extraOffset sourceRect: sourceRect cellSize: cellSize
	"Warp the given using the appropriate transform and offset."
	| tfm |
	tfm := transform composedWithLocal: aTransform.
	^self privateWarp: aForm transform: tfm at: extraOffset sourceRect: sourceRect cellSize: cellSize! !

Object subclass: #ArhensDemo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Demo'!

ArhensDemo class
	instanceVariableNames: 'canvasName'!

ArhensDemo class
	instanceVariableNames: 'canvasName'!

!ArhensDemo classSide methodsFor: 'benchmark' stamp: 'bf 7/20/2006 11:30'!
benchmarkBalloonFont
	"MessageTally spyOn: [self benchmarkBalloonFont]"

	| aString aCanvas lines totalCharacters time |

	aString := 'The quick brown fox jumps over the lazy dog'.
	lines := 200.
	totalCharacters := lines * aString size.

	aCanvas := RomeBalloonCanvas new "on: (Form extent: 500@500 depth: 32)".
	aCanvas font: (RomeTTFont family: 'Bitstream Vera Serif' style: 'Roman').
	aCanvas fontSize: (TextStyle pointsToPixels: 12).
	aCanvas selectFill: (Color black).

	aCanvas translateBy: 0@15.
	
	time := [
		1 to: lines do: [ :i | 
			aCanvas drawString: aString at: 0@15.
		].
		aCanvas finish.
	] timeToRun.

	^ 'time: ', time, 'ms (', (totalCharacters asFloat / (time / 1000) ) rounded, ' chars/sec)'.
! !

!ArhensDemo classSide methodsFor: 'benchmark' stamp: 'bf 7/21/2006 18:11'!
benchmarkFreetypeFont
	"MessageTally spyOn: [self benchmarkFreetypeFont]"

	| aString aCanvas lines totalCharacters time |

	aCanvas := RomeFreetypeCanvas new.
	aString := 'The quick brown fox jumps over the lazy dog'.

	aCanvas font: (RomeFreetypeFont family: 'Bitstream Vera Serif' style: 'Roman').
	aCanvas fontSize: 12.

	aCanvas selectNoPen.
	aCanvas selectFill: Color black.
	aCanvas translateBy: 0@15.	

	lines := 400.
	totalCharacters := lines * aString size.
	time := [
		1 to: lines do: [ :i| 
			aCanvas drawString: aString.
		].
		aCanvas finish.
	] timeToRun.

	^ 'time: ', time, 'ms (', (totalCharacters asFloat / (time / 1000) ) rounded, ' chars/sec)'.

	! !

!ArhensDemo classSide methodsFor: 'benchmark' stamp: 'bf 6/9/2006 16:15'!
benchmarkMVCFont
	"self benchmarkMVCFont"
	
	| aString lines totalCharacters time |
	aString := 'The quick brown fox jumps over the lazy dog'.
	lines := 400.
	totalCharacters := lines * aString size.
	time := [
		1 to: lines do: [ :i| 
			aString displayAt: 0@(15)	.
		].
	] timeToRun.

	^ 'time: ', time, 'ms (', (totalCharacters asFloat / (time / 1000) ) rounded, ' chars/sec)'.

	! !

!ArhensDemo classSide methodsFor: 'benchmark' stamp: 'bf 6/9/2006 16:17'!
benchmarkMorphicFont
	"self benchmarkMorphicFont"
	
	| aString lines totalCharacters time aCanvas aFont |
	aCanvas := Display getCanvas.
	aString := 'The quick brown fox jumps over the lazy dog'.
	aFont := (TextStyle named: 'Accuny') fontOfPointSize: 12.
	lines := 400.
	totalCharacters := lines * aString size.
	time := [
		1 to: lines do: [ :i| 
			aCanvas drawString: aString at: 0@(15) font: aFont color: Color black.
		].
	] timeToRun.

	^ 'time: ', time, 'ms (', (totalCharacters asFloat / (time / 1000) ) rounded, ' chars/sec)'.

	! !

!ArhensDemo classSide methodsFor: 'benchmark' stamp: 'bf 6/9/2006 16:16'!
benchmarkMorphicTTCFont
	"MessageTally spyOn: [self benchmarkMorphicTTCFont]"
	
	| aString lines totalCharacters time aCanvas aFont |
	aCanvas := Display getCanvas.
	aString := 'The quick brown fox jumps over the lazy dog'.
	aFont := (TextStyle named: 'BitstreamVeraSans') fontOfPointSize: 12.
	lines := 800.
	totalCharacters := lines * aString size.
	time := [
		1 to: lines do: [ :i| 
			aCanvas drawString: aString at: 0@(15) font: aFont color: Color black.
		].
	] timeToRun.

	^ 'time: ', time, 'ms (', (totalCharacters asFloat / (time / 1000) ) rounded, ' chars/sec)'.

	! !

!ArhensDemo classSide methodsFor: 'benchmark' stamp: 'cyrille.delaunay 4/29/2010 16:24'!
benchmarkRectFill
	"MessageTally spyOn: [self canvasClass: RomePluginCanvas; benchmarkRectFill]"

	| c time rects rect |
	Display deferUpdates: true.
	rect := 0@0 corner: 100@100.
	c := self canvasClass on: Display.
	c selectPenWidth: 2 color: Color green.
	c translateBy: 50@50.
	c scaleBy: 2@2.
	rects := 1000.
	time := [
		1 to: rects do: [ :i | 
			c selectFill: Color red.
			c drawRectangle: rect.
		].
	] timeToRun.
	c finish.
	Display deferUpdates: false.
	Display forceToScreen.

	^ 'time: ', time asString, 'ms (', (rects asFloat / (time / 1000) ) rounded asString, ' rects/sec)'.
! !

!ArhensDemo classSide methodsFor: 'accessing' stamp: 'bf 8/29/2006 19:16'!
canvasClass
	^Smalltalk at: (canvasName ifNil: [#RomeCanvas])
! !

!ArhensDemo classSide methodsFor: 'accessing' stamp: 'bf 8/29/2006 19:16'!
canvasClass: aCanvasClassOrName
	canvasName := aCanvasClassOrName isBehavior
		ifTrue: [aCanvasClassOrName name]
		ifFalse: [aCanvasClassOrName]! !

!ArhensDemo classSide methodsFor: 'demos private' stamp: 'bf 8/29/2006 19:02'!
carForm
	"(SketchMorph withForm: self carForm) openInHand"
	| f c |
	f := Form extent: 140@200 depth: 32.
	c := RomeCanvas on: f.
	c translateBy: 20@0.
	self drawCarOn: c.
	c finish.
	^f! !

!ArhensDemo classSide methodsFor: 'demos' stamp: 'jl 7/11/2006 15:36'!
demoDrawFreetypeString
	"self demoDrawFreetypeString"
	self drawFretypeStringOn: self canvasClass new! !

!ArhensDemo classSide methodsFor: 'demos' stamp: 'jl 7/11/2006 15:50'!
demoFontTest
	"self demoFontTest"
	self drawFontTestOn: self canvasClass new! !

!ArhensDemo classSide methodsFor: 'demos' stamp: 'jl 7/11/2006 14:49'!
demoGradients
	"self demoGradients"
	self drawGradientsOn: self canvasClass new! !

!ArhensDemo classSide methodsFor: 'demos' stamp: 'jl 7/11/2006 14:49'!
demoMovingCar
	"self demoMovingCar"
	self demoMovingCarOn: self canvasClass new.
! !

!ArhensDemo classSide methodsFor: 'demos private' stamp: 'bf 7/18/2006 14:56'!
demoMovingCarOn: aCanvas
	"[self demoMovingCarOn: RomePluginCanvas new] timeToRun"
	| c |
	c := aCanvas.

0 to: 3*360 by: 3 do: [:w|
	Display deferUpdates: true.
	c selectFill: Color white.
	c drawRectangle: (0@0 corner: 800@600).
	c preserveStateDuring: [
		c translateBy: 100@100.
		c rotateBy: w around: 200@200.
		c translateBy: 20@180.
		c scaleBy: ((w * 2 / 180) cos) * 0.3 + 0.4.
		self drawCarOn: c.
	].
	c finish.
	Display deferUpdates: false.
	Display forceToScreen: (0@0 corner: 800@600).
]
	! !

!ArhensDemo classSide methodsFor: 'demos private' stamp: 'cyrille.delaunay 5/5/2010 16:37'!
demoMovingCarWarp
	"[self demoMovingCarWarp] timeToRun"
	| c carForm |
	c := CTransformCanvas on: Display.
	carForm := self carForm.

0 to: 3*360 by: 3 do: [:w|
	Display deferUpdates: true.
	c fillRectangle: (0@0 corner: 800@600) color: Color white.
	c preserveStateDuring: [:cc |  
		c translateBy: 100@100.
		c translateBy: 200@200.
		c transformBy: (MatrixTransform2x3 withAngle: w).
		c translateBy: -200@-200.
		c translateBy: 20@180.
		c transformBy: (MatrixTransform2x3 withScale: ((w * 2 / 180) cos) * 0.3 + 0.4)
			clippingTo: carForm boundingBox during: 
				[:ccc | c paintImage: carForm at: 0@0].
	].
	c finish.
	Display deferUpdates: false.
	Display forceToScreen: (0@0 corner: 800@600).
]
	! !

!ArhensDemo classSide methodsFor: 'demos' stamp: 'bf 7/31/2006 17:12'!
demoRotateRome
	"self demoRotateRome"
	self demoRotateRomeOn: self canvasClass new.	! !

!ArhensDemo classSide methodsFor: 'demos private' stamp: 'bf 7/31/2006 16:45'!
demoRotateRomeOn: aCanvas
	"self demoRotateRomeOn: RomeCanvas new"

	 | c |
	c := aCanvas.
	c selectFill: Color white.
	c drawRectangle: (0@0 corner: 800@600).
	c font: (self fontFor: c family: 'Bitstream Vera Serif' style: 'Roman').
	c fontSize: 1.

	0 to: 360 by: 5 do: [:w|
		Display deferUpdates: true.
		c preserveStateDuring: [
			c translateBy: 40@160.
			c scaleBy: (w * 0.7 max: 0.01).
			c rotateBy: w around: 1.5@0.75.
			c translateBy: 0.05@1.
			c selectPenWidth: 1/c transform scale y
				color: (Color blue alpha: (1 / 360 * w)).
			c selectFill: (Color r: 1 g: (1 / 360 * w) b: 0 alpha: (1 / 360 * w)).
			c drawString: 'Rome'.
		].
		c finish.
		Display deferUpdates: false.
		Display forceToScreen: (0@0 corner: 800@600).
	]
		! !

!ArhensDemo classSide methodsFor: 'demos' stamp: 'jl 7/11/2006 14:46'!
demoRotateSophieLogo
	"self demoRotateSophieLogo"
	self demoRotateSophieLogoOn: self canvasClass new
! !

!ArhensDemo classSide methodsFor: 'demos private' stamp: 'bf 7/28/2006 12:21'!
demoRotateSophieLogoOn: aCanvas
	"self demoRotateSophieLogoOn: RomeCanvas new"

	 | c |
	c := aCanvas.
	c selectFill: Color white.
	c drawRectangle: (0@0 corner: 800@600).
	0 to: 360 by: 5 do: [:w|
		Display deferUpdates: true.
		c drawRectangle: (0@0 corner: 800@600).
		c preserveStateDuring: [
			c translateBy: 250@250.
			c rotateBy: w.
			c translateBy: -100@-100.
			self drawSophieLogoOn: c.
		].	
		Display deferUpdates: false.
		Display forceToScreen: (0@0 corner: 800@600).
	]
		! !

!ArhensDemo classSide methodsFor: 'demos' stamp: 'jl 7/11/2006 14:50'!
demoRotateWindow
	"MessageTally spyOn: [self demoRotateWindow] "
	self demoRotateWindowOn: self canvasClass new.! !

!ArhensDemo classSide methodsFor: 'demos private' stamp: 'bf 7/18/2006 18:49'!
demoRotateWindowOn: aCanvas
	"self demoRotateWindowFreetype "
	| c step |

	c := aCanvas.

	step := 15.

	0 to: 360 by: step do: [:w|
		Display deferUpdates: true.
		c saveState.
		c selectFill: Color white.
		c drawRectangle: (0@0 corner: 800@600).
		c translateBy: 100@100.
		c rotateBy: w around: 200@200.
		self drawWindowOn: c.
		c restoreState.
		c finish.
		Display deferUpdates: false.
		Display forceToScreen: (0@0 corner: 800@600).
	]
		! !

!ArhensDemo classSide methodsFor: 'demos' stamp: 'jl 7/11/2006 15:26'!
demoSophieLogo
	"self demoSophieLogo"
	self drawSophieLogoOn: self canvasClass new
! !

!ArhensDemo classSide methodsFor: 'demos' stamp: 'jl 7/11/2006 14:51'!
demoStringWheel
	"[self demoStringWheel] timeToRun"
	self drawStringWheelOn: self canvasClass new! !

!ArhensDemo classSide methodsFor: 'demos' stamp: 'jl 7/11/2006 14:52'!
demoUnicode
	"self canvasClass: RomeFreetypeCanvas.
	[self demoUnicode] timeToRun"
	self drawUnicodeOn: self canvasClass new! !

!ArhensDemo classSide methodsFor: 'draw' stamp: 'jl 8/29/2006 19:03'!
drawBitmapFillOn: aCanvas
	"self drawBitmapFillOn: RomeBalloonCanvas new"
	| c fill |
	c := aCanvas.
	c translateBy: 20@20.
	c preserveStateDuring: [
		fill := BitmapFillStyle new.
		fill form: self exampleForm1.
		fill origin: (0@0).
		fill direction: (50@0).
		fill tileFlag: true.
		c selectFill: fill asRomeFill.
		c drawRectangle: (0@0 extent: (100@100)).
	].

	c translateBy: 120@0.
	c preserveStateDuring: [
		c rotateBy: 30.		
		fill := BitmapFillStyle new.
		fill form: self exampleForm1.
		fill origin: (0@0).
		fill direction: (50@0).
		fill tileFlag: true.
		c selectFill: fill asRomeFill.
		c drawRectangle: (0@0 extent: (100@100)).
	].
	c translateBy: 120@0.
	c preserveStateDuring: [
		c scaleBy: 2.
		fill := BitmapFillStyle new.
		fill form: self exampleForm1.
		fill origin: (0@0).
		fill direction: (50@0).
		fill tileFlag: true.
		c selectFill: fill asRomeFill.
		c drawRectangle: (0@0 extent: (100@100)).
	].

	c translateBy: 300@0.
	c preserveStateDuring: [
		c rotateBy: 30.
		c scaleBy: 2.
		fill := BitmapFillStyle new.
		fill form: self exampleForm1.
		fill origin: (0@0).
		fill direction: (50@0).
		fill tileFlag: true.
		c selectFill: fill asRomeFill.
		c drawRectangle: (0@0 extent: (100@100)).
	].


	c finish.! !

!ArhensDemo classSide methodsFor: 'draw' stamp: 'bf 7/18/2006 14:49'!
drawCar
	"self drawCar"
	| c |
	c := self canvasClass new.

	c translateBy: 20@20.
	self drawCarOn: c.
	c finish.! !

!ArhensDemo classSide methodsFor: 'draw' stamp: 'alain.plantec 7/16/2009 02:38'!
drawCarOn: aCanvas
	"self drawCar"

	aCanvas selectFill: (Color r: 1.0 g: 0.0 b: 0.0).
	aCanvas selectPenWidth: 2 color: Color black.
	aCanvas drawRoundRect: (0@0 corner: 100@200) radius: 40. "body"

	aCanvas selectFill: (Color r: 0.0 g: 0.0 b: 0.1).
	aCanvas drawRoundRect: (-20@20 extent: 20@40) radius: 20. "tires"
	aCanvas drawRoundRect: (-20@140 extent: 20@40) radius: 20. "tires"

	aCanvas drawRoundRect: (100@20 extent: 20@40) radius: 20. "tires"
	aCanvas drawRoundRect: (100@140 extent: 20@40) radius: 20. "tires"


	aCanvas selectFill: (Color r: 0.0 g: 0.0 b: 1.0).
	aCanvas drawRoundRect: (5@60 extent: 90@10) radius: 5. 
! !

!ArhensDemo classSide methodsFor: 'draw' stamp: 'bf 7/31/2006 16:46'!
drawFontTestOn: aCanvas
	"self drawFontTestOn: RomeFreetypeCanvas new"

	| fontManager font rows rowHeight rowWidth |
	aCanvas selectFill: (Color white).
	aCanvas drawRectangle: (0@0 extent: 850@850).
	
	aCanvas selectPenWidth: 0 color: (Color black).
	aCanvas selectFill: (Color black).
	aCanvas translateBy: 20@20.

	fontManager := RomeFontManager default.
	aCanvas fontSize: 12.
	rows := 40.
	rowHeight := 20.
	rowWidth := 250.
	fontManager fontNames doWithIndex: [  :eachFontName :index |
		aCanvas preserveTransformDuring: [
			font := fontManager romeFont: eachFontName.
	 		aCanvas translateBy: (rowWidth * (index -1 // rows) @((index - 1\\ rows) * rowHeight)).
			aCanvas font: font.
			aCanvas drawString: eachFontName.
		].
	]. 
	aCanvas finish.


! !

!ArhensDemo classSide methodsFor: 'draw' stamp: 'jl 7/12/2006 11:42'!
drawFretypeStringOn: aCanvas
	"self drawFretypeStringOn: RomeBalloonCanvas new"
	aCanvas
		drawRectangle: (0@0 extent: 500@50);
		translateBy: 30@30;
		selectFill: (Color black alpha: 0.99);
		font: (RomeFontManager default romeFont: 'Georgia-Regular');
		fontSize: 14;
		drawString: 'The quick brown fox jumps over the lazy dog.' at: 20@0;
		finish
! !

!ArhensDemo classSide methodsFor: 'draw' stamp: 'cyrille.delaunay 5/7/2010 10:46'!
drawGradientsOn: aCanvas
	"self drawGradientsOn: RomeCanvas new"
	| c fill scale |
	c := aCanvas.
	c translateBy: 20@20.
	scale := 1.
	c preserveStateDuring: [
		c scaleBy: 1 / scale.
		c rotateBy: 20.
		fill := GradientFillStyle ramp: {0 -> Color red. 0.2 -> Color green. 1 -> Color blue}.
		fill origin: (50@50) * scale.
		fill direction: (50@0) * scale.
		fill radial: true.
		c selectFill: fill asRomeFill.
		c drawRectangle: (0@0 extent: (100@100)  * scale).
	].

	c translateBy: 100@0.
	c preserveStateDuring: [
		c rotateBy: 20.
		c selectFill: ((GradientFillStyle  colors: {Color black. Color white})
			origin: 0@0;
			direction: 100@0;
			asRomeFill).
		c drawRectangle: (0@0 extent: 100@100).
	].

	c translateBy: 100@0.
	c preserveStateDuring: [
		c rotateBy: 20.
		c selectFill: ((GradientFillStyle colors: {Color black. Color white})
			origin: 0@0;
			direction: 100@100;
			asRomeFill).
		c drawRectangle: (0@0 extent: 100@100).
	].
	c translateBy: 100@0.
	c preserveStateDuring: [
		c rotateBy: 20.
		c selectFill: ((GradientFillStyle colors: {Color black. Color white})
			origin: 30@30;
			direction: 100@100;
			asRomeFill).
		c drawRectangle: (0@0 extent: 100@100).
	].
	c translateBy: 100@0.
	c preserveStateDuring: [
		c rotateBy: 20.
		c selectFill: ((GradientFillStyle colors: {Color black. Color white})
			origin: 30@30;
			direction: 100@100;
			asRomeFill).
		c drawRectangle: (0@0 extent: 100@100).
	].
	c finish.! !

!ArhensDemo classSide methodsFor: 'draw' stamp: 'bf 7/31/2006 16:46'!
drawSophieLogoOn: aCanvas
	"self drawSophieLogoOn: RomeBalloonCanvas new"
	| scale c w red white |
	scale := 8. 
	red := Color red twiceDarker alpha: 0.99.
	white := Color white alpha: 0.99.
	c := aCanvas.
	c scaleBy: scale.
	c preserveTransformDuring: [
		c translateBy: 0.5@0.5.
		c selectFill: white.
		c selectPenWidth: 1 color: red.
		c drawRectangle: (0@0 corner: 31@31).
		c drawRectangle: (0@0 corner: 29@31).
		c drawRectangle: (0@0 corner: 27@31)].

	c selectFill: red.
	c selectNoPen.
	c drawRectangle: (0@0 corner: 16@31).

	c font: (RomeTTFont named: 'Bitstream Vera Serif').
	c fontSize: 32.

	c preserveStateDuring: [
		c selectFill: red.
		c clipRectangle: (16@0 corner: 31@31).
		c drawString: 'S' at: 5@27.5].

	c preserveStateDuring: [
		c selectFill: white.
		c clipRectangle: (0@0 corner: 16@31).
		c drawString: 'S' at: 5@27.5].

	c flush.
	w := scale * 32.
	w.! !

!ArhensDemo classSide methodsFor: 'draw' stamp: 'bf 7/19/2006 19:17'!
drawStringWheelOn: aCanvas
	"self drawStringWheelOn: RomeBalloonCanvas new"
	| c |
	c := aCanvas.
	c font: (self fontFor: c family: 'Bitstream Vera Serif' style: 'Roman').
	c selectFill: (Color white).
	c drawRectangle: (0@0 extent: 800@800).
	c translateBy: 350@350.
	c fontSize: 10.
	c selectFill: (Color black).
	0 to: 359 by: 6 do: [ :i |
		c preserveTransformDuring: [ 
			c rotateBy: i.
			c translateBy: 100@0.
			c drawString: 'The quick brown fox jumps over the lazy dog'.
"			c drawString: 'mmmmmmmmmmmmmmmmmmmmmmmmmmm'."
		]
	].
	c finish! !

!ArhensDemo classSide methodsFor: 'draw' stamp: 'bf 8/29/2006 19:14'!
drawWindow
	"self drawWindow"
	| c |
	c := self canvasClass new.

	c translateBy: 20@20.
	c rotateBy: 30.
	self drawWindowOn: c.! !

!ArhensDemo classSide methodsFor: 'draw' stamp: 'cyrille.delaunay 4/29/2010 16:21'!
drawWindowOn: aCanvas

	aCanvas selectFill: (Color r: 0.99 g: 0.99 b: 0.9).
	aCanvas selectPenWidth: 1 color: (Color black).
	aCanvas drawRectangle: (0@0 corner: 400@400). "back"

	aCanvas drawRectangle: (0@0 corner: 400@20). "title bar"

	"aCanvas font: (self fontFor: aCanvas family: 'Bitstream Vera Serif' style: 'Roman')."
	"aCanvas fontSize: 12."
	aCanvas selectNoPen.
	aCanvas selectFill: (Color black).
	aCanvas translateBy: 3@15.
	aCanvas drawString: '"Rome Demo Window"'.

	aCanvas translateBy: 0@30.
	aCanvas drawString: 'The quick brown fox jumps over the lazy dog'.

	aCanvas fontSize: 16.
	aCanvas translateBy: 0@30.
	aCanvas drawString: 'The quick brown fox jumps over the lazy dog'.

	aCanvas fontSize: 32.
	aCanvas translateBy: 0@40.
	aCanvas drawString: 'The quick brown ...'.

	aCanvas fontSize: 50.
	aCanvas translateBy: 0@50.
	aCanvas drawString: 'The quick ...'.
! !

!ArhensDemo classSide methodsFor: 'examples' stamp: 'jl 6/21/2006 09:30'!
exampleForm1
	"self exampleForm1 display"
	| form size |

	size := 100.
	form := Form  extent: size@size depth: 32.
	
	(1 to: size) do:[ :i |
		(1 to: size) do: [ :j |
			form colorAt: i@j put: (Color r: i * 1.0 / size g: j * 1.0 / size b: 0).
		].
	].
	^form! !

!ArhensDemo classSide methodsFor: 'private' stamp: 'bf 7/14/2006 14:44'!
exampleGlyphPathFor: aCanvas of: aCharacter 
	"self exampleGlyphPathFor: RomeBalloonCanvas new of: $L"
	
	| font path |

	font := self fontFor: aCanvas family: 'Bitstream Vera Sans' style: 'Roman'.

	path := aCanvas preserveStateDuring: [
		aCanvas font: font.
		aCanvas fontSize: font glyphScale.
		aCanvas makePath: [aCanvas string: aCharacter asString]].

	^path.! !

!ArhensDemo classSide methodsFor: 'fonts' stamp: 'bf 7/21/2006 18:27'!
fontFor: aCanvas family: aFamily style: aStyle
	"self fontFor: RomeFreetypeCanvas new family: 'Bitstream Vera Serif' style: 'Roman'.
	self fontFor: RomeBalloonCanvas new family: 'Bitstream Vera Serif' style: 'Roman'".

	^(aCanvas class == RomeFreetypeCanvas or: [
			aCanvas class == RomePluginCanvas and: [RomeFreetypeCanvas isBehavior]])
		ifTrue: [RomeFreetypeFont family: aFamily style: aStyle]
		ifFalse: [RomeTTFont family: aFamily style: aStyle]! !

!ArhensDemo classSide methodsFor: 'accessing' stamp: 'bf 8/29/2006 19:13'!
selectBalloonCanvas
	"self selectBalloonCanvas"
	self canvasClass: #RomeBalloonCanvas.! !

!ArhensDemo classSide methodsFor: 'accessing' stamp: 'bf 8/29/2006 19:13'!
selectFreetypeCanvas
	"self selectFreetypeCanvas"
	self canvasClass: #RomeFreetypeCanvas.! !

!ArhensDemo classSide methodsFor: 'accessing' stamp: 'bf 8/29/2006 19:13'!
selectPluginCanvas
	"self selectPluginCanvas"
	self canvasClass: #RomePluginCanvas.! !

!ArhensDemo classSide methodsFor: 'tests' stamp: 'bf 7/31/2006 16:48'!
testClipNegativeScaleOn: aCanvas
	"self testClipNegativeScaleOn: RomeBalloonCanvas new"
	
	| rect |
	aCanvas translateBy: 300@300.
	aCanvas selectFill: (Color blue alpha: 0.2).
	aCanvas selectPenWidth: 2 color: (Color red alpha: 0.5).

	rect := (30@30 extent: 150@200).
	aCanvas rotateBy: 4.

	aCanvas clipRectangle: rect.
	aCanvas drawRectangle: rect.

	aCanvas translateBy: 50@150.

	aCanvas selectFill: (Color green alpha: 0.5).

	aCanvas drawRoundRect: (0@0 extent: 300@300) radius: 30.
	aCanvas scaleBy: 1@-1.
	aCanvas drawRoundRect: (0@0 extent: 300@300) radius: 30.

	aCanvas finish.

! !

!ArhensDemo classSide methodsFor: 'tests' stamp: 'bf 7/31/2006 16:48'!
testClipPathAgainstPathOn: aCanvas
	"self testClipPathAgainstPathOn: RomeBalloonCanvas new"
	
	| pathR pathG |
	pathR := self exampleGlyphPathFor: aCanvas of: $L.
	pathG := self exampleGlyphPathFor: aCanvas of: $G.

	aCanvas translateBy: 300@300.
	aCanvas selectPenWidth: 2 color: (Color red alpha: 0.5).

	aCanvas scaleBy: 0.3@0.3.

	aCanvas clipPath: pathR.

	aCanvas selectFill: (Color blue alpha: 0.5).
	aCanvas drawPath: pathR.

	aCanvas selectFill: (Color green alpha: 0.5).
	aCanvas drawPath: pathG.

	aCanvas finish.






! !

!ArhensDemo classSide methodsFor: 'tests' stamp: 'bf 7/31/2006 16:48'!
testClipPathAgainstRectOn: aCanvas
	"self testClipPathAgainstRectOn: RomeBalloonCanvas new"
	
	| pathG rect |
	pathG := self exampleGlyphPathFor: aCanvas of: $G.

	aCanvas translateBy: 100@100.
	aCanvas selectFill: (Color blue alpha: 0.5).
	aCanvas selectPenWidth: 2 color: (Color red alpha: 0.5).

	rect := (30@30 extent: 150@200).
	aCanvas rotateBy: 4.

	aCanvas clipRectangle: rect.
	aCanvas drawRectangle: rect.

	aCanvas translateBy: 30@130.

	aCanvas scaleBy: 0.2.
	aCanvas drawPath: pathG.

	aCanvas scaleBy: 1@-1.
	aCanvas drawPath: pathG.


	aCanvas finish.

! !

!ArhensDemo classSide methodsFor: 'tests' stamp: 'bf 7/31/2006 16:48'!
testClipRoundRectAgainstRoundRectOn: aCanvas
	"self testClipRoundRectAgainstRoundRectOn: RomeBalloonCanvas new"
	
	aCanvas translateBy: 100@100.
	aCanvas selectFill: (Color blue alpha: 0.5).
	aCanvas selectPenWidth: 2 color: (Color red alpha: 0.5).
	aCanvas rotateBy: 45.
	aCanvas scaleBy: 3.
	"aCanvas clipRect: (50@50 corner: 100@100)."

	aCanvas clipPath: [
		aCanvas roundRect: (50@50 extent: 50@50) radius:  10 corners: 15.
	].

	aCanvas drawRoundRect: (25@25 extent: 50@50) radius: 20.

	aCanvas finish.

! !

!ArhensDemo classSide methodsFor: 'tests' stamp: 'bf 7/31/2006 16:48'!
testFlattenPathOn: aCanvas
	"self drawFlattenPathOn: RomeBalloonCanvas new"
	| path |

	path := self exampleGlyphPathFor: aCanvas of: $R.
	aCanvas selectFill: (Color blue alpha: 0.5).
	aCanvas selectPenWidth: 1 color: (Color red alpha: 0.9).
	aCanvas translateBy: 50@400.

	aCanvas scaleBy: 1@-1.
	aCanvas scaleBy: 0.5.
	aCanvas drawPath: path.

	aCanvas selectNoPen.
	aCanvas selectFill: (Color green alpha: 0.9).

	(path flatten: 10) do: [:eachContour | 
		eachContour do: [:eachPoint |
			aCanvas preserveTransformDuring: [	
				aCanvas translateBy: eachPoint.	
				
				aCanvas scaleBy: 7.
				aCanvas drawRectangle: (-1@-1 corner: 1@1).
			]
		]
	]! !

!ArhensDemo classSide methodsFor: 'tests' stamp: 'bf 7/31/2006 16:48'!
testHolesOn: aCanvas
	"self testHolesOn: RomeBalloonCanvas new"
	
	| |
	aCanvas translateBy: 150@150.
	aCanvas selectFill: (Color blue alpha: 0.2).
	aCanvas selectPenWidth: 2 color: (Color red alpha: 0.5).

	aCanvas drawPath: [
		aCanvas moveTo: 0@-100;
			lineTo: 100@50;
			lineTo: -100@50;
			closePath.

		aCanvas moveTo: 0@-50;
			lineTo: -50@25;
			lineTo: 50@25;
			closePath.
	].

	aCanvas finish.

! !

!ArhensDemo classSide methodsFor: 'tests' stamp: 'bf 8/29/2006 18:54'!
testImageOn: aCanvas
	"self testImageOn: RomeCanvas new"

	| form |
	form := self exampleForm1.	

	aCanvas paintImage: form.
	
	aCanvas preserveTransformDuring: [
		aCanvas translateBy: 120@0.
		aCanvas paintImage: form.
	].

	aCanvas preserveTransformDuring: [
		aCanvas translateBy: 120@120.
		aCanvas rotateBy: 45.
		aCanvas paintImage: form.
	].

	aCanvas preserveTransformDuring: [
		aCanvas translateBy: 240@0.
		aCanvas scaleBy: 3.
		aCanvas paintImage: form.
	].

	aCanvas finish.
! !

!ArhensDemo classSide methodsFor: 'tests' stamp: 'bf 7/31/2006 17:14'!
testLineWidthOn: aCanvas
	"self testLineWidthOn: RomeBalloonCanvas new"
	
	aCanvas translateBy: 150@150.
	aCanvas selectFill: (Color blue).
	aCanvas selectPenWidth: 2 color: Color red.
	
	aCanvas drawRectangle: (0@0 corner: 100@20).

	aCanvas translateBy: 0@40.
	aCanvas scaleBy: 4.
	aCanvas drawRectangle: (0@0 corner: 100@20).

	aCanvas finish.

! !

!ArhensDemo classSide methodsFor: 'tests' stamp: 'bf 7/31/2006 16:48'!
testOrientationOn: aCanvas
	"self testOrientationOn: RomeBalloonCanvas new"
	
	| |
	aCanvas translateBy: 150@150.
	aCanvas selectFill: (Color blue alpha: 0.2).
	aCanvas selectPenWidth: 2 color: (Color red alpha: 0.5).

	aCanvas rotateBy: 5.

	2 timesRepeat: [
		aCanvas drawPath: [
			aCanvas moveTo: 0@-50;
				lineTo: 50@0;
				lineTo: -50@0;
				closePath
		].

		aCanvas translateBy: 0@100.

		aCanvas drawPath: [
			aCanvas moveTo: 0@-50;
				lineTo: -50@0;
				lineTo: 50@0;
				closePath
		].
		aCanvas translateBy: 150@-100.
		aCanvas clipRectangle: (0@-200 corner: 100@200)
	].


	aCanvas selectFill: (Color green alpha: 0.5).

	aCanvas finish.

! !

!ArhensDemo classSide methodsFor: 'tests' stamp: 'jl 7/12/2006 15:53'!
testRotateClipPathAgainstRectOn: aCanvas
	"self testRotateClipPathAgainstRectOn: RomeBalloonCanvas new"
	
	aCanvas rotateBy: 10.
	self testClipPathAgainstRectOn: aCanvas.! !

!ArhensDemo classSide methodsFor: 'tests' stamp: 'bf 7/31/2006 16:49'!
testScalePenSizeOn: aCanvas
	"self testScalePenSizeOn: RomeBalloonCanvas new"

	| aScale |
	aScale := 500.

	aCanvas scaleBy: 1.0 / aScale.
	aCanvas selectPenWidth: 1 * aScale color: (Color blue alpha: 0.9).
	aCanvas selectNoFill.

	aCanvas drawRectangle: (10@10 * aScale extent: 100@100 * aScale ).
	aCanvas finish.! !

!ArhensDemo classSide methodsFor: 'tests' stamp: 'bf 8/29/2006 19:02'!
testStencilOn: aCanvas
	"self testStencilOn: RomePluginCanvas new"
	
	| img |
	img := self carForm.
	aCanvas translateBy: 30@30.
	aCanvas selectFill: (Color blue alpha: 0.5).
	aCanvas blendImage: img.
	aCanvas stencilImage: img at: 200@0.
	aCanvas stencilImage: img in: (0@250 extent: img extent / (1@2)).
	aCanvas stencilImage: img at: 200@250 sourceRect: (0@0 corner: img extent / 2).
	aCanvas stencilImage: img in: (200@400 extent: img extent / (1@2)) sourceRect: (0@0 corner: img extent / 2).
	aCanvas translateBy: 100@400.
	aCanvas rotateBy: 45.
	aCanvas scaleBy: 0.5.
	aCanvas stencilImage: img.
	aCanvas finish.

! !

Object subclass: #RomeCanvas
	instanceVariableNames: ''
	classVariableNames: 'ForceBalloonCanvas'
	poolDictionaries: ''
	category: 'Athens-Core'!

!RomeCanvas classSide methodsFor: 'subclasses' stamp: 'bf 7/24/2006 14:10'!
asConcreteCanvas
	^self isAbstract
		ifTrue: [self concreteCanvas]
		ifFalse: [self]
! !

!RomeCanvas classSide methodsFor: 'subclasses' stamp: 'bf 8/28/2006 18:56'!
concreteCanvas
	ForceBalloonCanvas == true ifFalse: [
		Smalltalk at: #RomePluginCanvas ifPresent: [:pluginCanvas | 
			pluginCanvas pluginAvailable ifTrue: [^pluginCanvas]]].
	Smalltalk at: #RomeBalloonCanvas ifPresent: [:balloonCanvas |
		^balloonCanvas].
	self error: 'no concrete rome canvas available'! !

!RomeCanvas classSide methodsFor: 'subclasses' stamp: 'bf 7/24/2006 11:04'!
isAbstract
	^self == RomeCanvas! !

!RomeCanvas classSide methodsFor: 'instance creation' stamp: 'bf 7/24/2006 14:09'!
new
	^self asConcreteCanvas on: Display! !

!RomeCanvas classSide methodsFor: 'instance creation' stamp: 'bf 7/24/2006 14:12'!
on: aForm
	^self isAbstract	
		ifTrue: [self concreteCanvas on: aForm]
		ifFalse: [super new setTarget: aForm]! !

!RomeCanvas methodsFor: 'converting' stamp: 'bf 7/25/2006 11:12'!
asRomeCanvas
	^self! !

!RomeCanvas methodsFor: 'drawing images' stamp: 'bf 7/25/2006 13:44'!
blendImage: aForm
	"Draw a translucent image with the set of parameters"
	^self blendImage: aForm at: 0@0! !

!RomeCanvas methodsFor: 'drawing images' stamp: 'bf 7/25/2006 13:44'!
blendImage: aForm at: aPoint
	"Draw a translucent image with the set of parameters"
	^self blendImage: aForm at: aPoint sourceRect: aForm boundingBox! !

!RomeCanvas methodsFor: 'drawing images' stamp: 'bf 7/28/2006 18:09'!
blendImage: aForm at: aPoint sourceRect: aRectangle
	"Draw a translucent image with the set of parameters"
	^self blendImage: aForm in: (aPoint extent: aRectangle extent) sourceRect: aRectangle! !

!RomeCanvas methodsFor: 'drawing images' stamp: 'bf 7/25/2006 13:46'!
blendImage: aForm in: destRect
	"Draw a translucent image with the set of parameters"
	^self blendImage: aForm in: destRect sourceRect: aForm boundingBox! !

!RomeCanvas methodsFor: 'drawing images' stamp: 'bf 7/25/2006 14:01'!
blendImage: aForm in: destRect sourceRect: aRectangle
	"Draw a translucent image with the set of parameters"
	^self subclassResponsibility ! !

!RomeCanvas methodsFor: 'drawing' stamp: 'bf 7/29/2006 01:39'!
clear
	"clear current clip region to selected fill"
	^self subclassResponsibility! !

!RomeCanvas methodsFor: 'attributes canvas ' stamp: 'bf 8/1/2006 00:50'!
clipRectangle: aRect
	"clip all further drawing to aRectangle"
	^self subclassResponsibility
! !

!RomeCanvas methodsFor: 'initialize-release' stamp: 'JMM 1/25/2007 21:21'!
close! !

!RomeCanvas methodsFor: 'drawing curves' stamp: 'bf 7/25/2006 14:31'!
drawArc: radius at: aPoint from: angle1 to: angle2
	"Draw an arc segment. The arc will be drawn in CW direction. 
	To reverse the direction of the arc use a negative radius"
	^self subclassResponsibility
! !

!RomeCanvas methodsFor: 'drawing curves' stamp: 'bf 7/25/2006 14:31'!
drawCurveFrom: start via: cp1 and: cp2 to: end
	"Draw a cubic bezier curve"
	^self subclassResponsibility
! !

!RomeCanvas methodsFor: 'drawing curves' stamp: 'bf 7/25/2006 14:31'!
drawCurveFrom: start via: offCurve to: end
	"Draw a quadratic bezier curve"
	^self subclassResponsibility
! !

!RomeCanvas methodsFor: 'drawing images' stamp: 'bf 7/25/2006 13:46'!
drawImage: aForm
	"Draw a fully opaque image with the set of parameters"
	^self drawImage: aForm at: 0@0! !

!RomeCanvas methodsFor: 'drawing images' stamp: 'bf 7/25/2006 13:44'!
drawImage: aForm at: aPoint
	"Draw a fully opaque image with the set of parameters"
	^self drawImage: aForm at: aPoint sourceRect: aForm boundingBox! !

!RomeCanvas methodsFor: 'drawing images' stamp: 'bf 7/28/2006 18:09'!
drawImage: aForm at: aPoint sourceRect: aRectangle
	"Draw a fully opaque image with the set of parameters"
	^self drawImage: aForm in: (aPoint extent: aRectangle extent) sourceRect: aRectangle! !

!RomeCanvas methodsFor: 'drawing images' stamp: 'bf 7/25/2006 13:51'!
drawImage: aForm in: destRect
	"Draw a fully opaque image with the set of parameters"
	^self drawImage: aForm in: destRect sourceRect: aForm boundingBox! !

!RomeCanvas methodsFor: 'drawing images' stamp: 'bf 7/25/2006 14:01'!
drawImage: aForm in: destRect sourceRect: sourceRect
	"Draw a fully opaque image with the set of parameters"
	^self subclassResponsibility ! !

!RomeCanvas methodsFor: 'drawing curves' stamp: 'bf 7/25/2006 14:32'!
drawLineFrom: startPoint to: endPoint
	"Draw a line from startPoint to endPoint."
	^self subclassResponsibility
! !

!RomeCanvas methodsFor: 'drawing shapes' stamp: 'bf 7/25/2006 14:26'!
drawOval: aRectangle
	"Draw an oval specified by the given rectangle"
	^self subclassResponsibility ! !

!RomeCanvas methodsFor: 'drawing shapes' stamp: 'bf 7/25/2006 17:51'!
drawPolygon: aCollection
	"Draw a polygon using the given set of vertices"
	^self subclassResponsibility ! !

!RomeCanvas methodsFor: 'drawing curves' stamp: 'bf 7/25/2006 17:51'!
drawPolyline: aCollection
	"Draw a polyline using the given set of vertices"
	^self subclassResponsibility
! !

!RomeCanvas methodsFor: 'drawing shapes' stamp: 'bf 7/25/2006 14:26'!
drawRectangle: aRectangle
	"Draw aRectangle."
	^self subclassResponsibility ! !

!RomeCanvas methodsFor: 'drawing shapes' stamp: 'bf 7/25/2006 14:25'!
drawRoundRect: aRectangle radius: radius
	"Draw a rounded rectangle"
	^self drawRoundRect: aRectangle radius: radius corners: 15! !

!RomeCanvas methodsFor: 'drawing shapes' stamp: 'bf 7/31/2006 14:19'!
drawRoundRect: aRectangle radius: aRadius corners: flags
	"Draw a round rectangle using the specified position and size, radius, and corners to round (sum of 1=topLeft, 2=bottomLeft, 4=bottomRight, 8=topRight)."
	^self subclassResponsibility ! !

!RomeCanvas methodsFor: 'drawing text' stamp: 'cyrille.delaunay 4/29/2010 16:22'!
drawString: aString
	"Draw a string with the given set of parameters"
	"^self drawString: aString at: 0@0"! !

!RomeCanvas methodsFor: 'drawing text' stamp: 'bf 7/25/2006 14:22'!
drawString: aString at: aPoint
	"Draw a string with the given set of parameters"
	^self drawString: aString at: aPoint from: 1 to: aString size! !

!RomeCanvas methodsFor: 'drawing text' stamp: 'bf 7/25/2006 14:23'!
drawString: aString at: aPoint from: startIndex to: stopIndex
	"Draw a string with the given set of parameters"
	^self subclassResponsibility! !

!RomeCanvas methodsFor: 'initialize-release' stamp: 'bf 8/23/2006 10:57'!
finish
	"Flushes the canvas and ensures that he effects are visible on the underlying output medium."! !

!RomeCanvas methodsFor: 'initialize-release' stamp: 'bf 8/23/2006 10:58'!
finish: aRectangle
	"Flushes the canvas and ensures that the effects in aRectangle are visible on the underlying output medium."
	^self finish! !

!RomeCanvas methodsFor: 'attributes text' stamp: 'bf 8/1/2006 00:48'!
font
	"Answer the currently selected font"
	^self subclassResponsibility! !

!RomeCanvas methodsFor: 'attributes text' stamp: 'bf 8/1/2006 00:47'!
font: aFont
	"Set the font to be used for subsequent drawing"
	^self subclassResponsibility! !

!RomeCanvas methodsFor: 'attributes text' stamp: 'bf 8/1/2006 00:49'!
fontMatrix
	"Answer the current transform for fonts"
	^self subclassResponsibility! !

!RomeCanvas methodsFor: 'attributes text' stamp: 'bf 8/1/2006 00:47'!
fontMatrix: aTransform
	"Set the matrix transforming from font design units to user space.
	Normally this is just a scale (via fontSize) but can be overridden
	to achieve shearing and other effects."
	^self subclassResponsibility! !

!RomeCanvas methodsFor: 'attributes text' stamp: 'bf 8/1/2006 00:49'!
fontSize
	"Answer the currently selected font size."
	^self subclassResponsibility! !

!RomeCanvas methodsFor: 'attributes text' stamp: 'bf 8/1/2006 00:48'!
fontSize: aNumber
	"Select a new font size."
	^self subclassResponsibility! !

!RomeCanvas methodsFor: 'drawing text' stamp: 'bf 7/25/2006 14:24'!
measureString: aString
	"Measure the extent of aString."
	^self measureString: aString from: 1 to: aString size! !

!RomeCanvas methodsFor: 'drawing text' stamp: 'bf 7/25/2006 14:24'!
measureString: aString from: startIndex to: stopIndex
	"Measure the extent of aString."
	^self subclassResponsibility! !

!RomeCanvas methodsFor: 'drawing images' stamp: 'bf 7/25/2006 13:51'!
paintImage: aForm
	"Draw a color keyed image with the set of parameters"
	^self paintImage: aForm at: 0@0! !

!RomeCanvas methodsFor: 'drawing images' stamp: 'bf 7/25/2006 13:51'!
paintImage: aForm at: aPoint
	"Draw a color keyed image with the set of parameters"
	^self paintImage: aForm at: aPoint sourceRect: aForm boundingBox! !

!RomeCanvas methodsFor: 'drawing images' stamp: 'bf 7/28/2006 18:08'!
paintImage: aForm at: aPoint sourceRect: aRectangle
	"Draw a color keyed image with the set of parameters"
	^self paintImage: aForm in: (aPoint extent: aRectangle extent) sourceRect: aRectangle! !

!RomeCanvas methodsFor: 'drawing images' stamp: 'bf 7/25/2006 13:52'!
paintImage: aForm in: destRect
	"Draw a color keyed image with the set of parameters"
	^self paintImage: aForm in: destRect sourceRect: aForm boundingBox! !

!RomeCanvas methodsFor: 'drawing images' stamp: 'bf 7/25/2006 14:02'!
paintImage: aForm in: destRect sourceRect: aRectangle
	"Draw a color keyed image with the set of parameters"
	^self subclassResponsibility ! !

!RomeCanvas methodsFor: 'preserve state' stamp: 'bf 8/1/2006 00:45'!
preserveStateDuring: aBlock
	"Restore all attributes after evaluating aBlock"
	^self subclassResponsibility! !

!RomeCanvas methodsFor: 'preserve state' stamp: 'bf 8/1/2006 00:45'!
preserveTransformDuring: aBlock
	"Restore transform after evaluating aBlock"
	^self subclassResponsibility! !

!RomeCanvas methodsFor: 'transforming' stamp: 'bf 7/25/2006 14:34'!
rotateBy: angle
	"Rotate all further drawing operations by angle"
	^self subclassResponsibility
! !

!RomeCanvas methodsFor: 'transforming' stamp: 'bf 7/25/2006 14:34'!
rotateBy: angle around: center
	"Rotate all further drawing operations by angle around center"
	^self
		translateBy: center;
		rotateBy: angle;
		translateBy: center negated! !

!RomeCanvas methodsFor: 'transforming' stamp: 'bf 7/25/2006 14:34'!
scaleBy: scale
	"Scale all further drawing operations by scale"
	^self subclassResponsibility
! !

!RomeCanvas methodsFor: 'attributes canvas ' stamp: 'bf 8/1/2006 00:43'!
selectFill: aFill
	"Select the fill to use to use for subsequent drawing.
	This is a write-only operation."
	^self subclassResponsibility! !

!RomeCanvas methodsFor: 'attributes canvas ' stamp: 'bf 8/1/2006 00:44'!
selectNoFill
	"Do not fill shapes"
	^self subclassResponsibility! !

!RomeCanvas methodsFor: 'attributes canvas ' stamp: 'bf 7/31/2006 17:15'!
selectNoPen
	"Do not draw outlines of shapes"
	^self subclassResponsibility
! !

!RomeCanvas methodsFor: 'attributes canvas ' stamp: 'bf 7/31/2006 16:42'!
selectPenWidth: aNumber color: aColor
	"select a solid Pen of width and color"
	^self subclassResponsibility
! !

!RomeCanvas methodsFor: 'drawing images' stamp: 'bf 7/28/2006 18:34'!
stencilImage: aForm
	"Paint selected fill wherever aForm is non-transparent"
	^self stencilImage: aForm at: 0@0! !

!RomeCanvas methodsFor: 'drawing images' stamp: 'bf 7/28/2006 18:34'!
stencilImage: aForm at: aPoint
	"Paint selected fill wherever aForm is non-transparent"
	^self stencilImage: aForm at: aPoint sourceRect: aForm boundingBox! !

!RomeCanvas methodsFor: 'drawing images' stamp: 'bf 7/28/2006 18:34'!
stencilImage: aForm at: aPoint sourceRect: aRectangle
	"Paint selected fill wherever aForm is non-transparent"
	^self stencilImage: aForm in: (aPoint extent: aRectangle extent) sourceRect: aRectangle! !

!RomeCanvas methodsFor: 'drawing images' stamp: 'bf 7/28/2006 18:34'!
stencilImage: aForm in: destRect
	"Paint selected fill wherever aForm is non-transparent"
	^self stencilImage: aForm in: destRect sourceRect: aForm boundingBox
! !

!RomeCanvas methodsFor: 'drawing images' stamp: 'bf 7/28/2006 18:34'!
stencilImage: aForm in: destRect sourceRect: aRectangle
	"Paint selected fill wherever aForm is non-transparent"
	^self subclassResponsibility ! !

!RomeCanvas methodsFor: 'transforming' stamp: 'bf 7/25/2006 14:35'!
transform
	"Answer the currently selected transform"
	^self subclassResponsibility
! !

!RomeCanvas methodsFor: 'transforming' stamp: 'bf 7/25/2006 14:35'!
transform: aTransform
	"Set the transform to be used for subsequent drawing"
	^self subclassResponsibility
! !

!RomeCanvas methodsFor: 'transforming' stamp: 'bf 7/25/2006 14:35'!
transformBy: aTransform
	"Transform all further drawing operations by aTransform"
	^self subclassResponsibility
! !

!RomeCanvas methodsFor: 'transforming' stamp: 'bf 7/25/2006 14:35'!
translateBy: offset
	"Offset all further drawing operations by offset"
	^self subclassResponsibility
! !

RomeCanvas subclass: #RomePluginCanvas
	instanceVariableNames: 'handle target flags strokeColor stack font fontSize fontMatrix currentFillColor currentBlackColor glyphAccuracy cachedGlyphBlt cachedClearBlt drawRunPositions drawRunGlyph drawRunPointY'
	classVariableNames: 'FlagFill FlagStroke Registry'
	poolDictionaries: ''
	category: 'Athens-PluginCanvas'!

!RomePluginCanvas commentStamp: '<historical>' prior: 0!
INST VAR ORDER IS KNOWN TO PLUGIN!! DO NOT REARRANGE!!
handle: index in plugin's contexts array, nil if closed
target: RomePluginTargetForm
flags:
	bits 0 to 7 = stroke alpha (0 = no stroke)
	bit 8 = do fill
strokeColor: rgb of stroke color (10 bits per component)!

!RomePluginCanvas classSide methodsFor: 'accessing' stamp: 'jl 9/6/2006 12:35'!
expectedPluginVersion
	"Automatically generated"
	^30! !

!RomePluginCanvas classSide methodsFor: 'accessing' stamp: 'jl 9/6/2006 12:35'!
expectedPluginVersion: aNumber
	"self expectedPluginVersion: 30"
	self expectedPluginVersion = aNumber ifFalse: [
		self class compile: 'expectedPluginVersion
	"Automatically generated"
	^', aNumber asString].! !

!RomePluginCanvas classSide methodsFor: 'class initialization' stamp: 'bf 7/17/2006 19:25'!
initialize
	"self initialize"
	Smalltalk addToShutDownList: self.

	FlagStroke := 255. "stores privateAlpha"
	FlagFill := 1 << 8.
! !

!RomePluginCanvas classSide methodsFor: 'testing' stamp: 'bf 6/26/2006 15:33'!
pluginAvailable
	^self primPluginVersion > 0! !

!RomePluginCanvas classSide methodsFor: 'accessing' stamp: 'bf 7/31/2006 12:02'!
pluginVersion
	^self primPluginVersion! !

!RomePluginCanvas classSide methodsFor: 'accessing' stamp: 'bf 7/31/2006 12:07'!
pluginVersionName
	self pluginAvailable
		ifTrue: [^Smalltalk listLoadedModules
			detect: [:ea | ea beginsWith: 'RomePlugin ']
			ifNone: ['<error finding plugin>']].
	^'<plugin not available>'! !

!RomePluginCanvas classSide methodsFor: 'accessing' stamp: 'bf 6/26/2006 15:33'!
primPluginVersion
	<primitive: 'primitivePluginVersion' module: 'RomePlugin'>
	^0! !

!RomePluginCanvas classSide methodsFor: 'registry' stamp: 'bf 6/30/2006 15:23'!
register: anObject
	WeakArray isFinalizationSupported ifFalse:[^anObject].
	self registry add: anObject! !

!RomePluginCanvas classSide methodsFor: 'registry' stamp: 'bf 6/30/2006 15:24'!
registry
	WeakArray isFinalizationSupported ifFalse:[^nil].
	^Registry isNil
		ifTrue:[Registry := WeakRegistry new]
		ifFalse:[Registry].! !

!RomePluginCanvas classSide methodsFor: 'system shutdown' stamp: 'bf 7/7/2006 12:13'!
shutDown
	self allSubInstancesDo: [:each | each shutDown].
	RomePluginForm allSubInstancesDo: [:each | each shutDown].! !

!RomePluginCanvas classSide methodsFor: 'registry' stamp: 'bf 6/30/2006 15:23'!
unregister: anObject
	WeakArray isFinalizationSupported ifFalse:[^anObject].
	self registry remove: anObject ifAbsent:[]! !

!RomePluginCanvas methodsFor: 'finalization' stamp: 'bf 7/3/2006 15:58'!
actAsExecutor
	target := nil.! !

!RomePluginCanvas methodsFor: 'private' stamp: 'bf 7/25/2006 17:28'!
arrayFromPoints: aCollection
	| array pt |
	array := FloatArray new: aCollection size * 2.
	1 to: aCollection size do: [:i |
		pt := aCollection at: i.
		array at: 2 * i - 1 put: pt x.
		array at: 2 * i put: pt y].
	^array! !

!RomePluginCanvas methodsFor: 'drawing' stamp: 'bf 7/25/2006 15:05'!
blendImage: aForm in: destRect sourceRect: srcRect
	^self drawImage: aForm in: destRect sourceRect: srcRect! !

!RomePluginCanvas methodsFor: 'drawing' stamp: 'bf 7/29/2006 01:49'!
clear
	"clear current clip region to selected fill"
	self primClear! !

!RomePluginCanvas methodsFor: 'attributes canvas' stamp: 'bf 7/24/2006 16:39'!
clipRectangle: aRectangle
	^self primClipRectangleLeft: aRectangle left asFloat
		right: aRectangle right asFloat
		top: aRectangle top asFloat
		bottom: aRectangle bottom asFloat
! !

!RomePluginCanvas methodsFor: 'initialize-release' stamp: 'bf 7/7/2006 16:16'!
close
	handle ifNotNil: [
		self primClose.
		self unregister.
		target ifNotNil: [target hibernate]
	].

! !

!RomePluginCanvas methodsFor: 'drawing' stamp: 'bf 7/24/2006 17:01'!
drawArc: radius at: aPoint from: angle1 to: angle2
	^self primDrawArc: radius asFloat
		x: aPoint x asFloat
		y: aPoint y asFloat
		from: angle1 degreesToRadians 
		to: angle2 degreesToRadians! !

!RomePluginCanvas methodsFor: 'drawing' stamp: 'bf 7/24/2006 17:50'!
drawCurveFrom: start via: cp1 and: cp2 to: end
	^self primDrawCurveFromX: start x asFloat y: start y asFloat
		viaX: cp1 x asFloat y: cp1 y asFloat
		andX: cp2 x asFloat y: cp2 y asFloat
		toX: end x asFloat y: end y asFloat! !

!RomePluginCanvas methodsFor: 'drawing' stamp: 'bf 7/24/2006 17:59'!
drawCurveFrom: start via: via to: end
	^self primDrawCurveFromX: start x asFloat y: start y asFloat
		viaX: via x asFloat y: via y asFloat
		toX: end x asFloat y: end y asFloat! !

!RomePluginCanvas methodsFor: 'drawing' stamp: 'bf 7/31/2006 14:44'!
drawGeneralBezierShape: contours
	self primDrawGeneralBezierShape: contours! !

!RomePluginCanvas methodsFor: 'drawing' stamp: 'jl 9/6/2006 11:19'!
drawImage: aForm in: destRect sourceRect: srcRect
	aForm asRomePluginSourceFormDuring: [ :f |
		self primDrawImage: f
			destLeft: destRect left asFloat
			right: destRect right asFloat
			top: destRect top asFloat
			bottom: destRect bottom asFloat
			srcLeft: srcRect left asFloat
			right: srcRect right asFloat
			top: srcRect top asFloat
			bottom: srcRect bottom asFloat]
! !

!RomePluginCanvas methodsFor: 'drawing' stamp: 'bf 7/24/2006 16:41'!
drawLineFrom: startPoint to: endPoint
	^self primDrawLineFromX: startPoint x asFloat
		y: startPoint y asFloat
		toX: endPoint x asFloat
		y: endPoint y asFloat! !

!RomePluginCanvas methodsFor: 'drawing' stamp: 'bf 7/24/2006 18:16'!
drawOval: aRectangle
	^self primDrawOvalLeft: aRectangle left asFloat
		right: aRectangle right asFloat
		top: aRectangle top asFloat
		bottom: aRectangle bottom asFloat
! !

!RomePluginCanvas methodsFor: 'drawing' stamp: 'bf 7/25/2006 17:23'!
drawPolygon: aCollection
	"Draw a polygon using the given set of vertices"
	^self primDrawPolygon: (self arrayFromPoints: aCollection) ! !

!RomePluginCanvas methodsFor: 'drawing' stamp: 'bf 7/25/2006 17:29'!
drawPolyline: aCollection
	"Draw a polyline using the given set of vertices"
	^self primDrawPolyline: (self arrayFromPoints: aCollection) ! !

!RomePluginCanvas methodsFor: 'drawing' stamp: 'bf 7/17/2006 17:57'!
drawRectangle: aRectangle
	^self primDrawRectangleLeft: aRectangle left asFloat
		right: aRectangle right asFloat
		top: aRectangle top asFloat
		bottom: aRectangle bottom asFloat
! !

!RomePluginCanvas methodsFor: 'drawing' stamp: 'bf 7/18/2006 12:17'!
drawRoundRect: aRectangle radius: radius corners: corners
	^self primDrawRoundRectLeft: aRectangle left asFloat
		right: aRectangle right asFloat
		top: aRectangle top asFloat
		bottom: aRectangle bottom asFloat
		radius: radius asFloat
		corners: corners! !

!RomePluginCanvas methodsFor: 'drawing' stamp: 'bf 7/31/2006 15:53'!
drawString: aString at: aPoint from: start to: end
	^font render: aString at: aPoint from: start to: end on: self! !

!RomePluginCanvas methodsFor: 'private' stamp: 'mir 1/6/2007 15:07'!
drawUTF8String: utf8String
	"selected font is a RomeFreetypeFont, render directly"
	(flags anyMask: FlagStroke)
		ifTrue: [self primDrawZeroTerminatedUtf8String: utf8String x: 0.0 y: 0.0]
		ifFalse: [self primShowZeroTerminatedUtf8String: utf8String x:0.0 y: 0.0]
! !

!RomePluginCanvas methodsFor: 'private' stamp: 'mir 1/6/2007 15:20'!
drawUTF8String: utf8String at: offset
	"selected font is a RomeFreetypeFont, render directly"
	(flags anyMask: FlagStroke)
		ifTrue: [self primDrawZeroTerminatedUtf8String: utf8String x: offset x asFloat y: offset y asFloat]
		ifFalse: [self primShowZeroTerminatedUtf8String: utf8String x: offset x asFloat y: offset y asFloat]
! !

!RomePluginCanvas methodsFor: 'finalization' stamp: 'bf 7/17/2006 20:02'!
finalize
	self isExecutor ifFalse: [self error: 'finalize called on non-executor'].
	self close.
! !

!RomePluginCanvas methodsFor: 'initialize-release' stamp: 'JMM 1/25/2007 21:45'!
finish
	self flush.
	self close! !

!RomePluginCanvas methodsFor: 'initialize-release' stamp: 'bf 8/23/2006 11:16'!
finish: aRectangle
	self flush: aRectangle! !

!RomePluginCanvas methodsFor: 'initialize-release' stamp: 'bf 7/7/2006 13:36'!
flush
	target flush! !

!RomePluginCanvas methodsFor: 'initialize-release' stamp: 'bf 8/23/2006 11:12'!
flush: aRectangle
	target flush: aRectangle! !

!RomePluginCanvas methodsFor: 'attributes canvas' stamp: 'bf 7/19/2006 14:56'!
font: aRomeFont
	font := aRomeFont.
	(aRomeFont isKindOf: RomeFreetypeFont)
		ifTrue: [self primFontFace: aRomeFont face handle].
! !

!RomePluginCanvas methodsFor: 'attributes canvas' stamp: 'bf 8/28/2006 19:14'!
fontMatrix
	^fontMatrix ifNil: [fontMatrix := self matrixClass withScale: fontSize]! !

!RomePluginCanvas methodsFor: 'attributes canvas' stamp: 'bf 7/19/2006 14:03'!
fontMatrix: aTransform
	fontMatrix := aTransform.
	fontSize := nil.
	"self primFontMatrix: aTransform asMatrixTransform2x3"! !

!RomePluginCanvas methodsFor: 'attributes canvas' stamp: 'bf 7/19/2006 14:01'!
fontSize
	^fontSize ifNil: [fontSize := fontMatrix scale y]! !

!RomePluginCanvas methodsFor: 'attributes canvas' stamp: 'bf 7/19/2006 13:59'!
fontSize: aNumber
	fontSize := aNumber.
	fontMatrix := nil.
	self primFontSize: aNumber asFloat! !

!RomePluginCanvas methodsFor: 'private' stamp: 'bf 7/21/2006 18:20'!
ftString: aString at: aPoint from: start to: end
	"selected font is a RomeFreetypeFont, render directly"
	| utf8String converter |
	converter := UTF8TextConverter new.
	utf8String := String streamContents: [:stream | 
		start to: end do: [:i | 
			converter nextPut: (aString at: i) toStream: stream].
		stream nextPut: (Character value: 0)].
	(flags anyMask: FlagStroke)
		ifTrue: [self primDrawZeroTerminatedUtf8String: utf8String x: aPoint x asFloat y: aPoint y asFloat]
		ifFalse: [self primShowZeroTerminatedUtf8String: utf8String x: aPoint x asFloat y: aPoint y asFloat]
! !

!RomePluginCanvas methodsFor: 'initialize-release' stamp: 'bf 7/17/2006 18:36'!
initialize
	super initialize.
	flags := 0.! !

!RomePluginCanvas methodsFor: 'finalization' stamp: 'bf 7/3/2006 15:55'!
isExecutor
	^target isNil! !

!RomePluginCanvas methodsFor: 'private' stamp: 'bf 8/28/2006 19:13'!
matrixClass
	^Smalltalk at: #CMatrixTransform ifAbsent: [MatrixTransform2x3]! !

!RomePluginCanvas methodsFor: 'initialize-release' stamp: 'bf 7/7/2006 12:14'!
open
	handle ifNil: [
		target unhibernate.
		self primOpen.
		self register.
	].
! !

!RomePluginCanvas methodsFor: 'drawing' stamp: 'bf 7/25/2006 15:05'!
paintImage: aForm in: destRect sourceRect: srcRect
	^self drawImage: aForm in: destRect sourceRect: srcRect! !

!RomePluginCanvas methodsFor: 'state' stamp: 'bf 7/18/2006 12:31'!
preserveStateDuring: aBlock
	self saveState.
	^aBlock ensure: [self restoreState].
! !

!RomePluginCanvas methodsFor: 'transforming' stamp: 'mir 1/5/2007 17:54'!
preserveTransformDuring: aBlock
	"Reset transform after evaluating aBlock"
	| oldTransform |
	oldTransform := self transform.
	aBlock value.
	self transform: oldTransform! !

!RomePluginCanvas methodsFor: 'primitives' stamp: 'bf 7/29/2006 01:50'!
primClear
	<primitive: 'primitiveClear' module: 'RomePlugin'>
	^self primitiveOpenAndRetry
! !

!RomePluginCanvas methodsFor: 'primitives' stamp: 'bf 7/24/2006 16:39'!
primClipRectangleLeft: left right: right top: top bottom: bottom
	<primitive: 'primitiveClipRectangleLeftRightTopBottom' module: 'RomePlugin'>
	^self primitiveOpenAndRetry
! !

!RomePluginCanvas methodsFor: 'primitives' stamp: 'bf 7/3/2006 15:53'!
primClose
	"ok to fail"
	<primitive: 'primitiveClose' module: 'RomePlugin'>
	handle := nil.
! !

!RomePluginCanvas methodsFor: 'primitives' stamp: 'bf 7/24/2006 16:58'!
primDrawArc: radius x: x y: y from: angle1 to: angle2
	<primitive: 'primitiveDrawArcRadiusXYFromTo' module: 'RomePlugin'>
	^self primitiveOpenAndRetry
! !

!RomePluginCanvas methodsFor: 'primitives' stamp: 'bf 7/24/2006 17:18'!
primDrawCurveFromX: x0 y: y0 viaX: x1 y: y1 andX: x2 y: y2 toX: x3 y: y3
	<primitive: 'primitiveDrawCurveFromXYviaXYandXYtoXY' module: 'RomePlugin'>
	^self primitiveOpenAndRetry
! !

!RomePluginCanvas methodsFor: 'primitives' stamp: 'bf 7/24/2006 18:04'!
primDrawCurveFromX: x0 y: y0 viaX: x1 y: y1 toX: x3 y: y3
	<primitive: 'primitiveDrawCurveFromXYviaXYtoXY' module: 'RomePlugin'>
	^self primitiveOpenAndRetry
! !

!RomePluginCanvas methodsFor: 'primitives' stamp: 'bf 7/19/2006 14:58'!
primDrawGeneralBezierShape: arrayOfPointArrays
	<primitive: 'primitiveDrawGeneralBezierShape' module: 'RomePlugin'>
	^self primitiveOpenAndRetry
! !

!RomePluginCanvas methodsFor: 'primitives' stamp: 'bf 7/25/2006 14:55'!
primDrawImage: aForm destLeft: dstL right: dstR top: dstT bottom: dstB srcLeft: srcL right: srcR top: srcT bottom: srcB
	<primitive: 'primitiveDrawImageSrcLRTBDestLRTB' module: 'RomePlugin'>
	^self primitiveOpenAndRetry
! !

!RomePluginCanvas methodsFor: 'primitives' stamp: 'bf 7/24/2006 16:42'!
primDrawLineFromX: fromX y: fromY toX: toX y: toY
	<primitive: 'primitiveDrawLineFromXYtoXY' module: 'RomePlugin'>
	^self primitiveOpenAndRetry
! !

!RomePluginCanvas methodsFor: 'primitives' stamp: 'bf 7/24/2006 18:17'!
primDrawOvalLeft: left right: right top: top bottom: bottom
	<primitive: 'primitiveDrawOvalLeftRightTopBottom' module: 'RomePlugin'>
	^self primitiveOpenAndRetry
! !

!RomePluginCanvas methodsFor: 'primitives' stamp: 'bf 7/25/2006 17:31'!
primDrawPolygon: aFloatArray
	<primitive: 'primitiveDrawPolygon' module: 'RomePlugin'>
	^self primitiveOpenAndRetry
! !

!RomePluginCanvas methodsFor: 'primitives' stamp: 'bf 7/25/2006 17:31'!
primDrawPolyline: aFloatArray
	<primitive: 'primitiveDrawPolyline' module: 'RomePlugin'>
	^self primitiveOpenAndRetry
! !

!RomePluginCanvas methodsFor: 'primitives' stamp: 'bf 7/17/2006 17:08'!
primDrawRectangleLeft: left right: right top: top bottom: bottom
	<primitive: 'primitiveDrawRectangleLeftRightTopBottom' module: 'RomePlugin'>
	^self primitiveOpenAndRetry
! !

!RomePluginCanvas methodsFor: 'primitives' stamp: 'bf 7/18/2006 12:20'!
primDrawRoundRectLeft: left right: right top: top bottom: bottom radius: radius corners: corners
	<primitive: 'primitiveDrawRoundRectLeftRightTopBottomRadiusCorner' module: 'RomePlugin'>
	^self primitiveOpenAndRetry
! !

!RomePluginCanvas methodsFor: 'primitives' stamp: 'bf 7/18/2006 18:26'!
primDrawZeroTerminatedUtf8String: utf8String
	<primitive: 'primitiveDrawZeroTerminatedUtf8String' module: 'RomePlugin'>
	^self primitiveOpenAndRetry
! !

!RomePluginCanvas methodsFor: 'primitives' stamp: 'bf 7/18/2006 18:56'!
primDrawZeroTerminatedUtf8String: utf8String x: x y: y
	<primitive: 'primitiveDrawZeroTerminatedUtf8StringXY' module: 'RomePlugin'>
	^self primitiveOpenAndRetry
! !

!RomePluginCanvas methodsFor: 'primitives' stamp: 'jl 9/6/2006 11:43'!
primFillBitmapOriginX: x0 y: y0 directionX: x1 y: y1 normalX: x2 y: y2 repeat: aBoolean image: aForm
	<primitive: 'primitiveFillBitmapOriginXYdirectionXYnormalXYRepeatImage' module: 'RomePlugin'>
	^self primitiveOpenAndRetry
! !

!RomePluginCanvas methodsFor: 'primitives' stamp: 'bf 7/17/2006 19:45'!
primFillColor: rgbInt alpha: alphaInt
	<primitive: 'primitiveFillColorAlpha' module: 'RomePlugin'>
	^self primitiveOpenAndRetry
! !

!RomePluginCanvas methodsFor: 'primitives' stamp: 'bf 7/28/2006 14:39'!
primFillLinearGradientOriginX: x0 y: y0 directionX: x1 y: y1 colorStops: aWordArray
	<primitive: 'primitiveFillLinearOriginXYdirectionXYcolorStops' module: 'RomePlugin'>
	^self primitiveOpenAndRetry
! !

!RomePluginCanvas methodsFor: 'primitives' stamp: 'bf 7/28/2006 15:19'!
primFillRadialGradientOriginX: x0 y: y0 directionX: x1 y: y1 colorStops: aWordArray
	<primitive: 'primitiveFillRadialOriginXYdirectionXYcolorStops' module: 'RomePlugin'>
	^self primitiveOpenAndRetry
! !

!RomePluginCanvas methodsFor: 'primitives' stamp: 'jl 9/5/2006 17:53'!
primFillRadialGradientOriginX: x0 y: y0 directionX: x1 y: y1 normalX: x2 y: y2 colorStops: aWordArray
	<primitive: 'primitiveFillRadialOriginXYdirectionXYnormalXYcolorStops' module: 'RomePlugin'>
	^self primitiveOpenAndRetry
! !

!RomePluginCanvas methodsFor: 'primitives' stamp: 'bf 7/18/2006 18:28'!
primFontFace: aFT2Handle
	<primitive: 'primitiveFontFace' module: 'RomePlugin'>
	^self primitiveOpenAndRetry
! !

!RomePluginCanvas methodsFor: 'primitives' stamp: 'bf 7/18/2006 18:29'!
primFontSize: aFloat
	<primitive: 'primitiveFontSize' module: 'RomePlugin'>
	^self primitiveOpenAndRetry
! !

!RomePluginCanvas methodsFor: 'primitives' stamp: 'bf 7/19/2006 18:28'!
primGetLineWidth
	<primitive: 'primitiveGetLineWidth' module: 'RomePlugin'>
	^self primitiveOpenAndRetry
! !

!RomePluginCanvas methodsFor: 'primitives' stamp: 'bf 7/17/2006 21:35'!
primGetTransform: aMatrixTransform
	<primitive: 'primitiveGetTransform' module: 'RomePlugin'>
	^self primitiveOpenAndRetry
! !

!RomePluginCanvas methodsFor: 'primitives' stamp: 'bf 7/3/2006 12:29'!
primOpen
	<primitive: 'primitiveOpen' module: 'RomePlugin'>
	^self primitiveFailed! !

!RomePluginCanvas methodsFor: 'primitives' stamp: 'bf 7/18/2006 12:32'!
primRestoreState
	<primitive: 'primitiveRestoreState' module: 'RomePlugin'>
	^self primitiveOpenAndRetry
! !

!RomePluginCanvas methodsFor: 'primitives' stamp: 'bf 7/17/2006 20:34'!
primRotateBy: angle
	<primitive: 'primitiveRotateBy' module: 'RomePlugin'>
	^self primitiveOpenAndRetry
! !

!RomePluginCanvas methodsFor: 'primitives' stamp: 'bf 7/18/2006 12:32'!
primSaveState
	<primitive: 'primitiveSaveState' module: 'RomePlugin'>
	^self primitiveOpenAndRetry
! !

!RomePluginCanvas methodsFor: 'primitives' stamp: 'bf 7/17/2006 20:48'!
primScaleByX: x y: y
	<primitive: 'primitiveScaleBy' module: 'RomePlugin'>
	^self primitiveOpenAndRetry
! !

!RomePluginCanvas methodsFor: 'primitives' stamp: 'bf 7/19/2006 18:27'!
primSetLineWidth: aFloat
	<primitive: 'primitiveSetLineWidth' module: 'RomePlugin'>
	^self primitiveOpenAndRetry
! !

!RomePluginCanvas methodsFor: 'primitives' stamp: 'bf 7/17/2006 21:35'!
primSetTransform: aMatrixTransform
	<primitive: 'primitiveSetTransform' module: 'RomePlugin'>
	^self primitiveOpenAndRetry
! !

!RomePluginCanvas methodsFor: 'primitives' stamp: 'bf 7/21/2006 15:16'!
primShowZeroTerminatedUtf8String: utf8String x: x y: y
	"ignores pen"
	<primitive: 'primitiveShowZeroTerminatedUtf8StringXY' module: 'RomePlugin'>
	^self primitiveOpenAndRetry
! !

!RomePluginCanvas methodsFor: 'primitives' stamp: 'bf 7/28/2006 17:48'!
primStencilImage: aForm destLeft: dstL right: dstR top: dstT bottom: dstB srcLeft: srcL right: srcR top: srcT bottom: srcB
	<primitive: 'primitiveStencilImageSrcLRTBDestLRTB' module: 'RomePlugin'>
	^self primitiveOpenAndRetry
! !

!RomePluginCanvas methodsFor: 'primitives' stamp: 'bf 7/17/2006 21:10'!
primTransformBy: aMatrixTransform
	<primitive: 'primitiveTransformBy' module: 'RomePlugin'>
	^self primitiveOpenAndRetry
! !

!RomePluginCanvas methodsFor: 'primitives' stamp: 'bf 7/17/2006 20:37'!
primTranslateByX: x y: y
	<primitive: 'primitiveTranslateBy' module: 'RomePlugin'>
	^self primitiveOpenAndRetry
! !

!RomePluginCanvas methodsFor: 'primitives' stamp: 'bf 7/17/2006 19:47'!
primitiveOpenAndRetry
	"A primitive failed. Try to fix the receiver by opening it and retry."
	handle ifNotNil: [^self primitiveFailed].
	self open.
	handle ifNil: [^self primitiveFailed].
	^self primitiveRetry: thisContext sender.
! !

!RomePluginCanvas methodsFor: 'primitives' stamp: 'bf 7/7/2006 17:44'!
primitiveRetry: aContext
	"send the message that activated aContext again"
	^aContext receiver
		perform: aContext selector
		withArguments: ((1 to: aContext selector numArgs)
			collect: [:i | aContext at: i])! !

!RomePluginCanvas methodsFor: 'debug' stamp: 'bf 7/7/2006 13:40'!
printOn: aStream
	aStream nextPutAll: self class name.
	aStream nextPut: $(.
	self isExecutor
		ifTrue: [handle
			ifNotNil: [aStream nextPutAll: 'finalizer for #'; print: handle]
			ifNil: [aStream nextPutAll: 'finalized']]
		ifFalse: [handle
			ifNil: [aStream nextPutAll: 'closed']
			ifNotNil: [aStream nextPut: $#; print: handle].
			aStream nextPutAll: ' on '; print: target].
	aStream nextPut: $)
	! !

!RomePluginCanvas methodsFor: 'private' stamp: 'bf 7/25/2006 13:21'!
privateTargetForm
	^target privateTarget! !

!RomePluginCanvas methodsFor: 'finalization' stamp: 'bf 6/30/2006 15:26'!
register
	^self class register: self! !

!RomePluginCanvas methodsFor: 'state' stamp: 'bf 7/18/2006 12:30'!
restoreState
	"Restore the state from the internal stack"
	self copyFrom: stack.
	self primRestoreState.! !

!RomePluginCanvas methodsFor: 'transforming' stamp: 'bf 7/17/2006 22:19'!
rotateBy: angle
	^self primRotateBy: angle degreesToRadians! !

!RomePluginCanvas methodsFor: 'state' stamp: 'bf 7/18/2006 12:29'!
saveState
	"Save the state of the canvas onto the internal stack."
	stack := self clone.
	self primSaveState.! !

!RomePluginCanvas methodsFor: 'transforming' stamp: 'bf 7/17/2006 20:51'!
scaleBy: scale
	| p |
	p := scale asPoint.
	^self primScaleByX: p x asFloat y: p y asFloat! !

!RomePluginCanvas methodsFor: 'attributes canvas' stamp: 'bf 7/28/2006 15:10'!
selectFill: aFill
	aFill isColor ifFalse: [
		flags := flags bitOr: FlagFill.
		^aFill installOnRomePluginCanvas: self].
	aFill privateAlpha = 0
		ifTrue: [flags := flags bitClear: FlagFill. ^self].
	flags := flags bitOr: FlagFill.
	^self primFillColor: aFill privateRGB alpha: aFill privateAlpha! !

!RomePluginCanvas methodsFor: 'attributes canvas' stamp: 'bf 7/17/2006 22:43'!
selectNoFill
	flags := flags bitClear: FlagFill.
! !

!RomePluginCanvas methodsFor: 'attributes canvas' stamp: 'bf 7/17/2006 22:43'!
selectNoPen
	flags := flags bitClear: FlagStroke.
! !

!RomePluginCanvas methodsFor: 'attributes canvas' stamp: 'bf 7/31/2006 16:41'!
selectPenWidth: aNumber color: aColor
	flags := flags bitClear: FlagStroke.
	(aNumber <= 0 or: [aColor isTransparent])
		ifTrue: [^self].
	flags := flags bitOr: aColor privateAlpha.
	strokeColor := aColor privateRGB.
	self primSetLineWidth: aNumber asFloat! !

!RomePluginCanvas methodsFor: 'initialize-release' stamp: 'bf 7/7/2006 13:22'!
setTarget: aForm
	target := aForm asRomePluginTargetForm.
	self open.
! !

!RomePluginCanvas methodsFor: 'startup-shutdown' stamp: 'bf 7/3/2006 15:56'!
shutDown
	self isExecutor ifFalse: [self close].! !

!RomePluginCanvas methodsFor: 'drawing' stamp: 'jl 9/6/2006 11:20'!
stencilImage: aForm in: destRect sourceRect: srcRect
	aForm asRomePluginSourceFormDuring: [ :f |
		self primStencilImage: f
			destLeft: destRect left asFloat
			right: destRect right asFloat
			top: destRect top asFloat
			bottom: destRect bottom asFloat
			srcLeft: srcRect left asFloat
			right: srcRect right asFloat
			top: srcRect top asFloat
			bottom: srcRect bottom asFloat].
! !

!RomePluginCanvas methodsFor: 'private' stamp: 'bf 7/31/2006 16:13'!
strikeString: aString at: aPoint from: startIndex to: stopIndex
	"fill has been set, now just draw the string."
	| pos glyphs xTable height glyphIndex leftX rightX |
	pos := aPoint - (0@font asStrikeFont ascent) .
	glyphs := font asStrikeFont glyphs.
	xTable := font asStrikeFont xTable.
	height := glyphs height.
	startIndex to: stopIndex do: [:i |
		glyphIndex := (aString at: i) charCode + 1.
		leftX := xTable at: glyphIndex.
		rightX := xTable at: glyphIndex + 1.
		self stencilImage: glyphs
			at: pos
			sourceRect: (leftX @ 0 corner: rightX @ height).
		pos := pos + (rightX - leftX @ 0).
	]
! !

!RomePluginCanvas methodsFor: 'transforming' stamp: 'bf 8/28/2006 19:13'!
transform
	| tmp |
	tmp := self matrixClass new.
	self primGetTransform: tmp.
	^tmp! !

!RomePluginCanvas methodsFor: 'transforming' stamp: 'mir 1/6/2007 14:45'!
transform: aTransform
	self primSetTransform: aTransform "asMatrixTransform2x3 "! !

!RomePluginCanvas methodsFor: 'transforming' stamp: 'bf 7/17/2006 21:06'!
transformBy: aTransform
	aTransform transformRomePluginCanvas: self! !

!RomePluginCanvas methodsFor: 'transforming' stamp: 'bf 7/17/2006 20:32'!
translateBy: aPoint
	^self primTranslateByX: aPoint x asFloat y: aPoint y asFloat! !

!RomePluginCanvas methodsFor: 'private' stamp: 'bf 7/31/2006 14:43'!
ttString: aString at: aPoint from: startIndex to: stopIndex
	"selected font is a RomeTTFont, render outlines"
	self preserveStateDuring: [
		self translateBy: aPoint.	
		fontMatrix
			ifNil: [self scaleBy: fontSize]
			ifNotNil: [self transformBy: fontMatrix].
		self scaleBy: 1.0@-1.0 / font glyphScale. 
		(flags anyMask: FlagStroke) ifTrue: [ 
			self	primSetLineWidth: self primGetLineWidth * font glyphScale / self fontSize].
		startIndex to: stopIndex do: [:index |
			| glyph |
			glyph := font ttGlyphFor: (aString at: index).
			self drawGeneralBezierShape: glyph contours.
			index < stopIndex ifTrue: [ | kerning |
				kerning := font kerningLeft: (aString at: index) right: (aString at: index + 1).
				self translateBy: (glyph advanceWidth + kerning)@0.0 ]]].
! !

!RomePluginCanvas methodsFor: 'finalization' stamp: 'bf 6/30/2006 15:26'!
unregister
	^self class unregister: self! !

RomeCanvas subclass: #RomeReferenceCanvas
	instanceVariableNames: 'stack ctm pen deviceFill devicePen deviceClip deviceTolerance path capStyle joinStyle miterLimit dashSpec dashOffset font fontMatrix noPen noFill noClip'
	classVariableNames: 'DefaultPen'
	poolDictionaries: ''
	category: 'Athens-Reference'!

!RomeReferenceCanvas commentStamp: '<historical>' prior: 0!
A canvas is a two-dimensional medium on which objects are drawn in a device-independent manner. Canvases keep track of various attributes related to the drawing operations.

Instance variables:
	stack		<RomeCanvas>	- The internal stack.
	ctm 		<CDisplayTransform>	- The current user to device space transformation.
	
	deviceFill		<RomeFill>			- The current fill.
	devicePen		<RomePen>			- The current pen.
	deviceClip		<RomeClipshape>		- The current clip shape
	deviceTolerance	<Number>			- The tolerance when converting (stored as square!!)

	capStyle 	<Symbol>	- The cap style for lines, #butt, #square, or #round.
	joinStyle 	<Symbol>	- The join style for lines, #miter, #bevel, or #round.
	miterLimit 	<Number>	- The miter limit for #miter join style.
	dashSpec 	<Array of: Number> - The line dash specification.

	font 		<Font>		- The currently selected font.
	fontName	<String>		- The font name.
	fontFlags	<Number>	- Font emphasis flags.
	fontSize		<Number>	- Font size (in user space units).
	fontMatrix	<CDisplayTransform>	- The transformation from design to user space units.
	fontColor	<Color>		- The current font color.

	noPen 		<CPen>		- The "null" pen
	noFill		<CFill>		- The "null" fill

Reference:
A canvas keeps a set of attributes and draws shapes. The shapes are filled with the current fill, outlined by the current pen and clipped against the current clip shape. All shapes can be converted into paths and from there (implicitly and lossy) into polygons/polylines. A shape is drawn using the following stages:

    * Shape generalization: As the first step we determine whether the current transformation is shape-preserving or not. If it is not shape-preserving we generalize the input to an appropriate path.
    * Transformation: The output from the first step is transformed by the current transformation (e.g., converted into device coordinates). In addition, fill, and clip shape are transformed into device coordinates. At the end of this step there are no more transformations necessary.
    * Clipping: The output from the previous step is clipped against the current clip shape.
    * Filling: The output from the previous step is filled with the current fill. If the fill cannot be handled by the canvas directly it will ask the fill to draw the shape accordingly. The fill can then use the appropriate fallback strategies for drawing itself.

When a pen is specified to stroke the shape accordingly, the process is conceptually equivalent to the above (though we will typically see vast optimizations here) merely by filling the shape computed as the Minkowski sum of both pen outline and path outline. 
!

RomeReferenceCanvas subclass: #RomeBalloonCanvas
	instanceVariableNames: 'balloon target'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-BallonCanvas'!

!RomeBalloonCanvas classSide methodsFor: 'examples' stamp: 'cyrille.delaunay 5/5/2010 16:35'!
exampleChar
	"self exampleChar"
	| c |
	c := RomeBalloonCanvas on: Display.
	c selectPenWidth: 1 color: Color blue.
	c drawRectangle: (0@0 corner: 500@750).
	c translateBy: 0@500.
	c selectFill: (Color yellow alpha: 0.5).
	c drawPath: [
		(RomeTTFont family: 'Bitstream Vera Serif' style: 'Roman')
			outlineChar: $B size: 500 transform: IdentityTransform new on: c].
	c finish.! !

!RomeBalloonCanvas methodsFor: 'private' stamp: 'bf 6/23/2006 15:55'!
createPath
	^RomeBalloonPath new! !

!RomeBalloonCanvas methodsFor: 'device responsibilities' stamp: 'bf 7/29/2006 01:45'!
deviceClear: aRectangle fill: aFill
	"set aRectangle to aFill *even* if aFill is transparent."
	balloon
		clipBy: aRectangle during: [:c | c fillColor: aFill]! !

!RomeBalloonCanvas methodsFor: 'device responsibilities' stamp: 'jl 7/12/2006 17:06'!
deviceClip: aClipShape

	super deviceClip: aClipShape.

	deviceClip isRectangular ifTrue: [
		balloon := balloon copyOffset: 0@0 clipRect: (aClipShape bounds scaleBy: 1.0 / self roundingHack) rounded]
! !

!RomeBalloonCanvas methodsFor: 'device responsibilities' stamp: 'bf 5/16/2006 13:04'!
deviceGeneralPolygon: aCollection pen: aPen fill: aFill
	"Send a general polygon (e.g., a polygon that can contain holes) directly to the device. If this is not supported, fall back to simple polygons"
	aCollection isEmpty ifTrue: [^nil].
	aCollection size = 1 ifTrue: [^self devicePolygon: aCollection first pen: aPen fill: aFill].

	balloon
		drawGeneralPolygon: aCollection
		color: aFill
		borderWidth: aPen width
		borderColor: aPen color.! !

!RomeBalloonCanvas methodsFor: 'device responsibilities' stamp: 'bf 8/29/2006 18:57'!
deviceImage: aForm in: destRect sourceRect: sourceRect rule: rule
	"Draw the image; don't transform."
	| bb transDestRect |
	balloon finish.
	transDestRect := balloon ensuredEngine edgeTransform transformRect: destRect.
	transDestRect extent  = sourceRect extent  ifTrue:[
		"fine - just a plain blt"
		bb := BitBlt toForm: target.
		bb colorMap: (aForm colormapIfNeededFor: target).
		bb sourceForm: aForm.
		bb sourceOrigin: sourceRect origin.
		bb destOrigin: transDestRect origin.
"		bb extent: sourceRect extent."
		bb combinationRule: rule.
		bb copyBits.
	] ifFalse:[
		"not a plain blt - warp it"
		bb := WarpBlt toForm: target.
		bb colorMap: (aForm colormapIfNeededFor: target).
		bb sourceForm: aForm.
		bb sourceQuad: sourceRect innerCorners destRect: transDestRect.
		bb combinationRule: rule.
		bb warpBits.
	].
! !

!RomeBalloonCanvas methodsFor: 'device responsibilities' stamp: 'bf 5/4/2006 10:38'!
deviceLineFrom: startPoint to: endPoint pen: aPen
	self devicePolyline: {startPoint. endPoint} pen: aPen! !

!RomeBalloonCanvas methodsFor: 'device responsibilities' stamp: 'cyrille.delaunay 5/5/2010 16:35'!
devicePath: aPath pen: aPen fill: aFill
	(aPen isSolid) ifFalse:[
		"Draw pen and fill separately"
		self devicePath: aPath pen: noPen fill: aFill.
		self saveState.
		self transform: IdentityTransform new.
		aPen framePath: aPath on: self.
		^self restoreState.
	].

	balloon transformBy: aPath transform during: [:c |
			aPath degree = 1
				ifTrue: [c
					drawGeneralPolygon: (aPath untransformedFlatten)
					color: aFill
					borderWidth: (aPen width / (aPath transform scale x max: 1)) rounded
					borderColor: aPen color]
				ifFalse: [c
					drawGeneralBezierShape: (aPath asBezierShape: deviceTolerance)
					color: aFill
					borderWidth: (aPen width / (aPath transform scale x max: 1)) rounded
					borderColor: aPen color]
		]
! !

!RomeBalloonCanvas methodsFor: 'device responsibilities' stamp: 'cyrille.delaunay 5/5/2010 16:35'!
devicePolygon: aCollection pen: aPen fill: aFill

	aCollection isEmpty ifTrue:[^nil].
	aPen isSolid ifFalse:[
		self devicePolygon: aCollection pen: noPen fill: aFill.
		self saveState.
		self transform: IdentityTransform new.
		aPen framePolygon: aCollection on: self.
		^self restoreState.
	].

	balloon
		drawPolygon: aCollection
		color: aFill
		borderWidth: aPen width
		borderColor: aPen color.! !

!RomeBalloonCanvas methodsFor: 'device responsibilities' stamp: 'cyrille.delaunay 5/5/2010 16:35'!
devicePolyline: aCollection pen: aPen
	"Send a polyline directly to the device"
	| poly |
	(aPen isSolid) ifFalse:[
		"Let pen draw itself"
		self saveState.
		self transform: IdentityTransform new.
		aPen drawPolyline: aCollection on: self.
		^self restoreState.
	].

	"Balloon can only draw closed polygons - so we create one that goes forth and back"
	poly := Array new: aCollection size * 2 - 2.
	poly replaceFrom: 1 to: aCollection size with: aCollection.
	aCollection size + 1 to: poly size do: [:i | poly at: i put: (aCollection at: poly size - i + 2)].
	balloon drawPolygon: poly color: nil borderWidth: aPen width borderColor: aPen color

! !

!RomeBalloonCanvas methodsFor: 'device responsibilities' stamp: 'cyrille.delaunay 5/5/2010 16:35'!
deviceRect: aRectangle pen: aPen fill: aFill
	"Send a rectangle directly to the device. "

	aPen isSolid ifFalse:[
		self deviceRect: aRectangle pen: noPen fill: aFill.
		self saveState.
		self transform: IdentityTransform new.
		aPen frameRectangle: aRectangle on: self.
		^self restoreState.
	].

	balloon
		drawRectangle: aRectangle
		color: aFill
		borderWidth: aPen width
		borderColor: aPen color.! !

!RomeBalloonCanvas methodsFor: 'device responsibilities' stamp: 'cyrille.delaunay 5/5/2010 16:35'!
deviceRoundRect: aRectangle radius: radius corners: flags pen: aPen fill: aFill

	aPen isSolid ifFalse:[
		self deviceRect: aRectangle pen: noPen fill: aFill.
		self saveState.
		self transform: IdentityTransform new.
		aPen frameRoundRect: aRectangle radius: radius corners: flags on: self.
		^self restoreState.
	].

	self devicePath: (self makePath:[self roundRect: aRectangle radius: radius corners: flags]) 
			pen: aPen fill: aFill.
! !

!RomeBalloonCanvas methodsFor: 'initialize' stamp: 'bf 5/4/2006 13:26'!
finish
	balloon flush! !

!RomeBalloonCanvas methodsFor: 'private' stamp: 'bf 7/25/2006 13:19'!
privateTargetForm
	^target! !

!RomeBalloonCanvas methodsFor: 'private' stamp: 'bf 6/6/2006 17:16'!
roundingHack
	^64.0! !

!RomeBalloonCanvas methodsFor: 'initialize' stamp: 'cyrille.delaunay 5/5/2010 16:38'!
setTarget: aForm
	target := aForm.
	balloon := BalloonCanvas on: target.
	balloon aaLevel: 2.
	balloon deferred: true.

"HACK to avoid rounding errors"
	balloon transformBy: (MatrixTransform2x3 withScale: 1.0/self roundingHack).
	self scaleBy: self roundingHack.
	self selectTolerance: 0.5.
"END HACK"

	noClip := RomeClipshape new bounds: (0@0 corner: 1000000@1000000).
	deviceClip := noClip.
	self clipRectangle: target boundingBox.
! !

!RomeBalloonCanvas methodsFor: 'drawing text' stamp: 'bf 7/31/2006 15:54'!
ttString: aString at: aPoint from: startIndex to: stopIndex
	| aa |
	aa := balloon aaLevel.
	balloon aaLevel: 4.
	super ttString: aString at: aPoint from: startIndex to: stopIndex.
	balloon aaLevel: aa.! !

!RomeReferenceCanvas classSide methodsFor: 'examples' stamp: 'alain.plantec 7/7/2009 21:55'!
exampleArc
	"self exampleArc"
	| canvas center radius angle1 angle2 |
	canvas := self newExampleCanvas.
	"Draw arc"
	center := 0.5 @ 0.5.
	radius := 0.4.
	angle1 := 45.
	angle2 := 180.
	canvas
		drawArc: radius
		at: center
		from: angle1
		to: angle2.
	"Draw helper dot"
	canvas selectNoPen.
	canvas
		selectFill: (Color
				r: 1.0
				g: 0.2
				b: 0.2
				alpha: 0.6).
	canvas
		drawArc: 0.05
		at: center
		from: 0
		to: 360.
	"Draw helper lines"
	canvas
		selectPenWidth: 0.03
		color: (Color
				r: 1.0
				g: 0.2
				b: 0.2
				alpha: 0.6).
	canvas
		drawPath: [canvas
				arc: radius
				at: center
				from: angle1
				to: angle1.
			"no-op, just positioning"
			canvas lineTo: center].
	canvas
		drawPath: [canvas
				arc: radius
				at: center
				from: angle2
				to: angle2.
			"no-op, just positioning"
			canvas lineTo: center].
	canvas finish! !

!RomeReferenceCanvas classSide methodsFor: 'examples' stamp: 'bf 7/31/2006 16:49'!
exampleArcReverse
	"self exampleArcReverse"
	| canvas center radius angle1 angle2 |
	canvas := self newExampleCanvas.
	"Draw arc"
	center := 0.5@0.5.
	radius := -0.4.
	angle1 := 45.
	angle2 := 180.

	canvas drawArc: radius at: center from: angle1 to: angle2.
	"Draw helper dot"
	canvas selectNoPen.
	canvas selectFill: (Color r: 1.0 g: 0.2 b: 0.2 alpha: 0.6).
	canvas drawArc: 0.05 at: center from: 0 to: 360.
	"Draw helper lines"
	canvas selectPenWidth: 0.03 color: (Color r: 1.0 g: 0.2 b: 0.2 alpha: 0.6).
	canvas drawPath:[
		canvas arc: radius at: center from: angle1 to: angle1. "no-op, just positioning"
		canvas lineTo: center.
	].
	canvas drawPath:[
		canvas arc: radius at: center from: angle2 to: angle2. "no-op, just positioning"
		canvas lineTo: center.
	].

! !

!RomeReferenceCanvas classSide methodsFor: 'examples' stamp: 'bf 7/31/2006 16:50'!
exampleClip
	"self exampleClip"
	| canvas |
	canvas := self newExampleCanvas.
	canvas clipPath:[canvas arc: 0.3 at: 0.5@0.5 from: 0 to: 360; closePath].
	canvas selectFill: Color blue.
	canvas drawRectangle: (0@0 corner: 1@1).
	canvas selectPenWidth: 0.03 color: (Color r: 1.0 g: 0.2 b: 0.2 alpha: 0.6).
	canvas drawLineFrom: 0@0 to: 1@1.
	canvas drawLineFrom: 0@1 to: 1@0.
! !

!RomeReferenceCanvas classSide methodsFor: 'examples' stamp: 'ar 4/17/2005 22:54'!
exampleClipImage
	"self exampleClipImage"
	| canvas image |
	canvas := self newExampleCanvas.
	canvas clipPath:[
		canvas arc: 0.3 at: 0.5@0.5 from: 0 to: 360.
		canvas closePath.
	].
	image := self newExampleImage.
	canvas scaleBy: 1.0 / image extent.
	canvas drawImage: image at: 0@0.
! !

!RomeReferenceCanvas classSide methodsFor: 'examples' stamp: 'bf 7/31/2006 16:50'!
exampleClipRect
	"RomeBalloonCanvas exampleClipRect"
	| canvas rect |
	canvas := self newExampleCanvas.
	rect := 0.25@0.25 corner: 0.75@0.75.
	canvas clipRectangle: rect.
	canvas drawRectangle: rect.
	canvas selectPenWidth: 0.03 color: (Color r: 1.0 g: 0.2 b: 0.2).
	canvas drawLineFrom: 0@0 to: 1@1.
	canvas finish.! !

!RomeReferenceCanvas classSide methodsFor: 'examples' stamp: 'bf 7/31/2006 16:50'!
exampleCurveTo
	"self exampleCurveTo"
	| canvas p0 p1 p2 p3 |
	p0 := 0.1@0.5.
	p1 := 0.4@0.9.
	p2 := 0.6@0.1.
	p3 := 0.9@0.5.
	canvas := self newExampleCanvas.
	canvas drawCurveFrom: p0 via: p1 and: p2 to: p3.
	canvas selectPenWidth: 0.03 color: (Color r: 1.0 g: 0.2 b: 0.2 alpha: 0.6).
	canvas drawLineFrom: p0 to: p1.
	canvas drawLineFrom: p2 to: p3.
! !

!RomeReferenceCanvas classSide methodsFor: 'examples' stamp: 'bf 7/31/2006 16:50'!
exampleCurveTo2
	"self exampleCurveTo2"
	| canvas p0 p1 p2 p3 |
	canvas := self newExampleCanvas.
	canvas dashSpec: #(
		0.01		"ink"
		0.01		"skip"
	).
	canvas selectPenWidth: 0.005 color: Color black.
	p0 := 0.1@0.5.
	p1 := 0.4@0.9.
	p2 := 0.6@0.1.
	p3 := 0.9@0.5.
	canvas drawCurveFrom: p0 via: p1 and: p2 to: p3.
	canvas selectPenWidth: 0.005 color: (Color r: 1.0 g: 0.2 b: 0.2 alpha: 0.6).
	canvas drawLineFrom: p0 to: p1.
	canvas drawLineFrom: p2 to: p3.
! !

!RomeReferenceCanvas classSide methodsFor: 'examples' stamp: 'ar 4/17/2005 22:34'!
exampleDashes
	"self exampleDashes"
	| canvas |
	canvas := self newExampleCanvas.
	canvas dashSpec: #(
		0.20		"ink"
		0.05		"skip"
		0.05		"ink"
		0.05		"skip"
	).
	canvas drawPath:[
		canvas moveTo: 0.5@0.1.
		canvas lineTo: 0.9@0.9.
		canvas lineBy: -0.4@0.0.
		canvas curveVia: 0.2@0.9 and: 0.2@0.5 to: 0.5@0.5.
	].! !

!RomeReferenceCanvas classSide methodsFor: 'examples' stamp: 'ar 4/17/2005 22:36'!
exampleDashes2
	"self exampleDashes2"
	| canvas |
	canvas := self newExampleCanvas.
	canvas dashSpec: #(
		0.20		"ink"
		0.05		"skip"
		0.05		"ink"
		0.05		"skip"
	).
	canvas drawPath:[
		canvas moveTo: 0.3@0.3.
		canvas lineBy: 0.35@0.0.
		canvas lineBy: 0.0@0.35.
		canvas lineBy: -0.35@0.0.
		canvas lineBy: 0.0@-0.35.
	].! !

!RomeReferenceCanvas classSide methodsFor: 'examples' stamp: 'bf 7/31/2006 16:50'!
exampleDashes3
	"self exampleDashes3"
	| canvas |
	canvas := self newExampleCanvas.
	canvas dashSpec: #(
		0.01		"ink"
		0.01		"skip"
	).
	canvas selectPenWidth: 0.005 color: Color black.
	canvas drawPath:[
		canvas moveTo: 0.5@0.1.
		canvas lineTo: 0.9@0.9.
		canvas lineBy: -0.4@0.0.
		canvas curveVia: 0.2@0.9 and: 0.2@0.5 to: 0.5@0.5.
		canvas closePath.
	].! !

!RomeReferenceCanvas classSide methodsFor: 'examples' stamp: 'ar 4/17/2005 20:38'!
exampleFillAndStroke
	"self exampleFillAndStroke"
	| canvas |
	canvas := self newExampleCanvas.
	canvas selectFill: Color blue.
	canvas drawPath:[
		canvas moveTo: 0.5@0.1.
		canvas lineTo: 0.9@0.9.
		canvas lineBy: -0.4@0.0.
		canvas curveVia: 0.2@0.9 and: 0.2@0.5 to: 0.5@0.5.
		canvas closePath.
	].! !

!RomeReferenceCanvas classSide methodsFor: 'examples' stamp: 'ar 4/17/2005 20:38'!
exampleFillAndStroke2
	"self exampleFillAndStroke2"
	| canvas |
	canvas := self newExampleCanvas.
	canvas selectFill: Color blue.
	canvas drawPath:[
		canvas moveTo: 0.5@0.1.
		canvas lineTo: 0.9@0.9.
		canvas lineBy: -0.4@0.0.
		canvas curveVia: 0.2@0.9 and: 0.2@0.5 to: 0.5@0.5.
		canvas closePath.

		canvas moveTo: 0.25@0.1.
		canvas lineBy: 0.2@0.2.
		canvas lineBy: -0.2@0.2.
		canvas lineBy: -0.2@-0.2.
		canvas closePath.
	].! !

!RomeReferenceCanvas classSide methodsFor: 'examples' stamp: 'ar 4/17/2005 23:00'!
exampleFillAndStroke3
	"self exampleFillAndStroke3"
	| canvas |
	canvas := self newExampleCanvas.
	canvas dashSpec: #(
		0.1		"ink"
		0.1		"skip"
	).
	canvas selectFill: Color blue.
	canvas drawPath:[
		canvas moveTo: 0.5@0.1.
		canvas lineTo: 0.9@0.9.
		canvas lineBy: -0.4@0.0.
		canvas curveVia: 0.2@0.9 and: 0.2@0.5 to: 0.5@0.5.
		canvas closePath.
	].
	canvas drawPath:[
		canvas moveTo: 0.25@0.1.
		canvas lineBy: 0.2@0.2.
		canvas lineBy: -0.2@0.2.
		canvas lineBy: -0.2@-0.2.
		canvas closePath.
	].! !

!RomeReferenceCanvas classSide methodsFor: 'examples' stamp: 'bf 7/31/2006 16:50'!
exampleFillAndStroke4
	"self exampleFillAndStroke4"
	| canvas |
	canvas := self newExampleCanvas.
	canvas dashSpec: #(
		0.01		"ink"
		0.01		"skip"
	).
	canvas selectFill: (Color r: 0.5 g: 0.5 b: 1.0).
	canvas selectPenWidth: 0.005 color: Color black.
	canvas drawPath:[
		canvas moveTo: 0.5@0.1.
		canvas lineTo: 0.9@0.9.
		canvas lineBy: -0.4@0.0.
		canvas curveVia: 0.2@0.9 and: 0.2@0.5 to: 0.5@0.5.
		canvas closePath.
	].
	canvas drawPath:[
		canvas moveTo: 0.25@0.1.
		canvas lineBy: 0.2@0.2.
		canvas lineBy: -0.2@0.2.
		canvas lineBy: -0.2@-0.2.
		canvas closePath.
	].! !

!RomeReferenceCanvas classSide methodsFor: 'examples' stamp: 'ar 4/17/2005 18:43'!
exampleGradient
	"self exampleGradient"
	| fill canvas |
	canvas := self newExampleCanvas.

	fill := canvas newLinearGradient.
	fill origin: 0@0.
	fill direction: 0@1.
	fill addColorStop: Color black at: 1.0.
	fill addColorStop: Color white at: 0.0.
	canvas fill: fill.
	canvas drawRectangle: (0@0 corner: 1@1).

	fill := canvas newRadialGradient.
	fill origin: 0.45@0.4.
	fill direction: -0.05@0.
	fill addColorStop: Color white at: 0.0.
	fill addColorStop: Color white at: 0.3.
	fill addColorStop: Color black at: 1.0.
	canvas fill: fill.
	canvas drawOval: (0.2@0.2 corner: 0.8@0.8).! !

!RomeReferenceCanvas classSide methodsFor: 'examples' stamp: 'ar 4/18/2005 19:43'!
exampleImage
	"self exampleImage"
	| canvas image |
	canvas := self newExampleCanvas.
	image := self newExampleImage.
	canvas scaleBy: 1.0 / image extent.
	canvas drawImage: image at: 0@0.
! !

!RomeReferenceCanvas classSide methodsFor: 'examples' stamp: 'ar 4/18/2005 19:46'!
exampleImage2
	"self exampleImage2"
	| canvas image |
	canvas := self newExampleCanvas.
	image := self newExampleImage.
	canvas translateBy: 0.5@0.5.
	canvas rotateBy: 45.0.
	canvas scaleBy: 1.0 / image extent.
	canvas drawImage: image at: 0@0.! !

!RomeReferenceCanvas classSide methodsFor: 'examples' stamp: 'ar 4/18/2005 19:43'!
exampleImage3
	"self exampleImage3"
	| canvas image |
	canvas := self newExampleCanvas.
	image := self newExampleImage.
	canvas drawImage: image in: (0.0@0.0 corner: 1.0@1.0).
	canvas drawImage: image in: (0.1@0.1 corner: 0.9@0.9).
	canvas drawImage: image in: (0.2@0.2 corner: 0.8@0.8).
	canvas drawImage: image in: (0.3@0.3 corner: 0.7@0.5).
	canvas drawImage: image in: (0.4@0.4 corner: 0.6@0.6).! !

!RomeReferenceCanvas classSide methodsFor: 'examples' stamp: 'ar 4/18/2005 19:44'!
exampleImage4
	"self exampleImage4"
	| canvas image |
	canvas := self newExampleCanvas.
	image := self newExampleImage.
	canvas drawImage: image in: (0.0@0.0 corner: 1.0@1.0).
	canvas rotateBy: 45.
	canvas drawImage: image in: (0.1@0.1 corner: 0.9@0.9).
	canvas rotateBy: 45.
	canvas drawImage: image in: (0.2@0.2 corner: 0.8@0.8).
	canvas rotateBy: 45.
	canvas drawImage: image in: (0.3@0.3 corner: 0.7@0.5).
	canvas rotateBy: 45.
	canvas drawImage: image in: (0.4@0.4 corner: 0.6@0.6).! !

!RomeReferenceCanvas classSide methodsFor: 'examples' stamp: 'ar 4/18/2005 19:56'!
exampleImageAlpha
	"self exampleImageAlpha"
	| canvas image |
	canvas := self newExampleCanvas.
	image := self newExampleAlphaImage.
	canvas scaleBy: 1.0 / image extent.
	canvas blendImage: image at: 0@0.
! !

!RomeReferenceCanvas classSide methodsFor: 'examples' stamp: 'ar 4/18/2005 19:57'!
exampleImageAlpha2
	"self exampleImageAlpha2"
	| canvas image |
	canvas := self newExampleCanvas.
	image := self newExampleAlphaImage.
	canvas translateBy: 0.5@0.5.
	canvas rotateBy: 45.0.
	canvas scaleBy: 1.0 / image extent.
	canvas blendImage: image at: 0@0.! !

!RomeReferenceCanvas classSide methodsFor: 'examples' stamp: 'ar 4/18/2005 19:57'!
exampleImageAlpha3
	"self exampleImageAlpha3"
	| canvas image |
	canvas := self newExampleCanvas.
	image := self newExampleAlphaImage.
	canvas blendImage: image in: (0.0@0.0 corner: 1.0@1.0).
	canvas blendImage: image in: (0.1@0.1 corner: 0.9@0.9).
	canvas blendImage: image in: (0.2@0.2 corner: 0.8@0.8).
	canvas blendImage: image in: (0.3@0.3 corner: 0.7@0.5).
	canvas blendImage: image in: (0.4@0.4 corner: 0.6@0.6).! !

!RomeReferenceCanvas classSide methodsFor: 'examples' stamp: 'ar 4/18/2005 19:57'!
exampleImageAlpha4
	"self exampleImageAlpha4"
	| canvas image |
	canvas := self newExampleCanvas.
	image := self newExampleAlphaImage.
	canvas blendImage: image in: (0.0@0.0 corner: 1.0@1.0).
	canvas rotateBy: 45.
	canvas blendImage: image in: (0.1@0.1 corner: 0.9@0.9).
	canvas rotateBy: 45.
	canvas blendImage: image in: (0.2@0.2 corner: 0.8@0.8).
	canvas rotateBy: 45.
	canvas blendImage: image in: (0.3@0.3 corner: 0.7@0.5).
	canvas rotateBy: 45.
	canvas blendImage: image in: (0.4@0.4 corner: 0.6@0.6).! !

!RomeReferenceCanvas classSide methodsFor: 'examples' stamp: 'ar 4/18/2005 19:58'!
exampleImagePaint
	"self exampleImagePaint"
	| canvas image |
	canvas := self newExampleCanvas.
	image := self newExamplePaintImage.
	canvas scaleBy: 1.0 / image extent.
	canvas paintImage: image at: 0@0.
! !

!RomeReferenceCanvas classSide methodsFor: 'examples' stamp: 'ar 4/18/2005 20:04'!
exampleImagePaint2
	"self exampleImagePaint2"
	| canvas image |
	canvas := self newExampleCanvas.
	image := self newExamplePaintImage.
	canvas translateBy: 0.5@0.5.
	canvas rotateBy: 45.0.
	canvas scaleBy: 1.0 / image extent.
	canvas paintImage: image at: 0@0.! !

!RomeReferenceCanvas classSide methodsFor: 'examples' stamp: 'ar 4/18/2005 20:04'!
exampleImagePaint3
	"self exampleImagePaint3"
	| canvas image |
	canvas := self newExampleCanvas.
	image := self newExamplePaintImage.
	canvas paintImage: image in: (0.0@0.0 corner: 1.0@1.0).
	canvas paintImage: image in: (0.1@0.1 corner: 0.9@0.9).
	canvas paintImage: image in: (0.2@0.2 corner: 0.8@0.8).
	canvas paintImage: image in: (0.3@0.3 corner: 0.7@0.5).
	canvas paintImage: image in: (0.4@0.4 corner: 0.6@0.6).! !

!RomeReferenceCanvas classSide methodsFor: 'examples' stamp: 'ar 4/18/2005 20:04'!
exampleImagePaint4
	"self exampleImage4"
	| canvas image |
	canvas := self newExampleCanvas.
	image := self newExamplePaintImage.
	canvas paintImage: image in: (0.0@0.0 corner: 1.0@1.0).
	canvas rotateBy: 45.
	canvas paintImage: image in: (0.1@0.1 corner: 0.9@0.9).
	canvas rotateBy: 45.
	canvas paintImage: image in: (0.2@0.2 corner: 0.8@0.8).
	canvas rotateBy: 45.
	canvas paintImage: image in: (0.3@0.3 corner: 0.7@0.5).
	canvas rotateBy: 45.
	canvas paintImage: image in: (0.4@0.4 corner: 0.6@0.6).! !

!RomeReferenceCanvas classSide methodsFor: 'examples' stamp: 'cyrille.delaunay 5/5/2010 16:39'!
exampleImagePattern
	"self exampleImagePattern"
	| canvas image fill |
	canvas := self newExampleCanvas.
	image := self newExampleImage.
	fill := canvas newBitmapFill.
	fill image: image.
	fill repeatMode: #repeat.
	fill transform: (MatrixTransform2x3 withScale: image extent * 5.0).
	canvas selectFill: fill.
	canvas drawRectangle: (0@0 corner: 1@1).
! !

!RomeReferenceCanvas classSide methodsFor: 'examples' stamp: 'bf 7/31/2006 16:50'!
exampleLineCap
	"self exampleLineCap"
	| canvas |
	canvas := self newExampleCanvas.

	#(butt round square) do:[:capStyle|
		canvas selectPenWidth: 0.12 color: Color black.
		canvas capStyle: capStyle.
		canvas drawLineFrom: 0.25@0.2 to: 0.25@0.8.

		canvas selectPenWidth: 0.01 color: (Color r: 1.0 g: 0.2 b: 0.2).
		canvas capStyle: #round.
		canvas drawLineFrom: 0.25@0.2 to: 0.25@0.8.

		canvas translateBy: 0.25@0.0.
	].! !

!RomeReferenceCanvas classSide methodsFor: 'examples' stamp: 'ar 4/19/2005 00:44'!
exampleLineJoin
	"self exampleLineJoin"
	| canvas |
	canvas := self newExampleCanvas.
	#(miter bevel round) do:[:joinStyle|
		canvas joinStyle: joinStyle.
		canvas drawPath:[
			canvas moveTo: 0.3@0.33.
			canvas lineBy: 0.2@-0.2.
			canvas lineBy: 0.2@0.2.
		].
		canvas translateBy: 0.0@0.3.
	].! !

!RomeReferenceCanvas classSide methodsFor: 'examples' stamp: 'ar 4/17/2005 18:44'!
examplePath
	"self examplePath"
	| canvas |
	canvas := self newExampleCanvas.
	canvas drawPath:[
		canvas moveTo: 0.5@0.1.
		canvas lineTo: 0.9@0.9.
		canvas lineBy: -0.4@0.0.
		canvas curveVia: 0.2@0.9 and: 0.2@0.5 to: 0.5@0.5.
	].! !

!RomeReferenceCanvas classSide methodsFor: 'examples' stamp: 'bf 7/31/2006 16:50'!
exampleText
	"self exampleText"
	| canvas |
	canvas := self newExampleCanvas.
	canvas selectFont: 'Sans' size: 0.35 flags: 1. "bold"
	canvas drawString: 'Hello' at: 0.04@0.53.
	canvas selectFill: (Color r: 0.5 g: 0.5 b: 1.0).
	canvas selectPenWidth: 0.01 color: Color black.
	canvas drawPath:[
		canvas moveTo: 0.27@0.65.
		canvas text: 'void'.
	].! !

!RomeReferenceCanvas classSide methodsFor: 'examples' stamp: 'ar 4/18/2005 19:00'!
imageData
	^'/9j/4AAQSkZJRgABAQEASABIAAD/2wBDABALDA4MChAODQ4SERATGCgaGBYWGDEjJR0oOjM9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'! !

!RomeReferenceCanvas classSide methodsFor: 'examples' stamp: 'ar 4/18/2005 19:57'!
newExampleAlphaImage
	| image |
	image := self newExampleImage.
	image := image asFormOfDepth: 32.
	image fixAlpha.
	(BitBlt toForm: image)
		fillColor: (Color white alpha: 0.5);
		combinationRule: Form and;
		copyBits.
	^image! !

!RomeReferenceCanvas classSide methodsFor: 'examples' stamp: 'bf 7/31/2006 16:51'!
newExampleCanvas
	| canvas |
	canvas := self new.
	canvas scaleBy: (Display width min: Display height) asPoint.
	canvas selectPenWidth: 0.03 color: Color black.
	^canvas! !

!RomeReferenceCanvas classSide methodsFor: 'examples' stamp: 'ar 4/18/2005 19:55'!
newExampleImage
	| data |
	data := Base64MimeConverter mimeDecode: self imageData as: ByteString.
	^Form fromBinaryStream: data asByteArray readStream! !

!RomeReferenceCanvas classSide methodsFor: 'examples' stamp: 'ar 4/18/2005 20:00'!
newExamplePaintImage
	| image |
	image := self newExampleImage asFormOfDepth: 8.
	(Form dotOfSize: image width) displayOn: image at: 0@0 rule: Form and.
	^image! !

!RomeReferenceCanvas methodsFor: 'initialize-release' stamp: 'ar 4/16/2005 22:58'!
abort
	"Aborts the entire drawing process. This is used by printers or file output."! !

!RomeReferenceCanvas methodsFor: 'path creation' stamp: 'bf 5/18/2006 11:53'!
arc: radius at: aPoint from: angle1 to: angle2
	"Make an arc segment. The arc will be drawn in CW direction. 
	To reverse the direction of the arc use a negative radius. See
	Michael Goldapp, 'Approximation of circular arcs by cubic poynomials', 
	Computer Aided Geometric Design 8 (1991) 227-238."
	| delta h angleA angleB rAcos rAsin rBcos rBsin cp1 cp2 cp3 cp4 count step r  |
	radius negative
		ifFalse: [
			r := radius.
			delta := (angle2 - angle1) asFloat.
			angleA := angle1 degreesToRadians
		]
		ifTrue: [
			r := radius abs.
			delta := (angle1 - angle2) asFloat.
			angleA := angle2 degreesToRadians.
		].

	"FIXME: Compute better estimate for number of segments needed."
	delta < 0.0 ifTrue:[delta := delta + 360].
	count := (delta / 45.0) truncated max: 1.
	step := (delta / count asFloat) degreesToRadians.

	"The formula for computing the spline is
		(R * cos(A), R * sin(A))
		(R * cos(A) - h * sin(A), R * sin(A) + h * cos (A))
		(R * cos(B) + h * sin(B), R * sin(B) - h * cos (B))
		(R * cos(B), R * sin(B))

	for some value of h - the above paper gives us 

		h = 4/3 * tan(angle/4)

	as a very practical value"

	h := 4.0/3.0 * (step / 4.0) tan.

	0 to: count-1 do:[:i|
		angleB := angleA + step.
		rAcos := r * angleA cos.
		rAsin := r * angleA sin.
		rBcos := r * angleB cos.
		rBsin := r * angleB sin.
		cp1 := rAcos @ rAsin.
		cp2 := (rAcos - (h * rAsin)) @ (rAsin + (h * rAcos)).
		cp3 := (rBcos + (h * rBsin)) @ (rBsin - (h * rBcos)).
		cp4 := rBcos @ rBsin.

		(i = 0 and: [self currentPoint isNil]) ifTrue:[self moveTo: cp1 + aPoint].
		self curveVia: cp2 + aPoint and: cp3 + aPoint to: cp4 + aPoint.
		angleA := angleB.
	].! !

!RomeReferenceCanvas methodsFor: 'drawing images' stamp: 'bf 7/28/2006 18:28'!
blendImage: aForm in: destRect sourceRect: aRectangle
	"Draw a translucent image with the set of parameters"
	^self drawImage: aForm in: destRect sourceRect: aRectangle rule: 34! !

!RomeReferenceCanvas methodsFor: 'attributes lines' stamp: 'ar 4/16/2005 23:06'!
capStyle
	"Answer the cap style for lines."
	^capStyle! !

!RomeReferenceCanvas methodsFor: 'attributes lines' stamp: 'ar 4/17/2005 00:49'!
capStyle: aSymbol
	"Set the cap style for lines, either 
	#butt, #square, or #round"
	capStyle := aSymbol.
	self strokeChanged.! !

!RomeReferenceCanvas methodsFor: 'drawing' stamp: 'bf 7/29/2006 01:49'!
clear
	"clear current clip region to selected fill"
	self flag: #fixMe.
	"use actual clipping, like #clearPath: or something"
	self deviceClear: self deviceClip bounds fill: self deviceFill
! !

!RomeReferenceCanvas methodsFor: 'path functions' stamp: 'jl 7/12/2006 16:37'!
clipPath: aPathOrBlock
	"Construct a path and merge it with the current clip shape."
	| thePath devicePath clip |
	thePath := self makePath: aPathOrBlock.
	thePath isEmpty ifTrue:[
		^self deviceClip: (RomeClipshape new bounds: (0@0 corner: 0@0)).
	].
	"Transform path to device space"
	devicePath := thePath transformedBy: self transform.
	"Mix with clip path"
	clip := self deviceClip.
	(devicePath flatten: self deviceTolerance) do:[:poly|
		clip := clip intersect: (RomeClipshape new points: poly).
	].
	self deviceClip: clip.! !

!RomeReferenceCanvas methodsFor: 'path functions' stamp: 'bf 7/17/2006 14:11'!
clipRectangle: aRect

	((self transform isNoTransformWithin: aRect) not or: [deviceClip isRectangular not])
		ifTrue: [^self clipPath: [self rectangle: aRect]].

	^self deviceClip: (self deviceClip intersect: 
		(RomeClipshape new bounds: (aRect transformedBy: self transform)))! !

!RomeReferenceCanvas methodsFor: 'initialize-release' stamp: 'ar 4/16/2005 22:58'!
close
	"Closes any associated resources (if necessary).
	Closing a canvas also implies to #finish it."
	self finish.! !

!RomeReferenceCanvas methodsFor: 'path creation' stamp: 'ar 4/19/2005 00:52'!
closePath
	"Close the current path"
	path closePath.! !

!RomeReferenceCanvas methodsFor: 'private' stamp: 'bf 6/6/2006 14:03'!
createPath
	^RomePath new! !

!RomeReferenceCanvas methodsFor: 'path creation' stamp: 'bf 5/18/2006 11:53'!
currentPoint
	"If a path is under construction, answer its last point, nil otherwise"
	^path currentPoint! !

!RomeReferenceCanvas methodsFor: 'path creation' stamp: 'ar 4/19/2005 00:52'!
curveVia: cp1 and: cp2 to: aPoint
	"Add a curve to the current path"
	path curveVia: cp1 and: cp2 to: aPoint! !

!RomeReferenceCanvas methodsFor: 'path creation' stamp: 'ar 4/19/2005 00:52'!
curveVia: offCurve to: aPoint
	"Add a curve to the current path"
	path curveVia: offCurve to: aPoint.! !

!RomeReferenceCanvas methodsFor: 'path functions' stamp: 'ar 4/19/2005 00:54'!
dashPath: aPath
	"Construct a path and dash it according to dash spec"
	| loop lastPt dashes tolerance thePath pts |
	thePath := self makePath: aPath.
	"Turn off dashing internally"
	dashes := dashSpec.
	dashSpec := nil.
	loop := WriteStream on: (Array new: 10).
	tolerance := (self invertDistance: self deviceTolerance sqrt) squared.
	(thePath flatten: tolerance) do:[:poly|
		lastPt := nil.
		self dashPolyline: poly using: dashes do:[:pt1 :pt2|
			pt1 = lastPt ifTrue:[
				loop nextPut: pt2.
			] ifFalse:[
				(pts := loop contents) size = 0 ifFalse:[self drawPolyline: pts].
				loop resetToStart.
				loop nextPut: pt1; nextPut: pt2.
			].
			lastPt := pt2.
		].
		(pts := loop contents) size = 0 ifFalse:[self drawPolyline: pts].
		loop resetToStart.
	].
	dashSpec := dashes.! !

!RomeReferenceCanvas methodsFor: 'private' stamp: 'cyrille.delaunay 4/19/2010 11:08'!
dashPolyline: points using: dashes do: aBlock
	"Dash the given polyline."
	| dash dashMax dashIndex dashOn lastPt nextPt offset line 
	remainder lineMax lineIndex delta p1 p2 closed |
	closed := points first = points last.
	dashMax := dashes size.
	dashMax = 0 ifTrue:[^self].
	lineMax := points size.
	lineMax < 2 ifTrue:[^self].
	dashIndex := 1.
	dashOn := true.
	dash := dashes at: 1.

	dashOffset > 0.0 ifTrue:[
		"Advance by dashOffset"
		offset := dashOffset.
		[offset > dash] whileTrue:[
			offset := offset - dash.
			(dashIndex := dashIndex + 1) > dashMax ifTrue:[dashIndex := 1].
			dashOn := dashOn not.
		].
	].


	"Now dash the poly line"
	closed ifTrue:[
		p1 := lastPt := points at: lineMax.
		nextPt := points at: (lineIndex := 1).
	] ifFalse:[
		p1 := lastPt := points at: 1.
		nextPt := points at: (lineIndex := 2).
	].

	delta := nextPt - lastPt.
	line := remainder := delta r.
	[true] whileTrue:[
		remainder <= dash ifTrue:[
			"The line is fully inside this dash"
			dashOn ifTrue:[aBlock value: p1 value: nextPt].
			dash := dash - remainder.
			"Advance to next segment"
			(lineIndex := lineIndex + 1) > lineMax ifTrue:[^self].
			p1 := lastPt := nextPt.
			nextPt := points at: lineIndex.
			delta := nextPt - lastPt.
			line := remainder := delta r.
		] ifFalse:[
			"The line segment is longer than the dash"
			p2 := p1 + (delta * dash / line).
			remainder := remainder - dash.
			dashOn ifTrue:[aBlock value: p1 value: p2].
			p1 := p2.
			"Advance to next dash"
			(dashIndex := dashIndex + 1) > dashMax ifTrue:[dashIndex := 1].
			dash := dashes at: dashIndex.
			dashOn := dashOn not.
		].
	].
! !

!RomeReferenceCanvas methodsFor: 'attributes lines' stamp: 'ar 4/16/2005 23:07'!
dashSpec
	"Answer the current dash specification"
	^dashSpec ifNil:[#()].! !

!RomeReferenceCanvas methodsFor: 'attributes lines' stamp: 'ar 4/17/2005 00:49'!
dashSpec: aSpec
	"Set the new dash specification"
	dashSpec := aSpec.
	dashSpec size = 0 ifTrue:[dashSpec := nil].
	self strokeChanged.! !

!RomeReferenceCanvas methodsFor: 'device responsibilities' stamp: 'bf 7/29/2006 01:45'!
deviceClear: aRectangle fill: aFill
	"set aRectangle to aFill *even* if aFill is transparent."
	Display 	getCanvas
		clipBy: aRectangle during: [:c | c fillColor: aFill]! !

!RomeReferenceCanvas methodsFor: 'device state' stamp: 'ar 4/19/2005 00:55'!
deviceClip
	"Answer the currently selected clip shape"
	^deviceClip! !

!RomeReferenceCanvas methodsFor: 'device state' stamp: 'ar 4/19/2005 00:55'!
deviceClip: aClipshape
	"Set the currently active clip shape"
	deviceClip := aClipshape.! !

!RomeReferenceCanvas methodsFor: 'device state' stamp: 'ar 4/19/2005 00:56'!
deviceFill
	"Answer the current device fill. Usually this should be cached."
	^deviceFill! !

!RomeReferenceCanvas methodsFor: 'device state' stamp: 'ar 4/19/2005 00:56'!
deviceFill: aFill
	"Set the current device fill."
	deviceFill := aFill.! !

!RomeReferenceCanvas methodsFor: 'device responsibilities' stamp: 'bf 5/16/2006 12:56'!
deviceGeneralPolygon: aCollection pen: aPen fill: aFill
	"Send a general polygon (e.g., a polygon that can contain holes) directly to the device. If this is not supported, fall back to simple polygons"
	aCollection isEmpty ifTrue: [^nil].
	aCollection size = 1 ifTrue: [^self devicePolygon: aCollection first pen: aPen fill: aFill].

	"fill first"
	aFill = noFill ifFalse: [
		(self tesselate: aCollection) do: [:poly | 
			self devicePolygon: poly pen: noPen fill: aFill]].

	"draw contours separately"
	aPen = noPen ifFalse: [
		aCollection do: [:poly |
			self devicePolygon: poly pen: aPen fill: noFill]].
! !

!RomeReferenceCanvas methodsFor: 'device responsibilities' stamp: 'jl 5/31/2006 12:28'!
deviceImage: aForm in: destRect sourceRect: sourceRect rule: rule
	"Draw the image; don't transform."
	| bb |
	destRect extent = sourceRect extent ifTrue:[
		"fine - just a plain blt"
		bb := BitBlt toForm: Display.
		bb colorMap: (aForm colormapIfNeededFor: Display).
		bb sourceForm: aForm.
		bb sourceOrigin: sourceRect origin.
		bb destOrigin: destRect origin.
"		bb extent: sourceRect extent."
		bb combinationRule: rule.
		bb copyBits.
	] ifFalse:[
		"not a plain blt - warp it"
		bb := WarpBlt toForm: Display.
		bb colorMap: (aForm colormapIfNeededFor: Display).
		bb sourceForm: aForm.
		bb sourceQuad: sourceRect innerCorners destRect: destRect.
		bb combinationRule: rule.
		bb warpBits.
	].
! !

!RomeReferenceCanvas methodsFor: 'device responsibilities' stamp: 'cyrille.delaunay 5/5/2010 16:38'!
deviceLineFrom: startPoint to: endPoint pen: aPen
	"Send a line directly to the device"
	aPen isSolid ifFalse:[
		self saveState.
		self transform: MatrixTransform2x3 identity.
		aPen drawLineFrom: startPoint to: endPoint on: self.
		^self restoreState.
	].
	(BalloonCanvas on: Display)
		aaLevel: 1;
		line: startPoint to: endPoint width: aPen width color: aPen color.! !

!RomeReferenceCanvas methodsFor: 'device responsibilities' stamp: 'cyrille.delaunay 5/5/2010 16:36'!
deviceOval: outerBounds pen: aPen fill: aFill
	"Send an oval directly to the device. If a device does not support ovals it might just generalize into a path (such as shown below). If the device *does* support ovals but not the choosen pen and fill, it might ask the pen and fill to draw an oval by itself. In this case the device needs to provide a *new* canvas to be used by pen and fill so that the receiver is not affected by anything that pen and fill are doing."
	| rect |
	rect := aPen insetBounds: outerBounds.
	(aPen isSolid and:[aFill isSolidFill]) ifFalse:[
		"Draw pen and fill separately"
		self saveState.
		self transform: IdentityTransform new.
		aFill isSolidFill
			ifTrue:[self deviceOval: outerBounds pen: noPen fill: aFill]
			ifFalse:[aFill fillOval: rect on: self].
		aPen isSolid
			ifTrue:[self deviceOval: outerBounds pen: aPen fill: noFill]
			ifFalse:[aPen frameOval: rect on: self].
		^self restoreState.
	].
	self devicePath: (self makePath:[self oval: rect]) pen: aPen fill: aFill.! !

!RomeReferenceCanvas methodsFor: 'device responsibilities' stamp: 'cyrille.delaunay 5/5/2010 16:36'!
devicePath: aPath pen: aPen fill: aFill
	"Send a path directly to the device. If a device does not support paths it might fall back onto a polygon (such as shown below). If the device *does* support paths but not the choosen pen and fill, it might ask the pen and fill to draw the path by itself. In this case the device needs to provide a *new* canvas to be used by pen and fill so that the receiver is not affected by anything that pen and fill are doing."
	| closedContours openContours |
	(aPen isSolid and:[aFill isSolidFill]) ifFalse:[
		"Draw pen and fill separately"
		self saveState.
		self transform: IdentityTransform new.
		aFill isSolidFill
			ifTrue:[self devicePath: aPath pen: noPen fill: aFill]
			ifFalse:[aFill fillPath: aPath on: self].
		aPen isSolid
			ifTrue:[self devicePath: aPath pen: aPen fill: noFill]
			ifFalse:[aPen framePath: aPath on: self].
		^self restoreState.
	].

	closedContours := OrderedCollection new.
	openContours := OrderedCollection new.
	(aPath flatten: self deviceTolerance) do: [:poly |
		(poly first = poly last)
			ifTrue: [closedContours add: poly]
			ifFalse: [openContours add: poly]	].

	self deviceGeneralPolygon: closedContours pen: aPen fill: aFill.
	openContours do: [:poly | self devicePolyline: poly pen: aPen].

! !

!RomeReferenceCanvas methodsFor: 'device state' stamp: 'bf 7/19/2006 19:05'!
devicePen
	"Answer the current device pen"
	^pen transformedBy: self transform! !

!RomeReferenceCanvas methodsFor: 'device responsibilities' stamp: 'cyrille.delaunay 5/5/2010 16:36'!
devicePolygon: aCollection pen: aPen fill: aFill
	"Send a polygon directly to the device. All devices must support polygons.  However, if the device not support the choosen pen and fill, it might ask the pen and fill to draw the polygon by itself. In this case the device needs to provide a *new* canvas to be used by pen and fill so that the receiver is not affected by anything that pen and fill are doing."
	aCollection isEmpty ifTrue:[^nil].
	(aPen isSolid and:[aFill isSolidFill]) ifFalse:[
		"Draw pen and fill separately"
		self saveState.
		self transform: IdentityTransform new.
		aFill isSolidFill
			ifTrue:[self devicePolygon: aCollection pen: noPen fill: aFill]
			ifFalse:[aFill fillPolygon: aCollection on: self].
		aPen isSolid
			ifTrue:[self devicePolygon: aCollection pen: aPen fill: noFill]
			ifFalse:[aPen framePolygon: aCollection on: self].
		^self restoreState.
	].
	(BalloonCanvas on: Display)
		aaLevel: 1;
		drawPolygon: aCollection
		color: aFill
		borderWidth: aPen width
		borderColor: aPen color.! !

!RomeReferenceCanvas methodsFor: 'device responsibilities' stamp: 'cyrille.delaunay 5/5/2010 16:36'!
devicePolyline: aCollection pen: aPen
	"Send a polyline directly to the device"
	| lastPt |
	(aPen isSolid) ifFalse:[
		"Draw pen and fill separately"
		self saveState.
		self transform: IdentityTransform new.
		aPen drawPolyline: aCollection on: self.
		^self restoreState.
	].

	lastPt := nil.
	aCollection do:[:nextPt|
		lastPt ifNotNil:[self deviceLineFrom: lastPt to: nextPt pen: aPen].
		lastPt := nextPt.
	].! !

!RomeReferenceCanvas methodsFor: 'device responsibilities' stamp: 'cyrille.delaunay 5/5/2010 16:36'!
deviceRect: outerBounds pen: aPen fill: aFill
	"Send a rectangle directly to the device. If a device does not support rectangles (how dare it?) it might just generalize into a path (such as shown below). If the device *does* support rectangles but not the choosen pen and fill, it might ask the pen and fill to draw a rectangle by itself. In this case the device needs to provide a *new* canvas to be used by pen and fill so that the receiver is not affected by anything that pen and fill are doing."
	| rect |
	rect := aPen insetBounds: outerBounds.
	(aPen isSolid and:[aFill isSolidFill]) ifFalse:[
		"Draw pen and fill separately"
		self saveState.
		self transform: IdentityTransform new.
		aFill isSolidFill
			ifTrue:[self deviceRect: outerBounds pen: noPen fill: aFill]
			ifFalse:[aFill fillRectangle: rect on: self].
		aPen isSolid
			ifTrue:[self deviceRect: outerBounds pen: aPen fill: noFill]
			ifFalse:[aPen frameRectangle: rect on: self].
		^self restoreState.
	].
	self devicePath: (self makePath:[self rectangle: rect]) pen: aPen fill: aFill.! !

!RomeReferenceCanvas methodsFor: 'device responsibilities' stamp: 'cyrille.delaunay 5/5/2010 16:36'!
deviceRoundRect: outerBounds radius: radius corners: flags pen: aPen fill: aFill
	"Send a rectangle directly to the device. If a device does not support round rects it might just generalize into a path (such as shown below). If the device *does* support round rects but not the choosen pen and fill, it might ask the pen and fill to draw a round rect by itself. In this case the device needs to provide a *new* canvas to be used by pen and fill so that the receiver is not affected by anything that pen and fill are doing."
	| rect |
	rect := aPen insetBounds: outerBounds.
	(aPen isSolid and:[aFill isSolidFill]) ifFalse:[
		"Draw pen and fill separately"
		self saveState.
		self transform: IdentityTransform new.
		aFill isSolidFill
			ifTrue:[self deviceRoundRect: outerBounds radius: radius corners: flags pen: noPen fill: aFill]
			ifFalse:[aFill fillRoundRect: rect radius: radius corners: flags on: self].
		aPen isSolid
			ifTrue:[self deviceRoundRect: outerBounds radius: radius corners: flags pen: aPen fill: noFill]
			ifFalse:[aPen frameRoundRect: rect radius: radius corners: flags on: self].
		^self restoreState.
	].
	self devicePath: (self makePath:[self roundRect: rect radius: radius corners: flags]) 
			pen: aPen fill: aFill.! !

!RomeReferenceCanvas methodsFor: 'device state' stamp: 'ar 4/19/2005 00:56'!
deviceTolerance
	^deviceTolerance! !

!RomeReferenceCanvas methodsFor: 'device state' stamp: 'ar 4/19/2005 00:56'!
deviceTolerance: aNumber
	deviceTolerance := aNumber.! !

!RomeReferenceCanvas methodsFor: 'drawing curves' stamp: 'bf 7/24/2006 17:03'!
drawArc: radius at: aPoint from: angle1 to: angle2
	"Draw an arc segment. The arc will be drawn in CW direction. 
	To reverse the direction of the arc use a negative radius"
	^self drawPath:[self arc: radius at: aPoint from: angle1 to: angle2].! !

!RomeReferenceCanvas methodsFor: 'drawing curves' stamp: 'ar 4/19/2005 00:47'!
drawCurveFrom: start via: cp1 and: cp2 to: end
	"Draw a cubic bezier curve"
	^self drawPath:[
		self moveTo: start.
		self curveVia: cp1 and: cp2 to: end.
	].! !

!RomeReferenceCanvas methodsFor: 'drawing curves' stamp: 'ar 4/19/2005 00:47'!
drawCurveFrom: start via: offCurve to: end
	"Draw a quadratic bezier curve"
	^self drawPath:[
		self moveTo: start.
		self curveVia: offCurve to: end.
	].! !

!RomeReferenceCanvas methodsFor: 'drawing images' stamp: 'ar 4/18/2005 19:36'!
drawImage: aForm in: destRect sourceRect: sourceRect
	"Draw a fully opaque image with the set of parameters"
	^self drawImage: aForm in: destRect sourceRect: sourceRect rule: Form over! !

!RomeReferenceCanvas methodsFor: 'drawing images' stamp: 'cyrille.delaunay 5/7/2010 10:44'!
drawImage: aForm in: aRectangle sourceRect: sourceRect rule: rule
	"Draw an image with the set of parameters"
	| rect clip pt1 pt2 bmFill |
	"Check for weirdo transformations"
	(ctm isNoTransformWithin: aRectangle) ifTrue:[
		"Check for weirdo clipping"
		pt1 := self transformPoint: aRectangle origin.
		pt2 := self transformPoint: aRectangle corner.
		rect := pt1 corner: pt2.
		((clip := self deviceClip) isRectangular or:[clip containsRect: rect]) ifTrue:[
			"Send image straight to device"
			^self deviceImage: aForm in: rect sourceRect: sourceRect rule: rule
		].
	].
	"Generalize image to fill and draw rectangle"
	bmFill := TweakBitmapFill form: aForm.
	bmFill tileFlag: false.
	bmFill origin: 0@0.
	bmFill direction: aForm width@0.
	bmFill normal: 0@aForm height.
	bmFill combinationRule: rule.
	self saveState.
		self translateBy: aRectangle origin.
		self scaleBy: aRectangle extent / sourceRect extent.
		self selectFill: bmFill.
		self selectNoPen.
		self drawRectangle: sourceRect.
	self restoreState.! !

!RomeReferenceCanvas methodsFor: 'drawing curves' stamp: 'ar 4/19/2005 00:47'!
drawLineFrom: startPoint to: endPoint
	"Draw a line from startPoint to endPoint."
	| pt1 pt2  rect clip |
	self devicePen width <= 0 ifTrue:[^self].

	pt1 := ctm transformPoint: startPoint.
	pt2 := ctm transformPoint: endPoint.
	rect := self devicePen expandBounds: (pt1 rect: pt2).
	((clip := self deviceClip) isRectangular or:[clip containsRect: rect]) ifFalse:[
		^self drawPath:[self line: startPoint to: endPoint].
	].
	"See if we have a weirdo stroke to deal with"
	(dashSpec == nil and:[capStyle == #round and:[joinStyle == #round]]) ifFalse:[
		^self drawPath:[self line: startPoint to: endPoint].
	].
	^self deviceLineFrom: pt1 to: pt2 pen: self devicePen! !

!RomeReferenceCanvas methodsFor: 'drawing shapes' stamp: 'alain.plantec 7/7/2009 21:48'!
drawOval: aRectangle 
	"Draw an oval specified by the given rectangle"
	"Check for weirdo transformations"
	| pt1 pt2 rect clip | 
	(ctm isNoTransformWithin: aRectangle)
		ifFalse: [^ self
				drawPath: [self oval: aRectangle]].
	"Check for weirdo clipping"
	pt1 := self transformPoint: aRectangle origin.
	pt2 := self transformPoint: aRectangle corner.
	rect := self devicePen
				expandBounds: ((pt1 min: pt2)
						corner: (pt1 max: pt2)).
	((clip := self deviceClip) isRectangular
			or: [clip containsRect: rect])
		ifFalse: [^ self
				drawPath: [self oval: aRectangle]].
	"Check for weirdo line attributes"
	dashSpec == nil
		ifFalse: [self
				deviceOval: rect
				pen: noPen
				fill: self deviceFill.
			self saveState.
			self selectFill: noFill.
			self
				drawPath: [self oval: aRectangle].
			^ self restoreState].
	"Send geometry straight to device"
	self
		deviceOval: rect
		pen: self devicePen
		fill: self deviceFill! !

!RomeReferenceCanvas methodsFor: 'drawing shapes' stamp: 'bf 7/26/2006 17:35'!
drawPath: aBlock
	"Draw a generic path."
	| devicePath weirdoStroke rect clip aPath devicePoly |
	aPath := self makePath: aBlock.
	aPath isEmpty ifTrue:[^self].

	"Transform path to device space"
	devicePath := aPath transformedBy: self transform.

	"See if we have a weirdo stroke to deal with"
	weirdoStroke := false.
	(dashSpec == nil and:[capStyle == #round and:[joinStyle == #round]]) ifFalse:[
		weirdoStroke := self devicePen width > 0.
	].

	"See if we need to clip - in this case we must compute the outline first, 
	since clip might clip parts of the outline."
	rect := nil. "lazy"
	((clip := self deviceClip) isRectangular or: [
		rect := self devicePen expandBounds: devicePath bounds.
		clip containsRect: rect]) ifTrue:[
			"All right, we can leave the clipping to device."
			(weirdoStroke) ifFalse:[
				^self devicePath: devicePath pen: self devicePen fill: self deviceFill
			].
			"Only do fill - weirdo stroke will be handled below"
			self devicePath: devicePath pen: noPen fill: self deviceFill.
		] ifFalse:[
			"Device cannot clip; do it ourselves"
			rect ifNil: [rect := self devicePen expandBounds: devicePath bounds].
			(self deviceClip bounds intersects: rect) ifFalse:[^self]. "quick reject"
			aPath closed ifTrue: [
				"Fill interior first"
				devicePoly := devicePath flatten: self deviceTolerance.
				devicePoly := self deviceClip intersectGeneralPoly: devicePoly.
				self deviceGeneralPolygon: devicePoly pen: noPen fill: self deviceFill
			].
		].
	"Now stroke path"
	self devicePen width <= 0 ifTrue:[^self].

	dashSpec ifNotNil:[^self dashPath: aPath].

	(devicePath flatten: self deviceTolerance) do:[:poly|
		| penPolys fill |
		fill := self devicePen fill.
		penPolys := self tracePolygon: poly.
		penPolys := self deviceClip intersectGeneralPoly: penPolys.
		penPolys do: [:pts | self devicePolygon: pts pen: noPen fill: fill].
		"if penPolys would not be overlapping, we could use this:"
		"self deviceGeneralPolygon: penPoly pen: noPen fill: self devicePen fill."
	].! !

!RomeReferenceCanvas methodsFor: 'drawing shapes' stamp: 'ar 4/17/2005 18:48'!
drawPolygon: aCollection
	"Draw a polygon using the given set of vertices"
	^self drawPath:[self polygon: aCollection].! !

!RomeReferenceCanvas methodsFor: 'drawing curves' stamp: 'ar 4/19/2005 00:47'!
drawPolyline: aCollection
	"Draw a polyline using the given set of vertices"
	^self drawPath:[self polyline: aCollection].! !

!RomeReferenceCanvas methodsFor: 'drawing shapes' stamp: 'bf 6/8/2006 14:45'!
drawRectangle: aRectangle
	"Draw aRectangle."
	| pt1 pt2  rect clip |
	"Check for weirdo transformations"
	(ctm isNoTransformWithin: aRectangle) ifFalse:[
		^self drawPath:[self rectangle: aRectangle].
	].
	"Check for weirdo clipping"
	pt1 := self transformPoint: aRectangle origin.
	pt2 := self transformPoint: aRectangle corner.
	rect := self devicePen expandBounds: ((pt1 min: pt2) corner: (pt1 max: pt2)).
	((clip := self deviceClip) isRectangular or:[clip containsRect: rect]) ifFalse:[
		^self drawPath:[self rectangle: aRectangle].
	].

	"Check for weirdo line attributes"
	(dashSpec == nil and:[joinStyle == #miter or: [self devicePen hasEffect not]]) ifFalse:[
		self deviceRect: rect pen: noPen fill: self deviceFill.
		self saveState.
			self selectFill: noFill.
			self drawPath:[self rectangle: aRectangle].
		^self restoreState.
	].

	"Send geometry straight to device"
	self deviceRect: rect pen: self devicePen fill: self deviceFill! !

!RomeReferenceCanvas methodsFor: 'drawing shapes' stamp: 'bf 5/18/2006 13:38'!
drawRoundRect: aRectangle radius: aRadius corners: flags
	"Draw a round rectangle using the specified position 
	and size, radius, and corners to round."
	| pt1 pt2  rect radius clip |
	"Check for weirdo transformations"
	(ctm isNoTransformWithin: aRectangle) ifFalse:[
		^self drawPath:[self roundRect: aRectangle radius: aRadius corners: flags]
	].
	"Check for weirdo clipping"
	pt1 := self transformPoint: aRectangle origin.
	pt2 := self transformPoint: aRectangle corner.
	rect := self devicePen expandBounds: ((pt1 min: pt2) corner: (pt1 max: pt2)).
	((clip := self deviceClip) isRectangular or:[clip containsRect: rect]) ifFalse:[
		^self drawPath:[self roundRect: aRectangle radius: aRadius corners: flags]
	].

	radius := self transformDistance: aRadius.

	"Check for weirdo line attributes"
	(dashSpec == nil) ifFalse:[
		self deviceRoundRect: rect radius: radius corners: flags pen: noPen fill: self deviceFill.
		self saveState.
			self selectFill: noFill.
			self drawPath:[self roundRect: aRectangle radius: aRadius corners: flags].
		self restoreState.
	].

	"Send geometry straight to device"
	self deviceRoundRect: rect radius: radius corners: flags 
			pen: self devicePen fill: self deviceFill! !

!RomeReferenceCanvas methodsFor: 'drawing text' stamp: 'bf 7/31/2006 15:53'!
drawString: aString at: aPoint from: start to: end
	^font render: aString at: aPoint from: start to: end on: self! !

!RomeReferenceCanvas methodsFor: 'private' stamp: 'ar 4/17/2005 14:50'!
eigenValuesOf: aTransform
	"Compute the eigenvalues of aTransform."
	| m a b c d radius |
	m := aTransform asMatrixTransform2x3.
	a := m a11.	b := m a12.
	c := m a21.	d := m a22.
	radius := ((a*a) + (2.0*a*d) + (d*d) - (4.0*a*d) - (4.0*b*c)) sqrt.
	^Array
		with: (a + d + radius) * 0.5
		with: (a + d - radius) * 0.5! !

!RomeReferenceCanvas methodsFor: 'initialize-release' stamp: 'ar 4/16/2005 22:45'!
finish
	"Flushes the canvas and ensures that he effects are
	visible on the underlying output medium."! !

!RomeReferenceCanvas methodsFor: 'initialize-release' stamp: 'ar 4/16/2005 22:58'!
flush
	"Flushes the canvas, e.g., ensures that no state is 
	buffered in the canvas any longer."
	self finish. "if #flush isn't implemented but #finish then use #finish"! !

!RomeReferenceCanvas methodsFor: 'attributes text' stamp: 'ar 4/16/2005 23:19'!
font
	"Answer the currently selected font"
	^font! !

!RomeReferenceCanvas methodsFor: 'attributes text' stamp: 'ar 4/16/2005 23:20'!
font: aFont
	"Set the font to be used for subsequent drawing"
	font := aFont.
	self fontChanged.! !

!RomeReferenceCanvas methodsFor: 'private' stamp: 'ar 4/16/2005 23:21'!
fontChanged
	"The current font has changed. Do whatever is necessary."! !

!RomeReferenceCanvas methodsFor: 'attributes text' stamp: 'ar 4/16/2005 23:20'!
fontMatrix
	"Answer the current transform for fonts"
	^fontMatrix! !

!RomeReferenceCanvas methodsFor: 'attributes text' stamp: 'ar 4/16/2005 23:20'!
fontMatrix: aTransform
	"Set the matrix transforming from font design units to user space.
	Normally this is just a scale (via fontSize) but can be overridden
	to achieve shearing and other effects."
	fontMatrix := aTransform.! !

!RomeReferenceCanvas methodsFor: 'attributes text' stamp: 'jl 6/7/2006 17:48'!
fontSize
	"Answer the currently selected font size."
	^fontMatrix scale y! !

!RomeReferenceCanvas methodsFor: 'attributes text' stamp: 'cyrille.delaunay 5/5/2010 16:38'!
fontSize: aNumber
	"Select a new font size for the active font."
	fontMatrix := MatrixTransform2x3 withScale: aNumber! !

!RomeReferenceCanvas methodsFor: 'initialize-release' stamp: 'cyrille.delaunay 5/5/2010 16:38'!
initialize
	"Initializes the canvas with default values"
	noPen := RomePen width: 0 color: Color transparent.
	noFill := Color transparent.
	noClip := RomeClipshape new bounds: (0@0 corner: 1000@1000).

	"Basic attributes"
	ctm := IdentityTransform new.
	deviceFill := noFill.
	pen := noPen.
	deviceClip := noClip.
	deviceTolerance := 0.5 squared.

	"Line attributes"
	capStyle := #round.
	joinStyle := #round.
	miterLimit := 10.
	dashSpec := nil.
	dashOffset := 0.0.


	"Font attributes"
	font := nil.
	self fontSize: 1.
	fontMatrix := MatrixTransform2x3 identity.! !

!RomeReferenceCanvas methodsFor: 'transforming' stamp: 'ar 4/17/2005 22:29'!
invertDistance: aNumber
	"Transform the given distance from device to user space"
	"@@@@: FIXME - this is incorrect."
	^(ctm inverseTransformation transformDirection: aNumber@0) r! !

!RomeReferenceCanvas methodsFor: 'transforming' stamp: 'ar 4/16/2005 23:10'!
invertPoint: aPoint
	"Transform the given point from device to user space"
	^self transform invertPoint: aPoint! !

!RomeReferenceCanvas methodsFor: 'attributes lines' stamp: 'ar 4/16/2005 23:07'!
joinStyle
	"Answer the join style for lines"
	^joinStyle! !

!RomeReferenceCanvas methodsFor: 'attributes lines' stamp: 'ar 4/17/2005 00:49'!
joinStyle: aSymbol
	"Set the join style for lines, either
	#miter, #round, or #bevel"
	joinStyle := aSymbol.
	self strokeChanged.! !

!RomeReferenceCanvas methodsFor: 'path creation' stamp: 'ar 4/19/2005 00:52'!
line: startPoint to: endPoint
	self moveTo: startPoint.
	self lineTo: endPoint.! !

!RomeReferenceCanvas methodsFor: 'path creation' stamp: 'ar 4/19/2005 00:52'!
lineBy: aPoint
	path lineBy: aPoint.! !

!RomeReferenceCanvas methodsFor: 'path creation' stamp: 'ar 4/19/2005 00:52'!
lineTo: aPoint
	path lineTo: aPoint.! !

!RomeReferenceCanvas methodsFor: 'path functions' stamp: 'bf 6/6/2006 14:03'!
makePath: aBlockOrPath
	"Construct a path from either path or block"
	| donePath |
	path ifNotNil:[self error: 'Old path still active'].
	aBlockOrPath isBlock ifFalse:[^aBlockOrPath].
	path := self createPath.
	aBlockOrPath value.
	donePath := path.
	path := nil.
	^donePath! !

!RomeReferenceCanvas methodsFor: 'attributes lines' stamp: 'ar 4/16/2005 23:07'!
miterLimit
	"Answer the current miter limit"
	^miterLimit! !

!RomeReferenceCanvas methodsFor: 'attributes lines' stamp: 'ar 4/17/2005 00:49'!
miterLimit: aNumber
	"Indicate the current miter limit"
	miterLimit := aNumber.
	self strokeChanged.! !

!RomeReferenceCanvas methodsFor: 'path creation' stamp: 'ar 4/19/2005 00:53'!
moveTo: aPoint
	path moveTo: aPoint.
! !

!RomeReferenceCanvas methodsFor: 'initialize-release' stamp: 'ar 4/16/2005 22:45'!
open
	"Opens any associated resources (if necessary."! !

!RomeReferenceCanvas methodsFor: 'path creation' stamp: 'ar 4/19/2005 00:53'!
oval: aRectangle
	"Convert an oval into a path"
	| width height angleStep h angleA angleB rAcos rAsin rBcos rBsin 
	cp1 cp2 cp3 cp4 radius offset scale |
	offset := aRectangle origin + aRectangle corner * 0.5.
	width := aRectangle width * 0.5.
	height := aRectangle height * 0.5.
	width >= height ifTrue:[
		radius := width.
		scale := 1.0 @ (height / width).
	] ifFalse:[
		radius := height.
		scale := (width / height) @ 1.0.
	].
	"FIXME: Choose better approximation"
	angleStep := 45.0 degreesToRadians.
	h := 4.0/3.0 * (angleStep / 4.0) tan.
	0 to: 7 do:[:i|
		angleA := i * angleStep.
		angleB := angleA + angleStep.

		rAcos := radius * angleA cos.
		rAsin := radius * angleA sin.
		rBcos := radius * angleB cos.
		rBsin := radius * angleB sin.

		cp1 := rAcos @ rAsin.
		cp2 := (rAcos - (h * rAsin)) @ (rAsin + (h * rAcos)).
		cp3 := (rBcos + (h * rBsin)) @ (rBsin - (h * rBcos)).
		cp4 := rBcos @ rBsin.

		i = 0 ifTrue:[self moveTo: cp1*scale+offset].
		self curveVia: cp2*scale+offset and: cp3*scale+offset to: cp4*scale+offset.
	].
	self closePath.! !

!RomeReferenceCanvas methodsFor: 'drawing images' stamp: 'ar 4/18/2005 19:38'!
paintImage: aForm in: destRect sourceRect: aRectangle
	"Draw a color keyed image with the set of parameters"
	^self drawImage: aForm in: destRect sourceRect: aRectangle rule: Form paint! !

!RomeReferenceCanvas methodsFor: 'path creation' stamp: 'jl 7/4/2006 16:23'!
path: aPath
	"add aPath to current path"

	aPath pathOn: self! !

!RomeReferenceCanvas methodsFor: 'path creation' stamp: 'ar 4/19/2005 00:53'!
polygon: aCollection
	"Make a polygon"
	self polyline: aCollection.
	self closePath.! !

!RomeReferenceCanvas methodsFor: 'path creation' stamp: 'ar 4/19/2005 00:53'!
polyline: aCollection
	"Make a polyline"
	self moveTo: aCollection first.
	2 to: aCollection size do:[:i| self lineTo: (aCollection at: i)].! !

!RomeReferenceCanvas methodsFor: 'preserve state' stamp: 'bf 7/14/2006 14:30'!
preserveStateDuring: aBlock
	self saveState.
	^aBlock ensure: [	self restoreState].
! !

!RomeReferenceCanvas methodsFor: 'preserve state' stamp: 'bf 7/14/2006 14:30'!
preserveTransformDuring: aBlock
	"Reset transform after evaluating aBlock"
	| oldTransform |
	oldTransform := self transform.
	^aBlock ensure: [self transform: oldTransform].! !

!RomeReferenceCanvas methodsFor: 'path creation' stamp: 'ar 4/19/2005 00:53'!
rectangle: rect
	"Make a rectangle"
	self moveTo: rect topLeft.
	self lineTo: rect topRight.
	self lineTo: rect bottomRight.
	self lineTo: rect bottomLeft.
	self closePath.! !

!RomeReferenceCanvas methodsFor: 'preserve state' stamp: 'ar 4/17/2005 03:06'!
restoreState
	"Restore the state from the internal stack"
	self copyFrom: stack.! !

!RomeReferenceCanvas methodsFor: 'transforming' stamp: 'cyrille.delaunay 5/5/2010 16:38'!
rotateBy: angle
	"Rotate all further drawing operations by angle"
	^self transformBy: (MatrixTransform2x3 withAngle: angle)! !

!RomeReferenceCanvas methodsFor: 'path creation' stamp: 'bf 7/31/2006 14:10'!
roundRect: rect radius: radius corners: cornerFlags
	"Convert a round rect into a path"
	| outer inner r x y |
	x := rect width / 2.0.
	y := rect height / 2.0.
	r := ((radius min: x) min: y).

	outer := rect.
	inner := outer insetBy: r.
	(cornerFlags anyMask: 1) ifTrue:[
		self moveTo: outer left @ inner top.
		self arc: r at: inner topLeft from: 180 to: 270.
	] ifFalse:[
		self moveTo: outer topLeft.
	].

	(cornerFlags anyMask: 8) ifTrue:[
		self lineTo: inner right @ outer top.
		self arc: r at: inner topRight from: 270 to: 360.
	] ifFalse:[
		self lineTo: outer topRight.
	].

	(cornerFlags anyMask: 4) ifTrue:[
		self lineTo: outer right @ inner bottom.
		self arc: r at: inner bottomRight from: 0 to: 90.
	] ifFalse:[
		self lineTo: outer bottomRight.
	].

	(cornerFlags anyMask: 2) ifTrue:[
		self lineTo: inner left @ outer bottom.
		self arc: r at: inner bottomLeft from: 90 to: 180.
	] ifFalse:[
		self lineTo: outer bottomLeft.
	].

	self closePath.
! !

!RomeReferenceCanvas methodsFor: 'preserve state' stamp: 'ar 4/17/2005 03:05'!
saveState
	"Save the state of the canvas onto the internal stack."
	stack := self clone.
! !

!RomeReferenceCanvas methodsFor: 'transforming' stamp: 'cyrille.delaunay 5/5/2010 16:38'!
scaleBy: scale
	"Scale all further drawing operations by scale"
	^self transformBy: (MatrixTransform2x3 withScale: scale)
! !

!RomeReferenceCanvas methodsFor: 'attributes canvas ' stamp: 'ar 4/17/2005 14:13'!
selectClip: aClipshape
	"Clip the receiver by aClipshape, which can be either
	a Clipshape, a Rectangle, a Path, or a Mask."
	| globalClip |
	globalClip := aClipshape transformedBy: self transform.
	^self deviceClip: (self deviceClip intersect: globalClip)! !

!RomeReferenceCanvas methodsFor: 'attributes canvas ' stamp: 'ar 4/17/2005 20:07'!
selectFill: aFill
	"Select the fill to use to use for subsequent drawing.
	This is a write-only operation."
	| globalFill |
	globalFill := aFill isColor ifTrue:[aFill] ifFalse:[aFill transformedBy: self transform].
	self deviceFill: globalFill.! !

!RomeReferenceCanvas methodsFor: 'attributes canvas ' stamp: 'jl 6/21/2006 10:16'!
selectNoFill
	deviceFill := noFill! !

!RomeReferenceCanvas methodsFor: 'attributes canvas ' stamp: 'bf 7/19/2006 19:06'!
selectNoPen
	pen := noPen! !

!RomeReferenceCanvas methodsFor: 'attributes canvas ' stamp: 'bf 7/19/2006 19:06'!
selectPen: aPen
	"Set the pen to use for subsequent drawing."
	pen := aPen.
	! !

!RomeReferenceCanvas methodsFor: 'attributes canvas ' stamp: 'bf 7/31/2006 17:08'!
selectPenWidth: aNumber color: aColor
	"select a solid Pen of width and color"
	DefaultPen ifNil: [DefaultPen := RomePen new].
	DefaultPen width: aNumber color: aColor.
	self selectPen: DefaultPen! !

!RomeReferenceCanvas methodsFor: 'attributes canvas ' stamp: 'ar 4/17/2005 23:10'!
selectTolerance: aNumber
	"Indicate the tolerance for converting paths.
	The tolerance is the distance by which a flattened
	path might deviate from its original version."
	^self deviceTolerance: (self transformDistance: aNumber) squared! !

!RomeReferenceCanvas methodsFor: 'initialize-release' stamp: 'bf 7/24/2006 16:34'!
setTarget: aForm
! !

!RomeReferenceCanvas methodsFor: 'initialize-release' stamp: 'ar 4/16/2005 22:45'!
showPage
	"Printers only. Advances to the next page of output."! !

!RomeReferenceCanvas methodsFor: 'drawing images' stamp: 'bf 7/29/2006 00:00'!
stencilImage: aForm in: destRect sourceRect: aRectangle
	"Fill destRect using aForm's alpha channel as mask"
	
	| mask |
	mask := Form extent: aRectangle extent depth: 32.
	mask getCanvas stencil: aForm at: 0@0 sourceRect: aRectangle color: deviceFill.
	^self blendImage: mask in: destRect! !

!RomeReferenceCanvas methodsFor: 'drawing text' stamp: 'bf 7/31/2006 16:27'!
strikeString: aString at: aPoint from: startIndex to: stopIndex
	"fill has been set, now just draw the string."
	| pos glyphs xTable height glyphIndex leftX rightX |
	pos := aPoint - (0@font asStrikeFont ascent) .
	glyphs := font asStrikeFont glyphs.
	xTable := font asStrikeFont xTable.
	height := glyphs height.
	startIndex to: stopIndex do: [:i |
		glyphIndex := (aString at: i) charCode + 1.
		leftX := xTable at: glyphIndex.
		rightX := xTable at: glyphIndex + 1.
		self stencilImage: glyphs
			at: pos
			sourceRect: (leftX @ 0 corner: rightX @ height).
		pos := pos + (rightX - leftX @ 0).
	]
! !

!RomeReferenceCanvas methodsFor: 'path creation' stamp: 'bf 5/16/2006 15:50'!
string: aString
	
	self string: aString from: 1 to: aString size! !

!RomeReferenceCanvas methodsFor: 'path creation' stamp: 'bf 7/14/2006 14:43'!
string: aString from: startIndex to: stopIndex

	| offset advance |
	offset := 0@0.
	startIndex to: stopIndex do: [:index |
		advance := font outlineChar: (aString at: index)
			size: 1
			transform: (fontMatrix composedWithLocal: (COffsetTransform offset: offset))
			on: self.
		offset := offset + advance].
	^offset! !

!RomeReferenceCanvas methodsFor: 'private' stamp: 'ar 4/17/2005 00:50'!
strokeChanged
	"The current stroke attributes have changed. Do whatever is necessary."! !

!RomeReferenceCanvas methodsFor: 'private' stamp: 'bf 5/16/2006 13:00'!
tesselate: aCollection
	"Tesselate a general polygon into a collection of simple polygons"

	self flag: #fixMe.
	Transcript cr; show: 'Rome: tesselation not supported yet'.
	^aCollection! !

!RomeReferenceCanvas methodsFor: 'private' stamp: 'bf 7/27/2006 17:09'!
tracePolygon: inPoints
	"Compute the minkowski sum of the shape of the devicePen with the polygon/polyline specified by the argument."

	| r a b d n |
	self flag: #fixMe. "neither correct nor optimized, does not do capstyle/joinstyle"
	r := self devicePen width / 2.0.
	^Array streamContents: [:outContours |
		1 to: inPoints size-1 do: [:i |
			a := inPoints at: i.
			b := inPoints at: i+1.
			a = b ifFalse: [
				d := (b - a) normalized * r.		"direction"
				n := d y negated @ d x.			"normal"
				outContours nextPut: {a-n. a-d. a+n. b+n. b+d. b-n}.
			].
		].
	].! !

!RomeReferenceCanvas methodsFor: 'transforming' stamp: 'ar 4/17/2005 14:02'!
transform
	"Answer the currently selected transform"
	^ctm! !

!RomeReferenceCanvas methodsFor: 'transforming' stamp: 'ar 4/17/2005 14:03'!
transform: aTransform
	"Set the transform to be used for subsequent drawing"
	ctm := aTransform.
	self transformChanged.! !

!RomeReferenceCanvas methodsFor: 'transforming' stamp: 'ar 4/16/2005 23:08'!
transformBy: aTransform
	"Transform all further drawing operations by aTransform"
	^self transform: (self transform composedWithLocal: aTransform)! !

!RomeReferenceCanvas methodsFor: 'private' stamp: 'ar 4/16/2005 23:19'!
transformChanged
	"The current transform has changed. Do whatever is necessary."! !

!RomeReferenceCanvas methodsFor: 'transforming' stamp: 'ar 4/17/2005 23:11'!
transformDistance: aNumber
	"Transform the given distance from user to device space"
	"@@@@: FIXME - this is incorrect."
	^(ctm transformDirection: aNumber@0) r! !

!RomeReferenceCanvas methodsFor: 'transforming' stamp: 'ar 4/16/2005 23:09'!
transformPoint: aPoint
	"Transform the given point from user to device space"
	^self transform transformPoint: aPoint! !

!RomeReferenceCanvas methodsFor: 'transforming' stamp: 'ar 4/16/2005 23:08'!
translateBy: offset
	"Offset all further drawing operations by offset"
	^self transformBy: (COffsetTransform withOffset: offset)! !

!RomeReferenceCanvas methodsFor: 'drawing text' stamp: 'cyrille.delaunay 5/5/2010 16:38'!
ttString: aString at: aPoint from: startIndex to: stopIndex
	"Draw a string with the given set of parameters"

	self preserveStateDuring: [
		"we draw the glyphs in their native coordinate system ..."
		pen hasEffect ifTrue: [
			"... however, this must not affect line width."
			pen := pen transformedBy: (MatrixTransform2x3 withScale: font glyphScale / self fontSize)].

		self translateBy: aPoint.	
		self transformBy: fontMatrix.
		self scaleBy: 1.0@-1.0 / font glyphScale. 

		startIndex to: stopIndex do: [:index |
			| advance |
			self drawPath: [advance := font outlineChar: (aString at: index) on: self].
			index < stopIndex ifTrue: [ | kerning |
				kerning := font kerningLeft: (aString at: index) right: (aString at: index + 1).
				self translateBy: advance + (kerning@0.0) ]]].
! !

Object subclass: #RomeClipshape
	instanceVariableNames: 'bounds points'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Reference'!

!RomeClipshape methodsFor: 'accessing' stamp: 'ar 4/17/2005 21:45'!
asClipShape
	^self! !

!RomeClipshape methodsFor: 'converting' stamp: 'ar 4/17/2005 21:47'!
asPolygon
	^self points! !

!RomeClipshape methodsFor: 'converting' stamp: 'ar 4/17/2005 21:47'!
asRectangle
	^self bounds! !

!RomeClipshape methodsFor: 'accessing' stamp: 'ar 4/17/2005 21:45'!
bounds
	^bounds ifNil:[self computeBounds]! !

!RomeClipshape methodsFor: 'accessing' stamp: 'ar 4/17/2005 21:45'!
bounds: newBounds
	bounds := newBounds.
	points := nil.! !

!RomeClipshape methodsFor: 'private' stamp: 'ar 4/17/2005 21:47'!
computeBounds
	points size = 0 
		ifTrue:[bounds := 0@0 extent: 0@0]
		ifFalse:[bounds := Rectangle encompassing: points].
	^bounds! !

!RomeClipshape methodsFor: 'private' stamp: 'bf 7/14/2006 20:34'!
computePoints
	| origin corner |
	origin := bounds origin.
	corner := bounds corner.
	^Array
		with: origin
		with: corner x @ origin y
		with: corner
		with: origin x @ corner y
		with: origin
! !

!RomeClipshape methodsFor: 'clipping' stamp: 'ar 4/17/2005 21:46'!
containsPoint: aPoint
	| nextPt lastPt dx dy px py |
	(self bounds containsPoint: aPoint) ifFalse:[^false].
	self isRectangular ifTrue:[^true].
	nextPt := points at: 1.
	2 to: points size do:[:i|
		lastPt := nextPt.
		nextPt := points at: i.
		dx := nextPt x - lastPt x.
		dy := nextPt y - lastPt y.
		px := aPoint x - lastPt x.
		py := aPoint y - lastPt y.
		(dx * py) - (dy * px) < 0 ifTrue:[^false].
	].
	^true! !

!RomeClipshape methodsFor: 'clipping' stamp: 'ar 4/17/2005 21:46'!
containsPoints: pointList
	pointList do:[:pt| (self containsPoint: pt) ifFalse:[^false]].
	^true! !

!RomeClipshape methodsFor: 'clipping' stamp: 'ar 4/17/2005 21:46'!
containsRect: aRectangle
	(self bounds containsRect: aRectangle) ifFalse:[^false].
	self isRectangular ifTrue:[^true].
	(self containsPoint: aRectangle origin) ifFalse:[^false].
	(self containsPoint: aRectangle corner) ifFalse:[^false].
	(self containsPoint: aRectangle topRight) ifFalse:[^false].
	(self containsPoint: aRectangle bottomLeft) ifFalse:[^false].
	^true! !

!RomeClipshape methodsFor: 'clipping' stamp: 'ar 4/17/2005 21:52'!
intersect: aClipShape
	"Compute the intersection of the receiver and aClipShape"
	(self isRectangular and:[aClipShape isRectangular]) ifTrue:[
		^RomeClipshape new bounds: (self bounds intersect: aClipShape bounds).
	] ifFalse:[
		^RomeClipshape new points: 
			(RomePolygonClipper clip: self points against: aClipShape points).
	].! !

!RomeClipshape methodsFor: 'clipping' stamp: 'bf 7/14/2006 16:04'!
intersectGeneralPoly: contourList
	| wasCcw ccwList clipped |
	contourList isEmpty ifTrue: [
		^contourList].
	contourList size = 1 ifTrue: [
		^{RomePolygonClipper clip: contourList first against: self points}].
	^(contourList collect: [:pointList |
		wasCcw := (RomePolygonClipper signedAreaOf: pointList) positive.
		ccwList := wasCcw ifTrue: [pointList] ifFalse: [pointList reversed].
		clipped := RomePolygonClipper clip: ccwList against: self points.
		wasCcw ifTrue: [clipped] ifFalse: [clipped reversed]]
	) reject: [:pts | pts isEmpty]! !

!RomeClipshape methodsFor: 'clipping' stamp: 'ar 4/17/2005 21:46'!
intersectPoints: pointList
	^RomeClipshape points: (RomePolygonClipper clip: self points against: pointList).! !

!RomeClipshape methodsFor: 'clipping' stamp: 'bf 7/14/2006 14:58'!
intersectPoly: pointList
	^(RomePolygonClipper clip: pointList against: self points).! !

!RomeClipshape methodsFor: 'testing' stamp: 'ar 4/17/2005 21:47'!
isRectangular
	"Answer whether this clip shape is rectangular"
	^points == nil! !

!RomeClipshape methodsFor: 'accessing' stamp: 'ar 4/17/2005 21:45'!
points
	^points ifNil:[self computePoints]! !

!RomeClipshape methodsFor: 'accessing' stamp: 'bf 7/17/2006 14:48'!
points: newPoints
	newPoints size = 5 ifTrue: [
		"optimize axis-aligned rectangles"
		| min13 min24 max13 max24 |
		min13 := (newPoints at: 1) min: (newPoints at: 3).
		min24 := (newPoints at: 2) min: (newPoints at: 4).
		min13 = min24 ifTrue: [
			max13 := (newPoints at: 1) max: (newPoints at: 3).
			max24 := (newPoints at: 2) max: (newPoints at: 4).
			max13 = max24
				ifTrue: [^self bounds: (min13 corner: max13)]]].

	points := newPoints.
	bounds := nil.! !

Object subclass: #RomeFill
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Reference'!

!RomeFill methodsFor: 'drawing' stamp: 'ar 4/17/2005 21:14'!
fillOval: aRectangle on: aCanvas
	"By default, clip and fill rectangle"
	aCanvas clipPath:[aCanvas oval: aRectangle].
	self fillRectangle: aRectangle on: aCanvas! !

!RomeFill methodsFor: 'drawing' stamp: 'ar 4/17/2005 21:14'!
fillPath: aPath on: aCanvas
	"By default, clip and fill rectangle"
	aCanvas clipPath: aPath.
	self fillRectangle: aPath bounds on: aCanvas! !

!RomeFill methodsFor: 'drawing' stamp: 'ar 4/17/2005 21:20'!
fillPolygon: aCollection on: aCanvas
	"By default, clip and fill rectangle"
	| path |
	path := aCanvas makePath:[aCanvas polygon: aCollection].
	self fillPath: path on: aCanvas! !

!RomeFill methodsFor: 'drawing' stamp: 'ar 4/17/2005 21:15'!
fillRectangle: aRectangle on: aCanvas
	"You ought to know this at least..."
	^self subclassResponsibility! !

!RomeFill methodsFor: 'drawing' stamp: 'ar 4/17/2005 21:15'!
fillRoundRect: aRectangle radius: radius corners: flags on: aCanvas
	"By default, clip and fill rectangle"
	aCanvas clipPath:[aCanvas roundRect: aRectangle radius: radius corners: flags].
	self fillRectangle: aRectangle on: aCanvas! !

Object subclass: #RomeFont
	instanceVariableNames: 'familyName styleName bold italic postscriptName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Core'!

!RomeFont methodsFor: 'converting' stamp: 'bf 7/31/2006 14:58'!
asRomeFont
	^self! !

!RomeFont methodsFor: 'accessing' stamp: 'jl 7/5/2006 16:52'!
familyName
	^familyName! !

!RomeFont methodsFor: 'testing' stamp: 'bf 8/23/2006 14:40'!
hasLatinGlyphs
	"Answer false if font does not provide latin glyphs"
	^true! !

!RomeFont methodsFor: 'testing' stamp: 'jl 7/5/2006 16:51'!
isBold
	^bold! !

!RomeFont methodsFor: 'testing' stamp: 'jl 7/5/2006 16:51'!
isItalic
	^italic ! !

!RomeFont methodsFor: 'accessing' stamp: 'JMM 11/9/2006 16:49'!
postscriptName
	^postscriptName ifNil: [postscriptName := self face postscriptName.
			postscriptName ifNil: 
				[postscriptName := (self familyName,'-',self styleName) copyWithout: $ .]]! !

!RomeFont methodsFor: 'accessing' stamp: 'jl 7/5/2006 16:52'!
styleName
	^styleName! !

Object subclass: #RomePath
	instanceVariableNames: 'pathData firstPt bounds closed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Reference'!

!RomePath commentStamp: '<historical>' prior: 0!
Instance variables:
	pathData	<OrderedCollection>	The data for the path.
	bounds	<Rectangle>			The bounding box for the path.
	firstPt	<Point>				The start of the last open part, or nil.
	closed	<Boolean>			Wether some part of this path is closed.

The pathData consist of op codes followed by Point parameters:
	0 <to>						move
	1 <to>						line
	2 <via> <to>					quadratic bezier segment
	3 <via> <via> <to>				cubic bezier segment
	4 <first>						close (arg must be equal to first point)
!

RomePath subclass: #RomeBalloonPath
	instanceVariableNames: 'transform lastPt degree'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-BallonCanvas'!

!RomeBalloonPath commentStamp: '<historical>' prior: 0!
pathData:
	is a collection of segments
	segment is collection, except last segment might be WriteStream
	segment is:
	if degree=1: list of polygon points (p1, p2, ...)
	if degree=2: list of bezier points (from1, via1, to1, from2, via2, ...)
	if degree=3: list of bezier points and Bezier3Segment (from1, via1, to1, seg2, from3, via3, ...)!

!RomeBalloonPath methodsFor: 'flattening' stamp: 'bf 6/26/2006 12:18'!
asBezierShape: squaredTolerance
	degree < 2 ifTrue: [self becomeBezier].
	self flushSegment.
	^degree = 2
		ifTrue: [pathData]
		ifFalse: [
			| scale tolerance |
			scale := transform scale x.
			scale = 0.0 ifTrue: [^#()].
			tolerance := squaredTolerance sqrt / scale.
			pathData collect: [:in |
				Array streamContents: [:out | in do: [:each |
					each isPoint
						ifTrue: [out nextPut: each]
						ifFalse: [out nextPutAll: (each asBezier2Points: tolerance)]]]]]
	! !

!RomeBalloonPath methodsFor: 'private' stamp: 'bf 6/26/2006 13:40'!
becomeBezier
	degree = 1 ifFalse: [self error: 'already bezier'].
	pathData := pathData collect: [:pts |
		pts isStream 
			ifFalse: [self segmentAsBezier: pts]
			ifTrue: [self newSegment nextPutAll: (self segmentAsBezier: pts contents)]
	].
	degree := 2.
! !

!RomeBalloonPath methodsFor: 'creation' stamp: 'bf 7/14/2006 20:20'!
bezierShape: contours
	self flushSegment.
	degree = 1 ifTrue: [self becomeBezier].
	pathData addAll: contours.
	firstPt := nil.
	closed := true.! !

!RomeBalloonPath methodsFor: 'accessing' stamp: 'bf 6/8/2006 16:52'!
bounds
	^transform transformRect: super bounds
! !

!RomeBalloonPath methodsFor: 'creation' stamp: 'jl 7/12/2006 14:58'!
closePath
	"Close this path"
	firstPt ifNotNil: [
		self lineTo: firstPt.
		self flushSegment.
		closed := true].
	firstPt := nil.
! !

!RomeBalloonPath methodsFor: 'accessing' stamp: 'jl 7/12/2006 14:29'!
computeBounds
	"This is not exact if the transform involves rotation - but transforming each point here would be much more inefficient. We take the boundingbox of the untransformed path and transform that (see #bounds). Also, we store points more than once, so further efficiency could be gained by building the bounds while building the path."

	| min max allPoints |
	self flushSegment.
	
	allPoints := Array streamContents: [ :out | 
		pathData do: [:eachSegement |
				eachSegement do: [:each |
					each isPoint 
						ifTrue: [out nextPut: each]
						ifFalse: [out nextPutAll: each asPointArray]]]].

	min := max := allPoints first.
	allPoints do: [:pt |
		pt < min ifTrue: [min := pt].
		pt > max ifTrue: [max := pt]].

	^min corner: max.! !

!RomeBalloonPath methodsFor: 'accessing' stamp: 'bf 6/8/2006 12:08'!
currentPoint
	^firstPt
		ifNil: [nil]
		ifNotNil: [lastPt]! !

!RomeBalloonPath methodsFor: 'creation' stamp: 'bf 6/23/2006 15:48'!
curveVia: cp1 and: cp2 to: aPoint
	firstPt ifNil: [self moveTo: 0@0].
	lastPt = aPoint ifFalse: [
		| seg |
		degree = 1 ifTrue: [self becomeBezier	].
		degree := 3.
		seg := Bezier3Segment from: lastPt via: cp1 and: cp2 to: aPoint.
		pathData last nextPut: seg.
		lastPt := aPoint.
	].
! !

!RomeBalloonPath methodsFor: 'creation' stamp: 'bf 6/8/2006 16:33'!
curveVia: cp1 to: aPoint
	firstPt ifNil: [self moveTo: 0@0].
	lastPt = aPoint ifFalse: [
		degree = 1 ifTrue: [self becomeBezier	].
		pathData last
			nextPut: lastPt;
			nextPut: cp1;
			nextPut: aPoint.
		lastPt := aPoint.
	]! !

!RomeBalloonPath methodsFor: 'accessing' stamp: 'bf 6/8/2006 14:38'!
degree
	^degree! !

!RomeBalloonPath methodsFor: 'flattening' stamp: 'bf 7/17/2006 20:55'!
flatten: tolerance
	"Create a polyline for this path"
	
	self flushSegment.

	degree = 1 ifTrue: [
		^self reorient: (
			pathData collect: [:eachSegment |
				eachSegment collect: [:eachPoint | 
					transform transformPoint: eachPoint]])].

	^self reorient: (pathData collect: [ :eachSegment | | lastPoint in out  |
		lastPoint := nil.
		in := eachSegment readStream.
		out := WriteStream on: Array new.
		[in atEnd] whileFalse:[
			in peek isPoint
				ifTrue: [ | from via to |
					from := in next.
					via := in next.
					to := in next.
					from = lastPoint ifFalse: [out nextPut: (transform transformPoint: from)].
					from = via 
						ifTrue: [out nextPut: (transform transformPoint: to).]
						ifFalse: [self 
									flattenBezier2From: (transform transformPoint: from)
									via: 	(transform transformPoint: via)
									to:  	(transform transformPoint: to) 
									tolerance:  tolerance do: [ :pt | out nextPut: pt].
								out skip: -1.
								out nextPut: (transform transformPoint: to).

							].
					lastPoint := to]
				ifFalse: [ | bezier3 |
					bezier3 := in next.
					bezier3 start = lastPoint 
						ifFalse: [out nextPut: (transform transformPoint: bezier3 start)].
			
					self flattenBezier3From: 	(transform transformPoint: bezier3 start)
						via: 	(transform transformPoint: bezier3 via1)
						and: 	(transform transformPoint: bezier3 via2)
						to:  	(transform transformPoint: bezier3 end) 
						tolerance:  tolerance do: [ :pt | out nextPut: pt].
					out skip: -1.
					out nextPut: (transform transformPoint: bezier3 end).
					lastPoint := bezier3 end.
				]
			].
		out contents]).
	
! !

!RomeBalloonPath methodsFor: 'private' stamp: 'bf 6/23/2006 15:53'!
flushSegment
	| segment |
	pathData isEmpty ifTrue: [^self].
	pathData last isStream ifFalse: [^self].
	segment := pathData last contents.
	(segment size < 2 and: [segment first isPoint])
		ifTrue: [pathData removeLast]
		ifFalse: [pathData at: pathData size put: segment].! !

!RomeBalloonPath methodsFor: 'initialize' stamp: 'cyrille.delaunay 5/5/2010 16:36'!
initialize
	super initialize.
	transform := IdentityTransform new.
	degree := 1.! !

!RomeBalloonPath methodsFor: 'creation' stamp: 'bf 6/8/2006 17:04'!
lineTo: aPoint
	firstPt ifNil: [self moveTo: 0@0].
	lastPt = aPoint ifFalse: [
		degree = 1
			ifTrue: [pathData last nextPut: aPoint]
			ifFalse: [pathData last
				nextPut: lastPt;
				nextPut: lastPt;
				nextPut: aPoint].
		lastPt := aPoint.
	]! !

!RomeBalloonPath methodsFor: 'creation' stamp: 'bf 6/8/2006 17:03'!
moveTo: aPoint
	"Move to aPoint"
	self flushSegment.
	pathData add: self newSegment.
	degree = 1 ifTrue: [pathData last nextPut: aPoint].
	firstPt := aPoint.
	lastPt := aPoint.
! !

!RomeBalloonPath methodsFor: 'private' stamp: 'bf 6/8/2006 15:18'!
newSegment
	^WriteStream on: (Array new: 12)! !

!RomeBalloonPath methodsFor: 'accessing' stamp: 'bf 7/19/2006 13:54'!
pathOn: aCanvas
	^self error: 'not yet implemented'.

	"see RomePath>>bezierShape: for a similar method, but this one needs to account for the current path degree"! !

!RomeBalloonPath methodsFor: 'private' stamp: 'bf 6/26/2006 13:40'!
segmentAsBezier: pointArray
	| bezier strm |
	bezier := Array new: (pointArray size - 1) * 3.
	strm := WriteStream on: bezier.
	1 to: pointArray size - 1 do: [:i |
		strm nextPut: (pointArray at: i); 
			nextPut: (pointArray at: i); 
			nextPut: (pointArray at: i + 1) 
	].
	^bezier! !

!RomeBalloonPath methodsFor: 'accessing' stamp: 'bf 6/6/2006 15:18'!
transform
	^transform! !

!RomeBalloonPath methodsFor: 'accessing' stamp: 'bf 6/6/2006 17:21'!
transformBy: tfm
	"Transform me by aTransform"
	transform := transform composedWithLocal: tfm.
! !

!RomeBalloonPath methodsFor: 'flattening' stamp: 'jl 7/12/2006 10:06'!
untransformedFlatten
	degree = 1 ifFalse: [self error: 'flatten sent to curved path'].
	self flushSegment.
	^pathData
! !

!RomePath methodsFor: 'accessing' stamp: 'ar 4/17/2005 19:36'!
bounds
	^bounds ifNil:[bounds := self computeBounds].! !

!RomePath methodsFor: 'creation' stamp: 'jl 7/12/2006 14:58'!
closePath
	"Close this path"
	firstPt ifNotNil: [
		pathData add: 4.
		pathData add: firstPt.
		closed := true].
	firstPt := nil.
! !

!RomePath methodsFor: 'accessing' stamp: 'ar 4/17/2005 14:32'!
closed
	"Answer whether this path is closed"
	^closed! !

!RomePath methodsFor: 'accessing' stamp: 'bf 5/9/2006 16:22'!
computeBounds
	| in op start end via1 via2 min max |
	min := max := nil.
	in := ReadStream on: pathData.
	[in atEnd] whileFalse:[
		op := in next.
		(op > 0 and:[op < 4]) ifFalse:[
			"moveTo, closePath" 
			start := in next.
		] ifTrue:[
			"lineTo, curveTo, curveToVia"
			min ifNil:[min := max := start].
			op = 1 ifTrue:[
				end := in next.
				min := min min: end. max := max max: end.
			].
			op = 2 ifTrue:[
				via1 := in next.
				end := in next.
				min := min min: end. max := max max: end.
				min := min min: via1. max := max max: via1.
			].
			op = 3 ifTrue:[
				via1 := in next.
				via2 := in next.
				end := in next.
				min := min min: end. max := max max: end.
				min := min min: via1. max := max max: via1.
				min := min min: via2. max := max max: via2.
			].
			start := end.
		].
	].
	^min corner: max! !

!RomePath methodsFor: 'accessing' stamp: 'bf 5/18/2006 11:51'!
currentPoint
	^firstPt
		ifNil: [nil]
		ifNotNil: [pathData last]! !

!RomePath methodsFor: 'creation' stamp: 'bf 5/18/2006 13:54'!
curveVia: cp1 and: cp2 to: aPoint
	firstPt ifNil: [self moveTo: 0@0].
	pathData last = aPoint ifFalse: [
		pathData add: 3.
		pathData add: cp1.
		pathData add: cp2.
		pathData add: aPoint.
	].
! !

!RomePath methodsFor: 'creation' stamp: 'bf 5/18/2006 13:54'!
curveVia: cp1 to: aPoint
	firstPt ifNil: [self moveTo: 0@0].
	pathData last = aPoint ifFalse: [
		pathData add: 2.
		pathData add: cp1.
		pathData add: aPoint.
	].
! !

!RomePath methodsFor: 'accessing' stamp: 'bf 6/6/2006 11:54'!
degree
	"answer 0, 1, 2, or 3 depending on the highest-order segment in this path"

	| degree in op |
	degree := 0.
	in := ReadStream on: pathData.
	[in atEnd] whileFalse:[
		op := in next.
		(op > 0 and: [op < 4]) ifTrue:[
			"lineto, curve2, curve3"
			op > degree ifTrue: [
				degree := op.
				degree = 3 ifTrue: [^degree]].
			in skip: op.
		] ifFalse: [
			"moveto, closepath"
			in skip: 1.
		]
	].
	^degree! !

!RomePath methodsFor: 'flattening' stamp: 'jl 7/14/2006 12:31'!
flatten: tolerance
	"Create a polyline for this path"
	| start in op end via1 via2 out poly |
	start := 0@0.
	in := ReadStream on: pathData.
	out := WriteStream on: Array new.
	poly := nil.
	[in atEnd] whileFalse:[
		op := in next.
		(op > 0 and:[op < 4]) ifTrue:[
			poly ifNil:[
				poly := WriteStream on: (Array new: 4). 
				poly nextPut: start.
			].
			op = 1 ifTrue:["lineTo"
				end := in next.
				poly nextPut: end.
			].
			op = 2 ifTrue:["bezier2"
				via1 := in next.
				end := in next.
				self flattenBezier2From: start via: via1 to: end tolerance: tolerance do:[:pt|
					poly nextPut: pt.
				].
			].
			op = 3 ifTrue:["bezier3"
				via1 := in next.
				via2 := in next.
				end := in next.
				self flattenBezier3From: start via: via1 and: via2 to: end tolerance: tolerance do:[:pt|
					poly nextPut: pt.
				].
			].
			start := end.
		] ifFalse:[
			start := in next.
			poly ifNotNil:[
				op = 4 ifTrue:[poly nextPut: start].
				out nextPut: poly contents.
				poly := nil.
			].
		].
	].
	poly ifNotNil:[out nextPut: poly contents].
	^self reorient: out contents! !

!RomePath methodsFor: 'flattening' stamp: 'bf 5/9/2006 17:32'!
flattenBezier2From: a via: b to: c tolerance: tolerance do: aBlock
	| dist ab bc mid |
	dist := self squaredDistanceOf: b toLineFrom: a to: c.
	dist <= tolerance ifTrue:[^aBlock value: c].
	"Recurse"
	ab := (a + b) * 0.5.
	bc := (b + c) * 0.5.
	mid := (ab + bc) * 0.5. 
	self flattenBezier2From: a via: ab to: mid tolerance: tolerance do: aBlock.
	self flattenBezier2From: mid via: bc to: c tolerance: tolerance do: aBlock.! !

!RomePath methodsFor: 'flattening' stamp: 'bf 5/9/2006 17:40'!
flattenBezier3From: a via: b and: c to: d tolerance: tolerance do: aBlock
	| dist1 dist2 ab bc cd abbc bccd  mid |
	"Check smoothness"
	dist1 := self squaredDistanceOf: b toLineFrom: a to: d.
	dist2 := self squaredDistanceOf: c toLineFrom: a to: d.
	(dist1 max: dist2) <= tolerance ifTrue:[^aBlock value: d].
	"Recurse"
	ab := (a + b) * 0.5.
	bc := (b + c) * 0.5.
	cd := (c + d) * 0.5.
	abbc := (ab + bc) * 0.5.
	bccd := (bc + cd) * 0.5.
	mid := (abbc + bccd) * 0.5.
	self flattenBezier3From: a via: ab and: abbc to: mid tolerance: tolerance do: aBlock.
	self flattenBezier3From: mid via: bccd and: cd to: d tolerance: tolerance do: aBlock.! !

!RomePath methodsFor: 'initialize' stamp: 'bf 7/14/2006 20:22'!
initialize
	firstPt := nil.
	pathData := OrderedCollection new.
	closed := false.! !

!RomePath methodsFor: 'testing' stamp: 'ar 4/17/2005 21:38'!
isEmpty
	^pathData isEmpty! !

!RomePath methodsFor: 'creation' stamp: 'bf 6/8/2006 16:34'!
lineBy: delta
	firstPt ifNil: [self moveTo: 0@0].
	^self lineTo: self currentPoint + delta
! !

!RomePath methodsFor: 'creation' stamp: 'bf 5/18/2006 13:53'!
lineTo: aPoint
	firstPt ifNil: [self moveTo: 0@0].
	pathData last = aPoint ifFalse: [
		pathData add: 1.
		pathData add: aPoint.
	]! !

!RomePath methodsFor: 'creation' stamp: 'ar 4/17/2005 21:38'!
moveTo: aPoint
	"Move to aPoint"
	pathData add: 0.
	pathData add: aPoint.
	firstPt := aPoint.! !

!RomePath methodsFor: 'accessing' stamp: 'jl 7/4/2006 16:54'!
pathOn: aCanvas
	"Put me on a canvas"
	| op in args |
	in := ReadStream on: pathData.
	[in atEnd] whileFalse: [
		op := in next.
		args := in next: (#(1 1 2 3 1) at: op+1). "arguments"
		(op < 4) ifTrue:[
			aCanvas
				perform: (#(moveTo: lineTo: curveVia:to: curveVia:and:to:) at: op+1)
				withArguments: args
		] ifFalse: [
			aCanvas closePath.
		].
	].
! !

!RomePath methodsFor: 'flattening' stamp: 'bf 7/14/2006 16:13'!
reorient: polyContours
	| outer |
	outer := RomePolygonClipper outerContourOf: polyContours.
	^(RomePolygonClipper signedAreaOf: outer) positive
		ifTrue: [polyContours]
		ifFalse: [polyContours collect: [:each | each reversed]]! !

!RomePath methodsFor: 'flattening' stamp: 'ar 4/17/2005 20:00'!
squaredDistanceOf: p toLineFrom: pt1 to: pt2
	"Answer the squared distance of p from the line connecting pt1 and pt2"
	| dx dy  pdx pdy u px py |
	dx := pt2 x - pt1 x.
	dy := pt2 y - pt1 y.
	pdx := p x - pt1 x.
	pdy := p y - pt1 y.
	(dx = 0 and:[dy = 0]) ifTrue:[
		^(pdx * pdx) + (pdy * pdy).
	].
	u := ((pdx * dx) + (pdy * dy)) asFloat / ((dx * dx) + (dy * dy)) asFloat.
	u <= 0.0 ifTrue:[^(pdx * pdx) + (pdy * pdy)].
	u >= 1.0 ifTrue:[
		pdx := p x - pt2 x.
		pdy := p y - pt2 y.
		^(pdx * pdx) + (pdy * pdy)
	].
	px := pt1 x + (u * dx).
	py := pt1 y + (u * dy).
	pdx := p x - px.
	pdy := p y - py.
	^(pdx * pdx) + (pdy * pdy)! !

!RomePath methodsFor: 'accessing' stamp: 'ar 4/17/2005 21:39'!
transformBy: tfm
	"Transform me by aTransform"
	| op in out |
	in := ReadStream on: pathData.
	out := WriteStream on: (Array new: pathData size).
	[in atEnd] whileFalse:[
		op := in next.
		out nextPut: op.
		"lineTo, curveTo, curveTo"
		(op > 0 and:[op < 4]) ifTrue:[
			1 to: op do:[:i| out nextPut: (tfm transformPoint: in next)].
		] ifFalse:[
			"moveTo, closePath" 
			out nextPut: (tfm transformPoint: in next)
		].
	].
	pathData := out contents.
	bounds := nil.! !

!RomePath methodsFor: 'accessing' stamp: 'ar 4/17/2005 19:11'!
transformedBy: aTransform
	^self copy transformBy: aTransform! !

Object subclass: #RomePen
	instanceVariableNames: 'width color'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Athens-Reference'!

!RomePen classSide methodsFor: 'instance creation' stamp: 'ar 4/17/2005 19:29'!
width: w color: aColor
	^self new width: w color: aColor! !

!RomePen methodsFor: 'accessing' stamp: 'ar 4/17/2005 20:06'!
color
	^color! !

!RomePen methodsFor: 'drawing' stamp: 'ar 4/17/2005 21:32'!
drawLineFrom: startPoint to: endPoint on: aCanvas
	^self subclassResponsibility! !

!RomePen methodsFor: 'drawing' stamp: 'ar 4/17/2005 21:31'!
drawPolyline: aCollection on: aCanvas
	"Bail to lines"
	| prevPt |
	prevPt := aCollection first.
	aCollection do:[:nextPt|
		nextPt = prevPt ifFalse:[self drawLineFrom: prevPt to: nextPt on: aCanvas].
		prevPt := nextPt.
	].! !

!RomePen methodsFor: 'accessing' stamp: 'bf 7/31/2006 17:01'!
expandBounds: aRectangle
	^aRectangle expandByRomePenWidth: width color: color! !

!RomePen methodsFor: 'accessing' stamp: 'ar 4/17/2005 22:51'!
fill
	^color! !

!RomePen methodsFor: 'drawing' stamp: 'ar 4/17/2005 21:28'!
frameOval: aRectangle on: aCanvas
	^self framePath: (aCanvas makePath:[aCanvas oval: aRectangle]) on: aCanvas! !

!RomePen methodsFor: 'drawing' stamp: 'ar 4/17/2005 21:29'!
framePath: aPath on: aCanvas
	"Bail to polygon"
	(aPath flatten: aCanvas deviceTolerance) do:[:poly|
		self framePolygon: poly on: aCanvas
	].! !

!RomePen methodsFor: 'drawing' stamp: 'ar 4/17/2005 21:30'!
framePolygon: aCollection on: aCanvas
	"Bail to lines"
	| prevPt |
	prevPt := aCollection last.
	aCollection do:[:nextPt|
		nextPt = prevPt ifFalse:[self drawLineFrom: prevPt to: nextPt on: aCanvas].
		prevPt := nextPt.
	].! !

!RomePen methodsFor: 'drawing' stamp: 'ar 4/17/2005 21:28'!
frameRectangle: aRectangle on: aCanvas
	"Bail to path"
	^self framePath: (aCanvas makePath:[aCanvas rectangle: aRectangle]) on: aCanvas! !

!RomePen methodsFor: 'drawing' stamp: 'ar 4/17/2005 21:28'!
frameRoundRect: aRectangle radius: radius corners: flags on: aCanvas
	"Bail to path"
	^self framePath: (aCanvas makePath:[
		aCanvas roundRect: aRectangle radius: radius corners: flags
	]) on: aCanvas! !

!RomePen methodsFor: 'testing' stamp: 'bf 6/8/2006 14:43'!
hasEffect
	^width > 0 and: [color isTransparent not]! !

!RomePen methodsFor: 'accessing' stamp: 'bf 7/31/2006 17:01'!
insetBounds: aRectangle
	^aRectangle insetByRomePenWidth: width color: color! !

!RomePen methodsFor: 'testing' stamp: 'ar 4/17/2005 21:39'!
isSolid
	^color isSolidFill! !

!RomePen methodsFor: 'printing' stamp: 'bf 6/23/2006 15:21'!
printOn: aStream
	aStream
		nextPutAll: self class name;
		nextPut: $(;
		print: width;
		space;
		print: color;
		nextPut: $)! !

!RomePen methodsFor: 'transforming' stamp: 'alain.plantec 7/16/2009 02:33'!
transformBy: aTransform
	width := (aTransform transformDirection: 0@width) r truncated. 
	color isColor ifFalse:[
		color := color transformedBy: aTransform.
	].! !

!RomePen methodsFor: 'transforming' stamp: 'ar 4/17/2005 19:38'!
transformedBy: aTransform
	"Transform me into device space"
	^self copy transformBy: aTransform! !

!RomePen methodsFor: 'accessing' stamp: 'ar 4/17/2005 20:06'!
width
	^width! !

!RomePen methodsFor: 'initialize' stamp: 'ar 4/17/2005 19:29'!
width: w color: aColor
	width := w.
	color := aColor.! !

Object subclass: #RomePolygonClipper
	instanceVariableNames: ''
	classVariableNames: 'Debug'
	poolDictionaries: ''
	category: 'Athens-Reference'!

!RomePolygonClipper commentStamp: '<historical>' prior: 0!
CPolygonClipper new halt
	intersect: 0@50 dir: 100@0
	with: 200@0 dir: 0@200.!

!RomePolygonClipper classSide methodsFor: 'instance creation' stamp: 'ar 4/18/2004 17:25'!
clip: polyPath against: clipPath
	^self new clip: polyPath against: clipPath! !

!RomePolygonClipper classSide methodsFor: 'accessing' stamp: 'ar 4/18/2004 15:36'!
debug
	^Debug! !

!RomePolygonClipper classSide methodsFor: 'accessing' stamp: 'ar 4/18/2004 15:36'!
debug: aBool
	Debug := aBool.! !

!RomePolygonClipper classSide methodsFor: 'class initialization' stamp: 'ar 4/19/2004 02:25'!
initialize
	"CPolygonClipper initialize"
	Debug := false.! !

!RomePolygonClipper classSide methodsFor: 'examples' stamp: 'bf 4/7/2006 15:44'!
makeStarPath: npts
	| pt ext oldR points pts |
	pt := 100 @ 100.
	ext := pt r.
	oldR := ext.
	points := npts.
	pts := (0 to: 360 by: 360 // points // 2)
				collect: [:angle | (Point r: (oldR := oldR = ext
									ifTrue: [ext * 5 // 12]
									ifFalse: [ext]) degrees: angle + pt degrees)
						+ (150 @ 150)].
	"Close path properly"
	pts at: 1 put: pts last.
	^pts! !

!RomePolygonClipper classSide methodsFor: 'utilities' stamp: 'bf 7/14/2006 16:12'!
outerContourOf: contourList
	| top |
	contourList size = 1 ifTrue: [^contourList first].
	^contourList detectMax: [:points | 
		top := points first y.
		2 to: points size do: [:i | 
			(points at: i) y > top ifTrue: [top := (points at: i) y]].
		top].! !

!RomePolygonClipper classSide methodsFor: 'examples' stamp: 'ar 4/17/2005 21:42'!
profileClipStar
	"RomePolygonClipper profileClipStar"
	| path1 path2 path3 clip |
	Debug := false.
	path1 := {50@50. 250@50. 250@250. 50@250. 50@50}.
	path2 := {150@0. 300@150. 150@300. 0@150. 150@0}.
	path3 := (RomePolygonClipper makeStarPath: 180) collect:[:each| each asIntegerPoint].

	clip := RomePolygonClipper clip: path1 against: path2.
	MessageTally spyOn:[
		1 to: 1000 do:[:i| RomePolygonClipper clip: path3 against: clip]]! !

!RomePolygonClipper classSide methodsFor: 'examples' stamp: 'ar 4/17/2005 21:43'!
profileClipStarInside
	"RomePolygonClipper profileClipStarInside"
	| path3 clip |
	Debug := false.
	clip := {0@0. 300@0. 300@300. 0@300. 0@0}.
	path3 := (RomePolygonClipper makeStarPath: 180) collect:[:each| each asIntegerPoint].
	MessageTally spyOn:[
		1 to: 1000 do:[:i| RomePolygonClipper clip: path3 against: clip]]
! !

!RomePolygonClipper classSide methodsFor: 'examples' stamp: 'ar 4/17/2005 21:42'!
profileClipStarOutside
	"RomePolygonClipper profileClipStarOutside"
	| path3 clip |
	Debug := false.
	clip := {0@0. 300@0. 300@300. 0@300. 0@0} collect:[:pt| pt + 300].
	path3 := (RomePolygonClipper makeStarPath: 180) collect:[:each| each asIntegerPoint].
	MessageTally spyOn:[
		1 to: 1000 do:[:i| RomePolygonClipper clip: path3 against: clip]]
! !

!RomePolygonClipper classSide methodsFor: 'utilities' stamp: 'bf 7/14/2006 15:38'!
signedAreaOf: points
	| area a b |
	area := 0.
	1 to: points size do: [:i |
		a := points at: i.
		b := points atWrap: i+1.
		area := area + (a x * b y) - (b x * a y).
	].
	^area / 2.0! !

!RomePolygonClipper classSide methodsFor: 'examples' stamp: 'ar 4/17/2005 21:43'!
testClipStar
	"RomePolygonClipper testClipStar"
	| path1 path2 path3 clip |
	Debug := true.
	path1 := {50@50. 250@50. 250@250. 50@250. 50@50}.
	path2 := {150@0. 300@150. 150@300. 0@150. 150@0}.
	path3 := (RomePolygonClipper makeStarPath: 180) collect:[:each| each asIntegerPoint].

	clip := RomePolygonClipper clip: path1 against: path2.
	RomePolygonClipper clip: path3 against: clip! !

!RomePolygonClipper classSide methodsFor: 'examples' stamp: 'ar 4/17/2005 21:42'!
testClipStarInside
	"RomePolygonClipper testClipStarInside"
	| path3 clip |
	Debug := true.
	clip := {0@0. 300@0. 300@300. 0@300. 0@0}.
	path3 := (RomePolygonClipper makeStarPath: 180) collect:[:each| each asIntegerPoint].
	RomePolygonClipper clip: path3 against: clip! !

!RomePolygonClipper classSide methodsFor: 'examples' stamp: 'ar 4/17/2005 21:42'!
testClipStarOutside
	"RomePolygonClipper testClipStarOutside"
	| path3 clip |
	Debug := true.
	clip := {0@0. 300@0. 300@300. 0@300. 0@0} collect:[:pt| pt + 300].
	path3 := (RomePolygonClipper makeStarPath: 180) collect:[:each| each asIntegerPoint].
	RomePolygonClipper clip: path3 against: clip! !

!RomePolygonClipper classSide methodsFor: 'examples' stamp: 'ar 4/17/2005 21:42'!
testClipStarPartwayOutside
	"RomePolygonClipper testClipStarPartwayOutside"
	| path3 clip |
	Debug := true.
	clip := {0@0. 300@0. 300@300. 0@300. 0@0} collect:[:pt| pt + 200].
	path3 := (RomePolygonClipper makeStarPath: 36) collect:[:each| each asIntegerPoint].
	^RomePolygonClipper clip: path3 against: clip! !

!RomePolygonClipper methodsFor: 'clipping' stamp: 'ar 4/20/2004 21:00'!
clip: polyPath against: clipPath
	| lastClip nextClip path |
	clipPath size < 3 ifTrue:[^#()].
	polyPath size < 3 ifTrue:[^#()].
	clipPath first = clipPath last ifFalse:[self error: 'Clippath not closed'].
	Debug ifTrue:[self debugDrawPath: Color black points: clipPath].
	Debug ifTrue:[self debugDrawPath: Color blue points: polyPath].
	path := polyPath.
	path first = path last ifFalse:[path := path copyWith: path first].
	nextClip := clipPath at: 1.
	2 to: clipPath size do:[:clipIndex|
		lastClip := nextClip.
		nextClip := clipPath at: clipIndex.
		path := self clip: path from: lastClip to: nextClip.
		path size < 3 ifTrue:[^#()].
	].
	Debug ifTrue:[self debugDrawPath: Color green points: path].
	^path! !

!RomePolygonClipper methodsFor: 'clipping' stamp: 'ar 4/18/2004 17:24'!
clip: path from: lastClip to: nextClip
	| lastClipX lastClipY clipX clipY index nextPt dx dy nextSide inside lastPt lastSide result pt lastInside |

	"Allocate result lazily - this is good for paths which are fully inside or outside of the clip edge since we won't ever allocate temporary storage for them."
	result := nil.

	"Cache lastClip's values"
	lastClipX := lastClip x.
	lastClipY := lastClip y.

	"Compute slope of the next clip segment"
	clipX := nextClip x - lastClipX.
	clipY := nextClip y - lastClipY.

	"Find first point which isn't on contour to determine inside/outside"
	index := 0.
	[nextPt := path at: (index := index + 1).
	dx := nextPt x - lastClipX.
	dy := nextPt y - lastClipY.
	"The cross product hands us either one of <0/0/>0 depending on the side"
	nextSide := (clipX * dy) - (dx * clipY).
	nextSide = 0] whileTrue:[
		"Check for degenerate case of all points being on the boundary of the clip edge"
		index = path size ifTrue:[^#()].
	].
	inside := nextSide > 0.
	inside ifTrue:[lastInside := index].

	"Now go over the path and see where we cross the boundaries"
	[index < path size] whileTrue:[
		lastPt := nextPt.
		lastSide := nextSide.

		"Compute location of nextPt relative to clip edge"
		nextPt := path at: (index := index + 1).
		dx := nextPt x - lastClipX.
		dy := nextPt y - lastClipY.

		"The cross product hands us either one of <0/0/>0 depending on the side"
		nextSide := (clipX * dy) - (dx * clipY).

		"If we run on the clip edge keep the last side for reference"
		nextSide = 0 ifTrue:[nextSide := lastSide].

		(nextSide sign * lastSide sign < 0) ifTrue:[
			"We're crossing the clip edge -- compute the intersection point"
			dx := nextPt x - lastPt x.
			dy := nextPt y - lastPt y.
			pt := self intersect: lastClip dir: clipX@clipY with: lastPt dir: dx@dy.
			result ifNil:[result := WriteStream on: (Array new: 4)].
			inside ifTrue:[
				"We're leaving the clip path - copy result into output"
				result nextPutAll: (path copyFrom: lastInside to: index-1).

				"Note: To avoid duplicates in the out path we only remember
				the intersection point if it doesn't coincide with the start point
				of the leaving edge (which is a visible end-point so we have
				recorded it above)"
				(pt x = lastPt x and:[pt y = lastPt y])
					ifFalse:[result nextPut: pt].
			] ifFalse:[
				"We're entering the clip path"
				result nextPut: pt.
			].
			Debug ifTrue:[self debugDrawPoint: Color red at: pt].
			inside := inside not.
			inside ifTrue:[lastInside := index].
		].
	].
	inside ifTrue:[
		result ifNil:[^path].
		"Copy remainder of visible points"
		result nextPutAll: (path copyFrom: lastInside to: index).
	] ifFalse:[
		result ifNil:[^#()].
		"Close path again if needed"
		result position > 0 ifTrue:[result nextPut: result originalContents first].
	].
	^result contents! !

!RomePolygonClipper methodsFor: 'debug' stamp: 'ar 4/18/2004 04:14'!
debugDrawLine: aColor from: start to: stop
	Display getCanvas line: start*2 to: stop*2 width: 2 color: aColor.
	(Delay forMilliseconds: 50) wait.! !

!RomePolygonClipper methodsFor: 'debug' stamp: 'jl 7/12/2006 16:38'!
debugDrawPath: aColor points: ptList
	| lastPt nextPt |
	lastPt := ptList first // 64.
	Display getCanvas fillRectangle: (lastPt*2-2 extent: 4@4) color: aColor.
	2 to: ptList size do:[:i|
		nextPt := (ptList at: i) // 64.
		Display getCanvas fillRectangle: (nextPt*2-2 extent: 4@4) color: aColor.
		Display getCanvas line: lastPt*2 to: nextPt*2 width: 2 color: aColor.
		lastPt := nextPt.
	].
	(Delay forMilliseconds: 200) wait.
! !

!RomePolygonClipper methodsFor: 'debug' stamp: 'ar 4/18/2004 04:23'!
debugDrawPoint: aColor at: pt
	Display getCanvas fillRectangle: (pt*2-2 extent: 5@5) color: aColor.
	(Delay forMilliseconds: 50) wait.! !

!RomePolygonClipper methodsFor: 'clipping' stamp: 'bf 4/7/2006 15:44'!
intersect: pt1 dir: dir1 with: pt2 dir: dir2
	"Compute the intersection of the line starting at pt1 with the line starting at pt2"
	| det alpha deltaX deltaY |
	det := (dir1 x * dir2 y) - (dir1 y * dir2 x).
	deltaX := pt2 x - pt1 x.
	deltaY := pt2 y - pt1 y.
	alpha := (deltaX * dir2 y) - (deltaY * dir2 x).
	"And compute intersection"
	^(pt1 x + (alpha * dir1 x // det)) @ (pt1 y + (alpha * dir1 y // det))
! !

!ColorForm methodsFor: '*Athens-PluginCanvas' stamp: 'be 7/31/2006 10:30'!
romePluginSourceFormDepth
	^32! !
RomePluginCanvas initialize!
RomePolygonClipper initialize!
